package edu.mit.is.okapi.servlets;



import javax.servlet.*;
import javax.servlet.http.*;

import java.io.*;


/*
<p>
   Copyright (c) 2002 Massachusetts Institute of Technology
<p>
   Permission is hereby granted, free of charge, to any
   person obtaining a copy of this software and associated
   documentation files (the "Software"), to deal in the
   Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish,
   distribute, sublicense, and/or sell copies of the
   Software, and to permit persons to whom the Software is
   furnished to do so, subject to the following conditions:
<p>
   The above copyright notice and this permission notice
   shall be included in all copies or substantial portions of
   the Software.
<p>
   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY
   KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
   WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
   PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
   DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
   CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
   IN THE SOFTWARE.
<p>
$Source: /cvs/oki/tech/contrib/mit/apps/examples/service/authentication/x509/src/edu/mit/is/okapi/servlets/OkiTestServlet.java,v $
@version@ $Revision: 1.1 $
$Date: 2002/04/26 22:20:17 $

*****************************************************************************
*
*  Sample pseudo-application demonstrating Authentication API
*     03/06/2002
*
****************************************************************************
*/

/**
 * Class OkiTestServlet
 *
 *
 * @author $author$
 * @version $Revision: 1.1 $ / $Date: 2002/04/26 22:20:17 $
 */
public class OkiTestServlet
extends HttpServlet {

  /**Process the HTTP Get request*/
  public void doGet(HttpServletRequest request, HttpServletResponse response)
  throws ServletException, IOException {

    javax.servlet.http.HttpSession    session  = request.getSession();

    boolean                           isSecure = (request.getServerPort()
                                                   == 443);

    org.okip.service.shared.api.Agent agent    =
      (org.okip.service.shared.api.Agent) session.getAttribute("agent");

    if (agent != null) {
      PrintWriter out = response.getWriter();

      response.setContentType("text/html");
      out.println("<html><head><title>OKI auth servlet: x509</title></head>");
      out.println("<body>");
      out.println("<h1>OKI auth servlet: x509</h1>");
      out.println("<h1>Hey, I know you, you're " + agent.getName());
      out.println("</h1>");

      try {
        org.okip.service.authentication.api.Factory myFactory =
          (org.okip.service.authentication.api.Factory) org.okip.service.shared.api.FactoryManager.getFactory(
            "org.okip.service.authentication.api",
            "edu.mit.is.service.authentication.impl.x509", null);

        out.println("<p>You were authenticated using:");
        out.println("<ul>");

        /*
         * Get an authentication types
         */

        org.okip.service.shared.api.Type[] types = myFactory.getAuthenTypes();

        if (null != types) {
          for (int i = 0; types.length != i; i++) {
            out.println("<li>" + types[i]);
            System.err.println(types[i]);
          }
        }
      }
      catch (Exception e) {
        out.println(e.getMessage());
        e.printStackTrace(out);
      }

      out.println("</ul></p>");
      out.println("</body></html>");
    }
    else {
      if (isSecure) {

        /*
          LOGIN BY CERTIFICATE AUTHENTICATION
        */
        PrintWriter out = response.getWriter();

        response.setContentType("text/html");
        out.println(
          "<html><head><title>OKI auth servlet: x509</title></head>");
        out.println("<body>");
        out.println("<h1>OKI auth servlet: x509</h1>");
        out.println("<pre>");

        try {
          edu.mit.is.service.authentication.impl.x509.ThreadContext.setProperty(
            "response", response);
          edu.mit.is.service.authentication.impl.x509.ThreadContext.setProperty(
            "request", request);

          /*
           * Get the MIT implementation of the Authen API
           */
          org.okip.service.authentication.api.Factory myFactory =
            (org.okip.service.authentication.api.Factory) org.okip.service.shared.api.FactoryManager.getFactory(
              "org.okip.service.authentication.api",
              "edu.mit.is.service.authentication.impl.x509", null);

          /*
           * Get an authentication types
           */
          out.println("Authen types:");

          org.okip.service.shared.api.Type[] types =
            myFactory.getAuthenTypes();

          if (null != types) {
            for (int i = 0; types.length != i; i++) {
              out.println(types[i]);
              System.err.println(types[i]);
            }
          }

          out.println("end of Authen types");

          /*
           * Get an authenticated user
           */
          out.println("Authenticated user:");

          org.okip.service.shared.api.Agent user = myFactory.getAgent();

          out.println("user.getName():" + user.getName());
          out.println("user object:" + user);

          out.println("end of Authenticated user");
          out.println("<hr>");

          if (null != user) {
            org.okip.service.shared.api.Type kerberos  = null;
            org.okip.service.shared.api.Type kerberos4 =
              new edu.mit.is.service.authentication.impl.authenkrb4.Krb4Type();

            /*
             * Get an authentication types for authenticated user
             */
            out.println("Authen types for Authenticated user:");

            types = myFactory.getAuthenTypes(user);

            if (null != types) {
              for (int i = 0; types.length != i; i++) {
                if (((org.okip.service.shared.api.Type) types[i]).equals(
                        kerberos4)) {
                  kerberos = kerberos4;
                }

                out.println(types[i]);
              }
            }

            out.println("end of Authen types for Authenticated user");
            out.println("<hr>");

            /*
             * Destroy all authentication for authenticated user
             */
            out.println("Destroy all authentication for Authenticated user:");
            myFactory.destroyAuthen(user);

            types = myFactory.getAuthenTypes(user);

            if (null != types) {
              for (int i = 0; types.length != i; i++) {
                out.println(types[i]);
              }
            }

            out.println(
              "end of Destroy all authentication for Authenticated user");
            out.println("<hr>");

            /*
             * Get an authenticated user with a specific authentication type
             */
            out.println(
              "Get an Authenticated user with authentication type of KERBEROS4:");

            try {
              user = myFactory.getAgent(user, kerberos);

              out.println("user.getName():" + user.getName());
              out.println(user);

              types = myFactory.getAuthenTypes(user);

              if (null != types) {
                for (int i = 0; types.length != i; i++) {
                  out.println(types[i]);
                }
              }
            }
            catch (Exception e) {
              out.println("Exception: " + e);
            }

            out.println(
              "end of Get an Authenticated user with authentication type of KERBEROS4");

            if (null != user) {

              /*
               * Destroy authentication of type KERBEROS4 for authenticated user
               */
              out.println(
                "Destroy authentication of type KERBEROS4 for Authenticated user:");

              try {
                myFactory.destroyAuthen(user, kerberos);

                types = myFactory.getAuthenTypes(user);

                if (null != types) {
                  for (int i = 0; types.length != i; i++) {
                    out.println(types[i]);
                  }
                }
              }
              catch (Exception e) {
                out.println("Exception: " + e);
              }

              out.println(
                "end of Destroy authentication of type KERBEROS4 for Authenticated user");

              /*
               * Get another authenticated user with a specific authentication type
               */
              out.println(
                "Get another Authenticated user with authentication type of KERBEROS4:");

              try {
                user = myFactory.getAgent(user, kerberos);

                out.println("user.getName():" + user.getName());
                out.println(user);

                types = myFactory.getAuthenTypes(user);

                if (null != types) {
                  for (int i = 0; types.length != i; i++) {
                    out.println(types[i]);
                  }
                }
              }
              catch (Exception e) {
                out.println("Exception: " + e);
              }

              out.println(
                "end of Get another Authenticated user with authentication type of KERBEROS4");

              if (null != user) {

                /*
                 * Destroy authentication array of types for authenticated user
                 */
                out.println(
                  "Destroy authentication array of types for Authenticated user:");

                try {
                  types = myFactory.getAuthenTypes(user);

                  myFactory.destroyAuthen(user, types);

                  types = null;
                }
                catch (Exception e) {
                  out.println("Exception: " + e);
                }

                out.println(
                  "end of Destroy authentication array of types for Authenticated user");
              }
            }

            out.println("<hr>");

            /*
             * Get an authenticated user with a specific authentication type
             */
            out.println(
              "Get an Authenticated user with authentication type of X509:");

            try {
              org.okip.service.shared.api.Type x509 =
                new edu.mit.is.service.authentication.impl.x509.X509Type();

              user = myFactory.getAgent(user, x509);

              out.println("user.getName():" + user.getName());
              out.println(user);

              types = myFactory.getAuthenTypes(user);

              if (null != types) {
                for (int i = 0; types.length != i; i++) {
                  out.println(types[i]);
                }
              }
            }
            catch (Exception e) {
              out.println("Exception: " + e);
            }

            out.println(
              "end of Get an Authenticated user with authentication type of X509");

            if (null != user) {

              /*
               * Destroy authentication of type X509 for authenticated user
               */
              out.println(
                "Destroy authentication of type X509 for Authenticated user:");

              try {
                org.okip.service.shared.api.Type x509 =
                  new edu.mit.is.service.authentication.impl.x509.X509Type();

                myFactory.destroyAuthen(user, x509);

                types = myFactory.getAuthenTypes(user);

                if (null != types) {
                  for (int i = 0; types.length != i; i++) {
                    out.println(types[i]);
                  }
                }
              }
              catch (Exception e) {
                out.println("Exception: " + e);
              }

              out.println(
                "end of Destroy authentication of type X509 for Authenticated user");

              /*
               * Get another authenticated user with a specific authentication type
               */
              out.println(
                "Get another Authenticated user with authentication type of X509:");

              try {
                org.okip.service.shared.api.Type x509 =
                  new edu.mit.is.service.authentication.impl.x509.X509Type();

                user = myFactory.getAgent(user, x509);

                out.println("user.getName():" + user.getName());
                out.println(user);

                types = myFactory.getAuthenTypes(user);

                if (null != types) {
                  for (int i = 0; types.length != i; i++) {
                    out.println(types[i]);
                  }
                }
              }
              catch (Exception e) {
                out.println("Exception: " + e);
              }

              out.println(
                "end of Get an Authenticated user with authentication type of X509");

              if (null != user) {

                /*
                 * Destroy authentication array of types for authenticated user
                 */
                out.println(
                  "Destroy authentication array of types for Authenticated user:");

                try {
                  types = myFactory.getAuthenTypes(user);

                  myFactory.destroyAuthen(user, types);

                  types = null;
                }
                catch (Exception e) {
                  out.println("Exception: " + e);
                }

                out.println(
                  "end of Destroy authentication array of types for Authenticated user");
              }
            }

            user = myFactory.getAgent();

            session.setAttribute("agent", user);
          }
        }
        catch (Throwable exx) {
          out.println(exx.getMessage());
          exx.printStackTrace();
        }

        out.println("</pre></body></html>");
      }
      else {
        response.sendRedirect("https://" + request.getServerName()
                              + request.getRequestURI() + "?"
                              + request.getQueryString());
      }
    }
  }

  /**Process the HTTP Post request with username/password */
  public void doPost(HttpServletRequest request, HttpServletResponse response)
  throws ServletException, IOException {
    doGet(request, response);
  }

  /**Clean up resources*/
  public void destroy() {}
}

