/*
  
     a CVS like version that syncs what it can, complains about problems
     (giving you some info about the conflict) and leaves it up to you to decide
     how to handle (e.g, delete your version / re-merge your changes, etc).
     This should always show you what it might do first, then go and do it...

     We're going to need a list (dotfile) in the sync directory that
     lists what actually is requested to sync... would be nice if we could
     say what NOT to sync.  (Would be nice if could do by extension or
     mime-type or something...)

     Should we handle re-names?  That could get tricky...

    I propose using a URL like format for
     identifing OKI cabinet repository sources...
     e.g.: file:// for local file systen, maybe oki:// for an oki repository?

*/

import java.util.*;

import org.okip.service.filing.api.*;

public class CabSync
{
    private static boolean A_DO_GUI = false;
    private static boolean A_TAKE_ACTION = true;
    private static boolean A_VERBOSE = true;
    private static boolean A_DEBUG = true;

    public static void main(String args[])
    {
        for (int i = 0; i < args.length; i++) {
            String a = args[i];
            if (a.equals("-gui"))
                A_DO_GUI = true;
            else if (a.equals("-n"))
                A_TAKE_ACTION = false;
            else if (a.equals("-v"))
                A_VERBOSE = !A_VERBOSE;
            else if (a.equals("-debug"))
                A_DEBUG = !A_DEBUG;
        }
        
        if (A_DO_GUI) {
            outln("spawning gui");
            /*
              SyncViewer sv = new SyncViewer(cabinet? SyncList?
            */
        }

        Cabinet cabinet0 = CabUtil.getCabinetFromDirectory("./c/l");       //local
        Cabinet cabinet1 = CabUtil.getCabinetFromDirectory("./c/r");       //remote
        CabUtil.printCabinet(cabinet0);
        CabUtil.printCabinet(cabinet1);

        outln("Syncing local " + cabinet0 + " with remote " + cabinet1);
        SyncList syncList = new SyncList(cabinet0, cabinet1);
        syncList.computeListStatus();        
        syncList.doSynchronize(A_TAKE_ACTION, A_VERBOSE, A_DEBUG);
        
        System.exit(0);
    }

        // do we even need the local/remote distiction?
        // isn't this just a priority code for conlict resolution?
        // well, the "local" cab will also contain CONFIG information
        // that WILL NOT exist in the remote cab about what we really
        // want to sync with in the remote cab.
        
        // ACTUALLY, we are going to need config info in the remote
        // directory also... If we run a sync based from THERE, it
        // won't actually know that remote files with more recent
        // mod-times may have been sourced from the local directory!

        // look at both resource lists, update all status information
        // (who's changed where) and create a todo list.


        // actually, we want to go thru the LOCAL list first,
        // then see whats up in the remote list.  Cause the local
        // list will also ultimately tell us abou stuff we don't
        // care about at all via a CVS/Entries like file.



    
    private static void outln(String s) { System.out.println("CabSync: " + s); }


}
