public class CShapeTreeCellRenderer extends javax.swing.JPanel 
implements javax.swing.tree.TreeCellRenderer
{
    java.awt.Color backColor;
    boolean isLeaf;
    private java.awt.image.BufferedImage bimg;
    int geometricShape = CShape.DEFAULT_SHAPE;
    int fillColor = CShape.DEFAULT_COLOR;
    int edgeThickness = CShape.DEFAULT_EDGE;
    String id = "0";
    CShape currentShape = null;

    public CShapeTreeCellRenderer()
    {
        setSize(new java.awt.Dimension(300,300));
    }
    
    public void init() 
    {
        setBackground(java.awt.Color.white);  
    }

    public java.awt.Graphics2D createGraphics2D(int w, int h) {
        java.awt.Graphics2D g2 = null;
        if (bimg == null || bimg.getWidth() != w || bimg.getHeight() != h) {
            bimg = (java.awt.image.BufferedImage) createImage(w, h);
        } 
        g2 = bimg.createGraphics();
        g2.setBackground(getBackground());
        g2.clearRect(0, 0, w, h);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING,
                            java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        return g2;
    }

    public void paint(java.awt.Graphics g) 
    {
        java.awt.Dimension d = getSize();
        java.awt.Graphics2D g2 = createGraphics2D(d.width, d.height);
        currentShape.draw(g2,5.0f,5.0f,40.0f,40.0f);
        g2.dispose();
        g.drawImage(bimg, 0, 0, this);
    }
    
    public java.awt.Component getTreeCellRendererComponent(javax.swing.JTree tree, Object value, boolean selected,
        boolean expanded, boolean leaf, int row, boolean hasFocus)
    {
        javax.swing.tree.DefaultMutableTreeNode currentNode = (javax.swing.tree.DefaultMutableTreeNode)value;
        currentShape = (CShape)currentNode.getUserObject();
        geometricShape = currentShape.getShape();
        fillColor = currentShape.getColor();
        edgeThickness = currentShape.getEdge();
        id = currentShape.getIdString();
        
        if (selected)
        {
            setBackground(java.awt.Color.gray);
        }
        else
        {
            setBackground(java.awt.Color.white);
        }
        isLeaf = leaf;
        return this;
    }
    
    public String getToolTipText()
    {
        if (isLeaf) 
        {
            return "Leaf";
        }
        return "Node";
    }
    
    public java.awt.Dimension getPreferredSize()
    {
        java.awt.Dimension dim = super.getPreferredSize();
        if (dim != null)
        {
            dim = new java.awt.Dimension(dim.width + 100, dim.height);
        }
        return dim;
    }
    
    public void processComponentKeyEvent(java.awt.event.KeyEvent ke)
    {
        System.out.println("key event in demo shape component");
    }
}
