public class ColorPropertyEditorRenderer extends javax.swing.JPanel implements javax.swing.ListCellRenderer
{
    private int selectionIndex = 0;
    private boolean isElementSelected = false;
    private java.awt.image.BufferedImage bimg;
    private int shape = DemoShape.DEFAULT_SHAPE;
    private int edge = DemoShape.DEFAULT_EDGE;
      
    public ColorPropertyEditorRenderer()
    {
        setBackground(java.awt.Color.white);
    }
    
    public java.awt.Component getListCellRendererComponent(
    javax.swing.JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
    {
        selectionIndex = index;
        isElementSelected = isSelected;
        if (isSelected) setBackground(java.awt.Color.gray);

        return this;
    }
    
    public void drawColor(int w, int h, java.awt.Graphics2D g2) 
    {
        DemoShape demoShape = new DemoShape();
        if (isElementSelected) 
        {
            setBackground(java.awt.Color.gray);
        }
        else
        {
            setBackground(java.awt.Color.white);
        }
        demoShape.Draw(g2,shape,selectionIndex,edge,120.0f,5.0f,40.0f,40.0f);        
        setBackground(java.awt.Color.white);
    }

    public java.awt.Graphics2D createGraphics2D(int w, int h) {
        java.awt.Graphics2D g2 = null;
        if (bimg == null || bimg.getWidth() != w || bimg.getHeight() != h) {
            bimg = (java.awt.image.BufferedImage) createImage(w, h);
        } 
        g2 = bimg.createGraphics();
        g2.setBackground(getBackground());
        g2.clearRect(0, 0, w, h);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING,
                            java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        return g2;
    }

    public void paint(java.awt.Graphics g) 
    {
        java.awt.Dimension d = getSize();
        java.awt.Graphics2D g2 = createGraphics2D(d.width, d.height);
        drawColor(d.width, d.height, g2);
        g2.dispose();
        g.drawImage(bimg, 0, 0, this);
    }
    
    public void setShape (int index)
    {
        shape = index;
    }
    
    public void setEdge (int index)
    {
        edge = index;
    }
}
    
    
    