public class HierarchyStore
{
    private javax.swing.tree.DefaultTreeModel shapeHierarchy = null;
    private javax.swing.tree.DefaultTreeModel colorHierarchy = null;
    private javax.swing.tree.DefaultTreeModel edgeHierarchy = null;
    private CShape cshape1 = new CShape("1",CShape.CIRCLE,CShape.BLUE,CShape.THIN_EDGE);
    private CShape cshape2 = new CShape("2",CShape.CIRCLE,CShape.CYAN,CShape.THIN_EDGE);
    private CShape cshape3 = new CShape("3",CShape.CIRCLE,CShape.GREEN,CShape.THIN_EDGE);
    private CShape cshape4 = new CShape("4",CShape.CIRCLE,CShape.BLUE,CShape.THIN_EDGE);
    private CShape cshape5 = new CShape("5",CShape.CIRCLE,CShape.CYAN,CShape.THICK_EDGE);
    private CShape cshape6 = new CShape("6",CShape.CIRCLE,CShape.GREEN,CShape.THICK_EDGE);
    private CShape cshape7 = new CShape("7",CShape.CIRCLE,CShape.CYAN,CShape.THICK_EDGE);
    private CShape[] cshapes = {cshape1,cshape2,cshape3,cshape4,cshape5,cshape6,cshape7};
            
    public HierarchyStore()
    {
        initShapeHierarchy();
        initColorHierarchy();
        initEdgeHierarchy();
    }
    
    private void initShapeHierarchy()
    {
        javax.swing.tree.DefaultMutableTreeNode shapeRoot = new javax.swing.tree.DefaultMutableTreeNode();
        CShape cshape = new CShape();
        cshape.setIdString("-1");
        shapeRoot.setUserObject(cshape);
        shapeHierarchy = new javax.swing.tree.DefaultTreeModel(shapeRoot); 

        javax.swing.tree.DefaultMutableTreeNode cshape1Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape2Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape3Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape4Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape5Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape6Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape7Node = new javax.swing.tree.DefaultMutableTreeNode();
        
        cshape1Node.setUserObject(cshape1);
        cshape2Node.setUserObject(cshape2);
        cshape3Node.setUserObject(cshape3);
        cshape4Node.setUserObject(cshape4);
        cshape5Node.setUserObject(cshape5);
        cshape6Node.setUserObject(cshape6);
        cshape7Node.setUserObject(cshape7);

/*       	Shape
                1
                    2
                        4
                        5
                    3
                        6
                        7
*/
        shapeHierarchy.insertNodeInto(cshape1Node,shapeRoot,0);
        shapeHierarchy.insertNodeInto(cshape7Node,cshape3Node,0);
        shapeHierarchy.insertNodeInto(cshape6Node,cshape3Node,0);
        shapeHierarchy.insertNodeInto(cshape3Node,cshape1Node,0);
        shapeHierarchy.insertNodeInto(cshape5Node,cshape2Node,0);
        shapeHierarchy.insertNodeInto(cshape4Node,cshape2Node,0);
        shapeHierarchy.insertNodeInto(cshape2Node,cshape1Node,0);                
    }
    
    private void initColorHierarchy()
    {
        javax.swing.tree.DefaultMutableTreeNode colorRoot = new javax.swing.tree.DefaultMutableTreeNode();
        CShape cshape = new CShape();
        cshape.setIdString("-1");
        colorRoot.setUserObject(cshape);
        colorHierarchy = new javax.swing.tree.DefaultTreeModel(colorRoot); 

        javax.swing.tree.DefaultMutableTreeNode cshape1Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape2Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape3Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape4Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape5Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape6Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape7Node = new javax.swing.tree.DefaultMutableTreeNode();
        
        cshape1Node.setUserObject(cshape1);
        cshape2Node.setUserObject(cshape2);
        cshape3Node.setUserObject(cshape3);
        cshape4Node.setUserObject(cshape4);
        cshape5Node.setUserObject(cshape5);
        cshape6Node.setUserObject(cshape6);
        cshape7Node.setUserObject(cshape7);

/*       	Color
                1
                    4
                2
                    5
                        7
                3
                    6
*/
        colorHierarchy.insertNodeInto(cshape3Node,colorRoot,0);
        colorHierarchy.insertNodeInto(cshape6Node,cshape3Node,0);
        colorHierarchy.insertNodeInto(cshape2Node,colorRoot,0);
        colorHierarchy.insertNodeInto(cshape5Node,cshape2Node,0);
        colorHierarchy.insertNodeInto(cshape7Node,cshape5Node,0);
        colorHierarchy.insertNodeInto(cshape1Node,colorRoot,0);
        colorHierarchy.insertNodeInto(cshape4Node,cshape1Node,0);
    }
    
    private void initEdgeHierarchy()
    {
        javax.swing.tree.DefaultMutableTreeNode edgeRoot = new javax.swing.tree.DefaultMutableTreeNode();
        CShape cshape = new CShape();
        cshape.setIdString("-1");
        edgeRoot.setUserObject(cshape);
        edgeHierarchy = new javax.swing.tree.DefaultTreeModel(edgeRoot); 
        
        javax.swing.tree.DefaultMutableTreeNode cshape1Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape2Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape3Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape4Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape5Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape6Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape7Node = new javax.swing.tree.DefaultMutableTreeNode();
        
        cshape1Node.setUserObject(cshape1);
        cshape2Node.setUserObject(cshape2);
        cshape3Node.setUserObject(cshape3);
        cshape4Node.setUserObject(cshape4);
        cshape5Node.setUserObject(cshape5);
        cshape6Node.setUserObject(cshape6);
        cshape7Node.setUserObject(cshape7);

/*       	Edge
                1
                    2
                        3
                        4
                5
                    6
                        7
*/
        edgeHierarchy.insertNodeInto(cshape7Node,cshape6Node,0);
        edgeHierarchy.insertNodeInto(cshape6Node,cshape5Node,0);
        edgeHierarchy.insertNodeInto(cshape5Node,edgeRoot,0);
        edgeHierarchy.insertNodeInto(cshape4Node,cshape2Node,0);
        edgeHierarchy.insertNodeInto(cshape1Node,edgeRoot,0);
        edgeHierarchy.insertNodeInto(cshape3Node,cshape2Node,0);
        edgeHierarchy.insertNodeInto(cshape2Node,cshape1Node,0);
    }
    
    public CShape getNode(int index)
    {
        return cshapes[index];
    }
    
    public CShape[] getNodes()
    {
        return cshapes;
    }
    
    public javax.swing.tree.DefaultTreeModel getShapeHierarchy()
    {
        return shapeHierarchy;
    }

    public javax.swing.tree.DefaultTreeModel getColorHierarchy()
    {
        return colorHierarchy;
    }

    public javax.swing.tree.DefaultTreeModel getEdgeHierarchy()
    {
        return edgeHierarchy;
    }
}
    