public class NodeRenderer extends javax.swing.JPanel implements javax.swing.ListCellRenderer
{
    private int selectionIndex = 0;
    private boolean isElementSelected = false;
    private java.awt.image.BufferedImage bimg;
    private CShape cshape = null;
      
    public NodeRenderer()
    {
        setBackground(java.awt.Color.white);
    }
    
    public java.awt.Component getListCellRendererComponent(
    javax.swing.JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
    {
        cshape = (CShape)value;
        selectionIndex = index;
        isElementSelected = isSelected;
        if (isSelected) setBackground(java.awt.Color.gray);

        return this;
    }
    
    public void draw(int w, int h, java.awt.Graphics2D g2) 
    {
        if (isElementSelected) 
        {
            setBackground(java.awt.Color.gray);
        }
        else
        {
            setBackground(java.awt.Color.white);
        }
        cshape.draw(g2,180.0f,5.0f,40.0f,40.0f);        
        setBackground(java.awt.Color.white);
    }

    public java.awt.Graphics2D createGraphics2D(int w, int h) {
        java.awt.Graphics2D g2 = null;
        if (bimg == null || bimg.getWidth() != w || bimg.getHeight() != h) {
            bimg = (java.awt.image.BufferedImage) createImage(w, h);
        } 
        g2 = bimg.createGraphics();
        g2.setBackground(getBackground());
        g2.clearRect(0, 0, w, h);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING,
                            java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        return g2;
    }

    public void paint(java.awt.Graphics g) 
    {
        java.awt.Dimension d = getSize();
        java.awt.Graphics2D g2 = createGraphics2D(d.width, d.height);
        draw(d.width, d.height, g2);
        g2.dispose();
        g.drawImage(bimg, 0, 0, this);
    }
}
    
    
    