public class CShape extends java.awt.Component
{
    private java.awt.image.BufferedImage bimg;
    
    private String key = (new Key()).getKeyAsString();
    private static java.awt.Font keyFont = null;
    private String id = "0";
    private static java.awt.Font idFont = null;
    private String description = "";
    private static java.awt.Font descriptionFont = null;
    private static boolean showId = true;
    public static boolean showNodeDescription = true;
    private static boolean showKey = true;
    private static boolean showPropertyDescription = true;
    private static boolean showObjectProperties = true;
    
    private static final String BUILDER_NEW_OBJECT = "-2";
    private static final String DO_NOT_DRAW = "-1";
    private static final String NO_TEXT = "0";

    //could move some of this to a local-dependent resource file

    public static final int CIRCLE = 0;
    public static final int SQUARE = 1;
    public static final int TRIANGLE = 2;
    public static final int DIAMOND = 3;
    public static final int PARRALLELOGRAM = 4;
    public static final int PENTAGON = 5;
    public static final int INVERTED_TRIANGLE = 6;
    public static final int TRAPEZOID = 7;
    
    public static final int THIN_EDGE = 0;
    public static final float THIN_EDGE_VALUE = 2.0f;
    public static final int THICK_EDGE = 1;
    public static final float THICK_EDGE_VALUE = 8.0f;
    
    public static final int BLUE = 0;
    public static final java.awt.Color BLUE_VALUE = java.awt.Color.blue;
    public static final int CYAN = 1;
    public static final java.awt.Color CYAN_VALUE = java.awt.Color.cyan;
    public static final int GREEN = 2;
    public static final java.awt.Color GREEN_VALUE = java.awt.Color.green;
    public static final int MAGENTA = 3;
    public static final java.awt.Color MAGENTA_VALUE = java.awt.Color.magenta;
    public static final int ORANGE = 4;
    public static final java.awt.Color ORANGE_VALUE = java.awt.Color.orange;
    public static final int PINK = 5;
    public static final java.awt.Color PINK_VALUE = java.awt.Color.pink;
    public static final int RED = 6;
    public static final java.awt.Color RED_VALUE = java.awt.Color.red;
    
    public static int DEFAULT_SHAPE = CIRCLE;
    public static int DEFAULT_COLOR = BLUE;
    public static int DEFAULT_EDGE = THIN_EDGE;
    
    public static String CIRCLE_STRING = "Circle";
    public static String SQUARE_STRING = "Square";
    public static String TRIANGLE_STRING = "Triangle";
    public static String DIAMOND_STRING = "Diamond";
    public static String PARRALLELOGRAM_STRING = "Parrallelogram";
    public static String PENTAGON_STRING = "Pentagon";
    public static String INVERTED_TRIANGLE_STRING = "Inverted_Triangle";
    public static String TRAPEZOID_STRING = "Trapezoid";
    
    public static String BLUE_STRING = "Blue";
    public static String CYAN_STRING = "Cyan";
    public static String GREEN_STRING = "Green";
    public static String MAGENTA_STRING = "Magenta";
    public static String ORANGE_STRING = "Orange";
    public static String PINK_STRING = "Pink";
    public static String RED_STRING = "Red";
    
    public static String THIN_STRING = "Thin";
    public static String THICK_STRING = "Thick";
    
    private int geometricShape = DEFAULT_SHAPE;
    private int fillColor = DEFAULT_COLOR;
    private int edgeThickness = DEFAULT_EDGE; 
    
    private String[] shapeStrings = {CIRCLE_STRING, SQUARE_STRING, TRIANGLE_STRING, 
    DIAMOND_STRING, PARRALLELOGRAM_STRING,
    PENTAGON_STRING, INVERTED_TRIANGLE_STRING, TRAPEZOID_STRING};
    private String[] colorStrings = {BLUE_STRING, CYAN_STRING, GREEN_STRING, MAGENTA_STRING,
    ORANGE_STRING, PINK_STRING, RED_STRING};
    private String[] edgeStrings = {THIN_STRING, THICK_STRING};
    
    private static int draw_id_x_offset=0;
    private static int draw_id_y_offset=0;
    private static int draw_key_x_offset=0;
    private static int draw_key_y_offset=0;
    private static int draw_description_line1_length=0;
    private static int draw_description_line1_x_offset=0;
    private static int draw_description_line1_y_offset=0;
    private static int draw_description_line2_length=0;
    private static int draw_description_line2a_x_offset=0;
    private static int draw_description_line2a_y_offset=0;
    private static int draw_description_line2b_x_offset=0;
    private static int draw_description_line2b_y_offset=0;
    private static int draw_description_line3_length=0;
    private static int draw_description_line3a_x_offset=0;
    private static int draw_description_line3a_y_offset=0;
    private static int draw_description_line3b_x_offset=0;
    private static int draw_description_line3b_y_offset=0;
    private static int draw_description_line3c_x_offset=0;
    private static int draw_description_line3c_y_offset=0;

    public CShape (String idString, int shape, int color, int edge, String descString) 
    {
        id = idString;
        geometricShape = shape;
        fillColor = color;
        edgeThickness = edge;
        description = descString;
    }

    public CShape (String idString, String shapeString, String colorString, String edgeString, String descString) 
    //needs to be more efficient and trap invalid data
    {
        this();

        if (shapeString.equals(CIRCLE_STRING)) geometricShape = CIRCLE;
        if (shapeString.equals(SQUARE_STRING)) geometricShape = SQUARE;
        if (shapeString.equals(TRIANGLE_STRING)) geometricShape = TRIANGLE;
        if (shapeString.equals(DIAMOND_STRING)) geometricShape = DIAMOND;
        if (shapeString.equals(PARRALLELOGRAM_STRING)) geometricShape = PARRALLELOGRAM;
        if (shapeString.equals(PENTAGON_STRING)) geometricShape = PENTAGON;
        if (shapeString.equals(INVERTED_TRIANGLE_STRING)) geometricShape = INVERTED_TRIANGLE;
        if (shapeString.equals(TRAPEZOID_STRING)) geometricShape = TRAPEZOID;
        
        if (colorString.equals(BLUE_STRING)) fillColor = BLUE;
        if (colorString.equals(CYAN_STRING)) fillColor = CYAN;
        if (colorString.equals(GREEN_STRING)) fillColor = GREEN;
        if (colorString.equals(MAGENTA_STRING)) fillColor = MAGENTA;
        if (colorString.equals(ORANGE_STRING)) fillColor = ORANGE;
        if (colorString.equals(PINK_STRING)) fillColor = PINK;
        if (colorString.equals(RED_STRING)) fillColor = RED;

        if (edgeString.equals(THIN_STRING)) edgeThickness = THIN_EDGE;
        if (edgeString.equals(THICK_STRING)) edgeThickness = THICK_EDGE;

        id = idString;
        description = descString;
    }

    public CShape()
    {
        this("0",DEFAULT_SHAPE,DEFAULT_COLOR,DEFAULT_EDGE,"");
    }
    
    public CShape (int shape, int color, int thickness)  
    {
        this("0",shape,color,thickness,"");
    }

    public CShape (String idString, int shape, int color, int thickness)  
    {
        this(idString,shape,color,thickness,"");
    }

    public int getShape()
    {        
        return geometricShape;
    }
    
    public String getShapeString()
    {
        return shapeStrings[geometricShape];
    }
        
    public void setShape(int s)
    {
        geometricShape = s;
    }
    
    public int getColor()
    {
        return fillColor;
    }
    
    public String getColorString()
    {
        return colorStrings[fillColor];
    }
    
    public void setColor(int c)
    {
        fillColor = c;
    }
    
    public int getEdge()
    {
        return this.edgeThickness;
    }
    
    public String getEdgeString()
    {
        return edgeStrings[edgeThickness];
    }
    
    public void setEdge(int t)
    {
        edgeThickness = t;
    }
    
    public void setIdString(String s) //only called for root and new objects
    {
        id = s;
    }

    public String getIdString()
    {
        return id;
    }
    
    public void setDescription (String d)
    {
        description = d;
    }
    
    public String getDescription()
    {
        return description;
    }
    
    public void setShowId(boolean b)
    {
        showId = b;
    }
    
    public void setShowKey(boolean b)
    {
        showKey = b;
    }
    
    public void setShowNodeDescription(boolean b)
    {
        showNodeDescription = b;
    }
    
    public void setShowPropertyDescription(boolean b)
    {
        showPropertyDescription = b;
    }
    
    public void setShowObjectProperties(boolean b)
    {
        showObjectProperties = b;
    }
    
    public void setKeyFont(String name, int style, int size)
    {
        keyFont = new java.awt.Font(name, style, size);
    }
    
    public void setIdFont(String name, int style, int size)
    {
        idFont = new java.awt.Font(name, style, size);
    }
    
    public void setDescriptionFont(String name, int style, int size)
    {
        descriptionFont = new java.awt.Font(name, style, size);
    }
    
    public void setKey (String k)
    {
        key = k;
    }
    
    public String getKey()
    {
        return key;
    }
    
    public void setTextDrawingConstants (int id_x, int id_y, int key_x, int key_y,
                                         int line1_len, int line1_x, int line1_y,
                                         int line2_len, int line2a_x, int line2a_y, int line2b_x, int line2b_y,
                                         int line3_len, int line3a_x, int line3a_y, int line3b_x, int line3b_y, 
                                         int line3c_x, int line3c_y )
    {
        draw_id_x_offset=id_x;
        draw_id_y_offset=id_y;
        draw_key_x_offset=key_x;
        draw_key_y_offset=key_y;
        draw_description_line1_length=line1_len;
        draw_description_line1_x_offset=line1_x;
        draw_description_line1_y_offset=line1_y;
        draw_description_line2_length=line2_len;
        draw_description_line2a_x_offset=line2a_x;
        draw_description_line2a_y_offset=line2a_y;
        draw_description_line2b_x_offset=line2b_x;
        draw_description_line2b_y_offset=line2b_y;
        draw_description_line3_length=line3_len;
        draw_description_line3a_x_offset=line3a_x;
        draw_description_line3a_y_offset=line3a_y;
        draw_description_line3b_x_offset=line3b_x;
        draw_description_line3b_y_offset=line3b_y;
        draw_description_line3c_x_offset=line3c_x;
        draw_description_line3c_y_offset=line3c_y;
    }
    
    public String toString()
    {
        if (id.equals(BUILDER_NEW_OBJECT)) 
        {
            return "new object";
        }
        else
        {
            return ( key + ":" + 
                     id  + ":" +
                     shapeStrings[geometricShape] + ":" +
                     colorStrings[fillColor] + ":" +
                     edgeStrings[edgeThickness] );
        }
    }

    //     draw a shape with a non-zero id, if any
    public void draw (java.awt.Graphics2D g2, float x, float y, float w, float h)
    {        
        if (id.equals(DO_NOT_DRAW)) return;
        java.awt.Shape currentShape = null;
        switch (geometricShape)
        {
            case CIRCLE:
                currentShape = new java.awt.geom.Ellipse2D.Float(x,y,w,h);
                break;
            case SQUARE:
                currentShape = new java.awt.geom.Rectangle2D.Float(x,y,w,h);
                break;
            case TRIANGLE:
                java.awt.geom.GeneralPath triangle = new java.awt.geom.GeneralPath();
                triangle.moveTo(x+w/2,y);
                triangle.lineTo(x+w,y+h);
                triangle.lineTo(x,y+h);
                triangle.closePath();
                currentShape = triangle;
                break;
            case DIAMOND:
                java.awt.geom.GeneralPath diamond = new java.awt.geom.GeneralPath();
                diamond.moveTo(x+w/2,y);
                diamond.lineTo(x+w,y+h/2);
                diamond.lineTo(x+w/2,y+h);
                diamond.lineTo(x,y+h/2);
                diamond.closePath();
                currentShape = diamond;
                break;
            case PARRALLELOGRAM:
                java.awt.geom.GeneralPath parrallelogram = new java.awt.geom.GeneralPath();
                parrallelogram.moveTo(x+w/2,y);
                parrallelogram.lineTo(x+w,y);
                parrallelogram.lineTo(x+w/2,y+h);
                parrallelogram.lineTo(x,y+h);
                parrallelogram.closePath();
                currentShape = parrallelogram;
                break;
            case PENTAGON:
                java.awt.geom.GeneralPath pentagon = new java.awt.geom.GeneralPath();
                pentagon.moveTo(x+w/2,y);
                pentagon.lineTo(x+w,y+h/2);
                pentagon.lineTo(x+w,y+h);
                pentagon.lineTo(x,y+h);
                pentagon.lineTo(x,y+h/2);
                pentagon.closePath();
                currentShape = pentagon;
                break;
            case INVERTED_TRIANGLE:
                java.awt.geom.GeneralPath itriangle = new java.awt.geom.GeneralPath();
                itriangle.moveTo(x,y);
                itriangle.lineTo(x+w,y);
                itriangle.lineTo(x+w/2,y+h);
                itriangle.closePath();
                currentShape = itriangle;
                break;
            case TRAPEZOID:
                java.awt.geom.GeneralPath trapezoid = new java.awt.geom.GeneralPath();
                trapezoid.moveTo(x+w/4,y);
                trapezoid.lineTo(x+3*w/4,y);
                trapezoid.lineTo(x+w,y+h);
                trapezoid.lineTo(x,y+h);
                trapezoid.closePath();
                currentShape = trapezoid;
                break;
            default:
                break;
        }

        java.awt.Color currentColor = null;
        switch (fillColor)
        {
            case BLUE:
                currentColor = BLUE_VALUE;
                break;
            case CYAN:
                currentColor = CYAN_VALUE;
                break;
            case GREEN:
                currentColor = GREEN_VALUE;
                break;
            case MAGENTA:
                currentColor = MAGENTA_VALUE;
                break;
            case ORANGE:
                currentColor = ORANGE_VALUE;
                break;
            case PINK:
                currentColor = PINK_VALUE;
                break;
            case RED:
                currentColor = RED_VALUE;
                break;
            default:
                break;
        }
        
        switch (edgeThickness)
        {
            case THIN_EDGE: 
                g2.setStroke(new java.awt.BasicStroke(THIN_EDGE_VALUE));
                break;
            case THICK_EDGE:
                g2.setStroke(new java.awt.BasicStroke(THICK_EDGE_VALUE));
                break;
            default:
                break;
        }
        
        g2.setColor(java.awt.Color.black);
        
        //editors use the "0" id which means they don't show an id number
        if (!id.equals(NO_TEXT))
        {
            if (showId)
            {
                g2.setFont(idFont);
                g2.drawString(id, x + draw_id_x_offset, y + draw_id_y_offset); 	
            }
        }
        
        if (!id.equals(NO_TEXT))
        {
            if (showKey)
            {
                g2.setFont(keyFont);
                g2.drawString(key, x + draw_key_x_offset, y + draw_key_y_offset); 	
            }
        }
        
        // show up to three, 80-character lines of text 
        if ( ((!id.equals(NO_TEXT)) && showNodeDescription) || 
             ((id.equals(NO_TEXT))  && showPropertyDescription))
        {
            g2.setFont(descriptionFont);
            if ((description.length() >= 0) && (description.length() <= draw_description_line1_length))
            {
                g2.drawString(description, x + draw_description_line1_x_offset, y + draw_description_line1_y_offset); 
            }
            else if (description.length() <= draw_description_line2_length)
            {
                g2.drawString(description.substring(0,draw_description_line1_length),
                    x + draw_description_line2a_x_offset,
                    y + draw_description_line2a_y_offset
                ); 
                g2.drawString(description.substring(draw_description_line1_length),
                    x + draw_description_line2b_x_offset,
                    y + draw_description_line2b_y_offset
                ); 
            }
            else
            {
                g2.drawString(description.substring(0,draw_description_line1_length),
                    x + draw_description_line3a_x_offset,
                    y + draw_description_line3a_y_offset
                ); 
                g2.drawString(description.substring(draw_description_line1_length,draw_description_line2_length),
                    x + draw_description_line3b_x_offset,
                    y + draw_description_line3b_y_offset
                ); 
                g2.drawString(description.substring(draw_description_line2_length,
                    java.lang.Math.min(description.length(),draw_description_line3_length)),
                    x + draw_description_line3c_x_offset,
                    y + draw_description_line3c_y_offset
                );            	    
            }
        }
 
        // if we are in the builder and the user wants us to, draw all objects with a black square outline;
        // otherwise draw as properties indicate  
        if (!showObjectProperties)
        {
            g2.setColor(java.awt.Color.black);
            g2.setStroke(new java.awt.BasicStroke(THIN_EDGE_VALUE));
            g2.draw(new java.awt.geom.Ellipse2D.Float(x,y,w,h));
        }
        else
        {
            g2.draw(currentShape);
            g2.setColor(currentColor);
            g2.fill(currentShape);
        }
    }
}