public class CShapeTreeCellTextEditor implements javax.swing.tree.TreeCellEditor, java.awt.event.ActionListener
{
    private javax.swing.JTextField textField; 
    private java.util.Vector listenersVector = new java.util.Vector();
    private javax.swing.tree.DefaultMutableTreeNode node;
    private CShape currentCShape;
    
    public CShapeTreeCellTextEditor()
    {
        textField = new javax.swing.JTextField("",80);
        textField.addActionListener(this);
    }
    
    //called at each cell
    public java.awt.Component getTreeCellEditorComponent(javax.swing.JTree tree, Object value, 
    boolean isSelected, boolean expanded, boolean leaf, int row)
    {
        node = (javax.swing.tree.DefaultMutableTreeNode)value;
        return (java.awt.Component)textField;
    }
    
    public Object getCellEditorValue()
    {
        currentCShape.setDescription(textField.getText());
        return currentCShape;
    }
    
    //decides when to activate editor
    public boolean isCellEditable(java.util.EventObject eo)
    {
        if (CShape.showNodeDescription)
        {
            if (eo instanceof java.awt.event.MouseEvent)
            {         
                java.awt.event.MouseEvent me = (java.awt.event.MouseEvent)eo;
                if (me.isControlDown())
                {
                    currentCShape = (CShape)node.getUserObject();
                    textField.setText(currentCShape.getDescription());
                    return true;
                }
            }
/*
            else if (eo instanceof java.awt.event.KeyEvent)
            {
                java.awt.event.KeyEvent ke = (java.awt.event.KeyEvent)eo;System.out.println("key event "+ke.getKeyCode());
                if (ke.getKeyCode() == java.awt.event.KeyEvent.VK_F2)
                {
                    currentCShape = (CShape)node.getUserObject();
                    textField.setText(currentCShape.getDescription());
                    return true;
                }
            }
*/
        }
        return false;
    }
    
    public boolean shouldSelectCell(java.util.EventObject eo)
    {
        return true;
    }
    
    public boolean stopCellEditing()
    {
        return true;
    }
    
    public void cancelCellEditing()
    {
    }
    
    public void addCellEditorListener(javax.swing.event.CellEditorListener listener)
    {
        listenersVector.addElement(listener);
    }
    
    public void removeCellEditorListener(javax.swing.event.CellEditorListener listener)
    {
        listenersVector.removeElement(listener);
    }
    
    public void actionPerformed(java.awt.event.ActionEvent ae)
    {
       if (listenersVector.size() > 0)
        {
            javax.swing.event.ChangeEvent ce = new javax.swing.event.ChangeEvent(textField);
            for (int i = listenersVector.size()-1; i >= 0; i--)
            {
                ((javax.swing.event.CellEditorListener)listenersVector.elementAt(i)).editingStopped(ce);
            }
        }
    }
}
