public class ColorPropertyEditor extends javax.swing.JFrame 
implements javax.swing.event.ListSelectionListener,
           java.awt.event.ActionListener
{
    private String[] colorStrings = {CShape.BLUE_STRING, CShape.CYAN_STRING, 
        CShape.GREEN_STRING,CShape.MAGENTA_STRING, 
        CShape.ORANGE_STRING, CShape.PINK_STRING, 
        CShape.RED_STRING};
    private javax.swing.JList colorList;
    private javax.swing.DefaultListSelectionModel colorListSelectionModel = 
        new javax.swing.DefaultListSelectionModel();
    private ColorPropertyEditorRenderer colorRenderer = null;
    private int minWidth, minHeight, boundsX, boundsY;
    private javax.swing.JButton applyButton = new javax.swing.JButton();
    private java.util.Vector listeners = new java.util.Vector();

    public ColorPropertyEditor(String title, java.util.Properties propertiesFile)
    {
        super(title);
        minWidth = new java.lang.Integer(propertiesFile.getProperty("editor_frame_width")).intValue();
        minHeight = new java.lang.Integer(propertiesFile.getProperty("editor_frame_height")).intValue();
        boundsX = new java.lang.Integer(propertiesFile.getProperty("editor_frame_boundsX")).intValue();
        boundsY = new java.lang.Integer(propertiesFile.getProperty("editor_frame_boundsY")).intValue();
        applyButton.setText(propertiesFile.getProperty("editor_apply_button_text"));

        setSize(minWidth,minHeight);
        colorRenderer = new ColorPropertyEditorRenderer();
                
        colorList = new javax.swing.JList(colorStrings);
        colorListSelectionModel.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        colorList.setSelectionModel(colorListSelectionModel);
        colorList.addListSelectionListener(this);
        colorListSelectionModel.addSelectionInterval(0,0);
        colorList.setFixedCellHeight(50);
        colorList.setCellRenderer(colorRenderer);
        colorList.setVisible(true);

        applyButton.addActionListener(this);
        applyButton.setVisible(true);
        getContentPane().add(colorList);
        getContentPane().add(applyButton,java.awt.BorderLayout.SOUTH);
    }

    public void addChangeListener(javax.swing.event.ChangeListener cl)
    {
        listeners.add(cl);
    }
    
    public void removeChangeListener(javax.swing.event.ChangeListener cl)
    {
        listeners.remove(cl);
    }
    
    protected void fireStateChanged(javax.swing.event.ChangeEvent ce)
    {
        for (int i = listeners.size()-1; i >= 0; i--)
        {
            javax.swing.event.ChangeListener cl = (javax.swing.event.ChangeListener)listeners.elementAt(i);
            cl.stateChanged(ce);
        }
    }

    public void actionPerformed(java.awt.event.ActionEvent ae)
    {
        fireStateChanged(new javax.swing.event.ChangeEvent(this));
    }

    public void valueChanged(javax.swing.event.ListSelectionEvent lse)
    {
    }

    public void setBounds(java.awt.Rectangle r)
    {
        r.width = minWidth;
        r.height = minHeight;
        super.setBounds(r);
    }
    
    public void setBounds(int x, int y, int w, int h)
    {
        super.setBounds(boundsX, boundsY, minWidth, minHeight);
    }
    
    public void setColor (int s)
    {
        colorListSelectionModel.addSelectionInterval(0,s);
    }

    public int getColor()
    {
        return colorList.getSelectedIndex();
    }    

    public void setShape (int s)
    {
        colorRenderer.setShape(s);
    }

    public void setEdge (int e)
    {
        colorRenderer.setEdge(e);
    }
}