public class ColorPropertyEditorRenderer extends javax.swing.JPanel implements javax.swing.ListCellRenderer
{
    private int selectionIndex = 0;
    private boolean isElementSelected = false;
    private java.awt.image.BufferedImage bimg;
    private int shape = CShape.DEFAULT_SHAPE;
    private int edge = CShape.DEFAULT_EDGE;
    private java.util.Properties propertiesFile = new java.util.Properties();
    private String colorDescriptions[] = new String[7];
      
    public ColorPropertyEditorRenderer()
    {
        setBackground(java.awt.Color.white);
        try
        {
            propertiesFile.load(new java.io.FileInputStream("CShape.properties"));
        }
        catch (Exception e)
        {
            System.out.println(e);
        }
        colorDescriptions[0] = propertiesFile.getProperty("blue_property_description");
        colorDescriptions[1] = propertiesFile.getProperty("cyan_property_description");
        colorDescriptions[2] = propertiesFile.getProperty("green_property_description");
        colorDescriptions[3] = propertiesFile.getProperty("magenta_property_description");
        colorDescriptions[4] = propertiesFile.getProperty("orange_property_description");
        colorDescriptions[5] = propertiesFile.getProperty("pink_property_description");
        colorDescriptions[6] = propertiesFile.getProperty("red_property_description");
    }
    
    public java.awt.Component getListCellRendererComponent(
    javax.swing.JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
    {
        selectionIndex = index;
        isElementSelected = isSelected;
        if (isSelected) setBackground(java.awt.Color.gray);

        return this;
    }
    
    public void drawColor(int w, int h, java.awt.Graphics2D g2) 
    {
        CShape cshape = new CShape("0",shape,selectionIndex,edge,colorDescriptions[selectionIndex]);
        if (isElementSelected) 
        {
            setBackground(java.awt.Color.gray);
        }
        else
        {
            setBackground(java.awt.Color.white);
        }
        cshape.draw(g2,5.0f,5.0f,40.0f,40.0f);        
        setBackground(java.awt.Color.white);
    }

    public java.awt.Graphics2D createGraphics2D(int w, int h) {
        java.awt.Graphics2D g2 = null;
        if (bimg == null || bimg.getWidth() != w || bimg.getHeight() != h) {
            bimg = (java.awt.image.BufferedImage) createImage(w, h);
        } 
        g2 = bimg.createGraphics();
        g2.setBackground(getBackground());
        g2.clearRect(0, 0, w, h);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING,
                            java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        return g2;
    }

    public void paint(java.awt.Graphics g) 
    {
        java.awt.Dimension d = getSize();
        java.awt.Graphics2D g2 = createGraphics2D(d.width, d.height);
        drawColor(d.width, d.height, g2);
        g2.dispose();
        g.drawImage(bimg, 0, 0, this);
    }
    
    public void setShape (int index)
    {
        shape = index;
    }
    
    public void setEdge (int index)
    {
        edge = index;
    }
}
    
    
    