public class DataStore
{
    private java.util.Vector cshapesVector = new java.util.Vector();
    private java.util.Properties propertiesFile = null;

    public DataStore()
    {
    }
    
    public void addNode(CShape cshape)
    {
        cshapesVector.addElement(cshape);
    }

    public void removeNode(String id)
    {
        for (int i = 0; i < cshapesVector.size(); i++)
        {
            if (((CShape)cshapesVector.elementAt(i)).getIdString().equals(id))
            { 
                cshapesVector.remove(i);
                break;
            }
        }
    }

    public void load(String file)
    {
        java.util.Properties propertiesFile = new java.util.Properties();
        try
        {
            propertiesFile.load(new java.io.FileInputStream(file));
        }
        catch (Exception e)
        {
            System.out.println(e);
        }

        // load data and initialize store
        cshapesVector.removeAllElements();
        int i = 0;
        String id = null;
        while ((id = propertiesFile.getProperty("node_"+i+"_id")) != null)
        {
            CShape cshape = new CShape(id,
                propertiesFile.getProperty("node_"+i+"_shape"),
                propertiesFile.getProperty("node_"+i+"_color"),
                propertiesFile.getProperty("node_"+i+"_edge"),
                propertiesFile.getProperty("node_"+i+"_description"));
            cshape.setKey(propertiesFile.getProperty("node_"+i+"_key"));
            cshapesVector.addElement(cshape);
            i++;
        }
    }
    
    public void save(String file)
    {
        java.util.Properties propertiesFile = new java.util.Properties();
        
        // save data for each node
        for (int i = 0; i < cshapesVector.size(); i++)
        {
            CShape cshape = (CShape)cshapesVector.elementAt(i); 
            propertiesFile.setProperty("node_"+i+"_key",
                cshape.getKey());
            propertiesFile.setProperty("node_"+i+"_id",
                cshape.getIdString());
            propertiesFile.setProperty("node_"+i+"_shape",
                cshape.getShapeString());
            propertiesFile.setProperty("node_"+i+"_color",
                cshape.getColorString());
            propertiesFile.setProperty("node_"+i+"_edge",
                cshape.getEdgeString());
            propertiesFile.setProperty("node_"+i+"_description",
                cshape.getDescription());
        }
        
        // write data to file
        if (cshapesVector.size() > 0)
        {
            try
            {
                propertiesFile.store(new java.io.FileOutputStream(file),"");
            }
            catch (Exception ex)
            {
                System.out.println(ex);
            }
        }
    }
    
    public CShape getNode(int index)
    {
        return (CShape)cshapesVector.elementAt(index);
    }
    
    public CShape[] getNodes()
    {
        CShape cshapes[] = new CShape[cshapesVector.size()];
        for (int i = 0; i < cshapesVector.size(); i++)
        {
            cshapes[i] = (CShape)cshapesVector.elementAt(i);
        }
        return (cshapes);
    }
}

    