public class EdgePropertyEditor extends javax.swing.JFrame 
implements javax.swing.event.ListSelectionListener, 
           java.awt.event.ActionListener
{
    private String[] edgeStrings = {CShape.THIN_STRING, CShape.THICK_STRING};
    private static javax.swing.JTabbedPane tabbedPane = new javax.swing.JTabbedPane();
    private javax.swing.JList edgeList;
    private javax.swing.DefaultListSelectionModel edgeListSelectionModel = 
        new javax.swing.DefaultListSelectionModel();
    private EdgePropertyEditorRenderer edgeRenderer = null;
    private int minWidth, minHeight, boundsX, boundsY;
    private javax.swing.JButton applyButton = new javax.swing.JButton();
    private java.util.Vector listeners = new java.util.Vector();
 
    public EdgePropertyEditor(String title, java.util.Properties propertiesFile)
    {
        super(title);

        minWidth = new java.lang.Integer(propertiesFile.getProperty("editor_frame_width")).intValue();
        minHeight = new java.lang.Integer(propertiesFile.getProperty("editor_frame_height")).intValue();
        boundsX = new java.lang.Integer(propertiesFile.getProperty("editor_frame_boundsX")).intValue();
        boundsY = new java.lang.Integer(propertiesFile.getProperty("editor_frame_boundsY")).intValue();
        applyButton.setText(propertiesFile.getProperty("editor_apply_button_text"));

        setSize(minWidth,minHeight);
        edgeRenderer = new EdgePropertyEditorRenderer();
                        
        edgeList = new javax.swing.JList(edgeStrings);
        edgeListSelectionModel.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        edgeList.setSelectionModel(edgeListSelectionModel);
        edgeList.addListSelectionListener(this);
        edgeListSelectionModel.addSelectionInterval(0,0);
        edgeList.setFixedCellHeight(50);
        edgeList.setCellRenderer(edgeRenderer);
        edgeList.setVisible(true);

        applyButton.addActionListener(this);
        applyButton.setVisible(true);
        getContentPane().add(edgeList);
        getContentPane().add(applyButton,java.awt.BorderLayout.SOUTH);
    }
    
    public void addChangeListener(javax.swing.event.ChangeListener cl)
    {
        listeners.add(cl);
    }
    
    public void removeChangeListener(javax.swing.event.ChangeListener cl)
    {
        listeners.remove(cl);
    }
    
    protected void fireStateChanged(javax.swing.event.ChangeEvent ce)
    {
        for (int i = listeners.size()-1; i >= 0; i--)
        {
            javax.swing.event.ChangeListener cl = (javax.swing.event.ChangeListener)listeners.elementAt(i);
            cl.stateChanged(ce);
        }
    }

    public void actionPerformed(java.awt.event.ActionEvent ae)
    {
        fireStateChanged(new javax.swing.event.ChangeEvent(this));
    }

    public void valueChanged(javax.swing.event.ListSelectionEvent lse)
    {
    }

    public void setBounds(java.awt.Rectangle r)
    {
        r.width = minWidth;
        r.height = minHeight;
        super.setBounds(r);
    }
    
    public void setBounds(int x, int y, int w, int h)
    {
        super.setBounds(boundsX, boundsY, minWidth, minHeight);
    }
    
    public void setEdge (int s)
    {
        edgeListSelectionModel.addSelectionInterval(0,s);
    }

    public int getEdge()
    {
        return edgeList.getSelectedIndex();
    }    

    public void setShape (int s)
    {
        edgeRenderer.setShape(s);
    }

    public void setColor (int c)
    {
        edgeRenderer.setColor(c);
    }
}