public class FileFilterExt extends javax.swing.filechooser.FileFilter
{
    String[] extensions;
    String description;
    
    public FileFilterExt(String ext)
    {
        this (new String[] {ext}, null);
    }
    
    public FileFilterExt(String exts[], String descr)
    {
        extensions = exts;
        description = (descr == null ? exts[0] + " files" : descr);
    }
    
    public boolean accept(java.io.File file)
    {
        if (file.isDirectory()) 
        { 
            return true; 
        }
        String name = file.getName();
        for (int i = extensions.length - 1; i >= 0; i--)
        {
            if (name.endsWith(extensions[i])) 
            {
                return true;
            }
        }
        return false;
    }
    
    public String getDescription()
    {
        return description;
    }
}
