public class EdgePropertyEditorRenderer extends javax.swing.JPanel implements javax.swing.ListCellRenderer
{
    private int selectionIndex = 0;
    private boolean isElementSelected = false;
    private java.awt.image.BufferedImage bimg;
    private int fillColor = CShape.DEFAULT_COLOR;
    private int shape = CShape.DEFAULT_SHAPE;
    private java.util.Properties propertiesFile = new java.util.Properties();
    private String edgeDescriptions[] = new String[2];
      
    public EdgePropertyEditorRenderer(java.util.Properties p)
    {
        setBackground(java.awt.Color.white);
        propertiesFile = p;
        edgeDescriptions[0] = p.getProperty("thin_property_description");
        edgeDescriptions[1] = p.getProperty("thick_property_description");
    }
    
    public java.awt.Component getListCellRendererComponent(
    javax.swing.JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
    {
        selectionIndex = index;
        isElementSelected = isSelected;
        if (isSelected) setBackground(java.awt.Color.gray);
        return this;
    }
    
    public void drawEdge(int w, int h, java.awt.Graphics2D g2) 
    {
        CShape cshape = new CShape("0",shape,fillColor,selectionIndex,edgeDescriptions[selectionIndex]);
        if (isElementSelected) 
        {
            setBackground(java.awt.Color.gray);
        }
        else
        {
            setBackground(java.awt.Color.white);
        }
        cshape.draw(g2,5.0f,5.0f,40.0f,40.0f);        
        setBackground(java.awt.Color.white);
    }

    public java.awt.Graphics2D createGraphics2D(int w, int h) {
        java.awt.Graphics2D g2 = null;
        if (bimg == null || bimg.getWidth() != w || bimg.getHeight() != h) {
            bimg = (java.awt.image.BufferedImage) createImage(w, h);
        } 
        g2 = bimg.createGraphics();
        g2.setBackground(getBackground());
        g2.clearRect(0, 0, w, h);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING,
                            java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        return g2;
    }

    public void paint(java.awt.Graphics g) 
    {
        java.awt.Dimension d = getSize();
        java.awt.Graphics2D g2 = createGraphics2D(d.width, d.height);
        drawEdge(d.width, d.height, g2);
        g2.dispose();
        g.drawImage(bimg, 0, 0, this);
    }

    public void setColor (int index)
    {
        fillColor = index;
    }
    
    public void setShape (int index)
    {
        shape = index;
    }    
}
    
    
    