public class HierarchyStore
{
    private javax.swing.tree.DefaultTreeModel shapeHierarchy = null;
    private javax.swing.tree.DefaultTreeModel colorHierarchy = null;
    private javax.swing.tree.DefaultTreeModel edgeHierarchy = null;
    private CShape cshape1 = null;
    private CShape cshape2 = null;
    private CShape cshape3 = null;
    private CShape cshape4 = null;
    private CShape cshape5 = null;
    private CShape cshape6 = null;
    private CShape cshape7 = null;
    private CShape[] cshapes = {cshape1,cshape2,cshape3,cshape4,cshape5,cshape6,cshape7};
    private java.util.Properties propertiesFile = null;
            
    public HierarchyStore(java.util.Properties p)
    {
        propertiesFile = p;
        Load();
        initShapeHierarchy();
        initColorHierarchy();
        initEdgeHierarchy();        
    }
    
    private void Load()
    {    
            cshape1 = new CShape(propertiesFile.getProperty("node_1_id_number"),
                                 propertiesFile.getProperty("node_1_shape"),
                                 propertiesFile.getProperty("node_1_color"),
                                 propertiesFile.getProperty("node_1_edge"),
                                 propertiesFile.getProperty("node_1_description"));
            cshape2 = new CShape(propertiesFile.getProperty("node_2_id_number"),
                                 propertiesFile.getProperty("node_2_shape"),
                                 propertiesFile.getProperty("node_2_color"),
                                 propertiesFile.getProperty("node_2_edge"),
                                 propertiesFile.getProperty("node_2_description"));
            cshape3 = new CShape(propertiesFile.getProperty("node_3_id_number"),
                                 propertiesFile.getProperty("node_3_shape"),
                                 propertiesFile.getProperty("node_3_color"),
                                 propertiesFile.getProperty("node_3_edge"),
                                 propertiesFile.getProperty("node_3_description"));
            cshape4 = new CShape(propertiesFile.getProperty("node_4_id_number"),
                                 propertiesFile.getProperty("node_4_shape"),
                                 propertiesFile.getProperty("node_4_color"),
                                 propertiesFile.getProperty("node_4_edge"),
                                 propertiesFile.getProperty("node_4_description"));
            cshape5 = new CShape(propertiesFile.getProperty("node_5_id_number"),
                                 propertiesFile.getProperty("node_5_shape"),
                                 propertiesFile.getProperty("node_5_color"),
                                 propertiesFile.getProperty("node_5_edge"),
                                 propertiesFile.getProperty("node_5_description"));
            cshape6 = new CShape(propertiesFile.getProperty("node_6_id_number"),
                                 propertiesFile.getProperty("node_6_shape"),
                                 propertiesFile.getProperty("node_6_color"),
                                 propertiesFile.getProperty("node_6_edge"),
                                 propertiesFile.getProperty("node_6_description"));
            cshape7 = new CShape(propertiesFile.getProperty("node_7_id_number"),
                                 propertiesFile.getProperty("node_7_shape"),
                                 propertiesFile.getProperty("node_7_color"),
                                 propertiesFile.getProperty("node_7_edge"),
                                 propertiesFile.getProperty("node_7_description"));
        cshapes[0] = cshape1;
        cshapes[1] = cshape2;
        cshapes[2] = cshape3;
        cshapes[3] = cshape4;
        cshapes[4] = cshape5;
        cshapes[5] = cshape6;
        cshapes[6] = cshape7;
    }

    public void Save(java.util.Properties p)
    {
        p.setProperty("node_1_id_number",cshapes[0].getIdString());
        p.setProperty("node_1_shape",cshapes[0].getShapeString());
        p.setProperty("node_1_color",cshapes[0].getColorString());
        p.setProperty("node_1_edge",cshapes[0].getEdgeString());
        p.setProperty("node_1_description",cshapes[0].getDescription());

        p.setProperty("node_2_id_number",cshapes[1].getIdString());
        p.setProperty("node_2_shape",cshapes[1].getShapeString());
        p.setProperty("node_2_color",cshapes[1].getColorString());
        p.setProperty("node_2_edge",cshapes[1].getEdgeString());
        p.setProperty("node_2_description",cshapes[1].getDescription());

        p.setProperty("node_3_id_number",cshapes[2].getIdString());
        p.setProperty("node_3_shape",cshapes[2].getShapeString());
        p.setProperty("node_3_color",cshapes[2].getColorString());
        p.setProperty("node_3_edge",cshapes[2].getEdgeString());
        p.setProperty("node_3_description",cshapes[2].getDescription());

        p.setProperty("node_4_id_number",cshapes[3].getIdString());
        p.setProperty("node_4_shape",cshapes[3].getShapeString());
        p.setProperty("node_4_color",cshapes[3].getColorString());
        p.setProperty("node_4_edge",cshapes[3].getEdgeString());
        p.setProperty("node_4_description",cshapes[3].getDescription());

        p.setProperty("node_5_id_number",cshapes[4].getIdString());
        p.setProperty("node_5_shape",cshapes[4].getShapeString());
        p.setProperty("node_5_color",cshapes[4].getColorString());
        p.setProperty("node_5_edge",cshapes[4].getEdgeString());
        p.setProperty("node_5_description",cshapes[4].getDescription());

        p.setProperty("node_6_id_number",cshapes[5].getIdString());
        p.setProperty("node_6_shape",cshapes[5].getShapeString());
        p.setProperty("node_6_color",cshapes[5].getColorString());
        p.setProperty("node_6_edge",cshapes[5].getEdgeString());
        p.setProperty("node_6_description",cshapes[5].getDescription());

        p.setProperty("node_7_id_number",cshapes[6].getIdString());
        p.setProperty("node_7_shape",cshapes[6].getShapeString());
        p.setProperty("node_7_color",cshapes[6].getColorString());
        p.setProperty("node_7_edge",cshapes[6].getEdgeString());
        p.setProperty("node_7_description",cshapes[6].getDescription());
    }
    
    private void initShapeHierarchy()
    {
        javax.swing.tree.DefaultMutableTreeNode shapeRoot = new javax.swing.tree.DefaultMutableTreeNode();
        CShape cshape = new CShape();
        cshape.setIdString("-1");
        shapeRoot.setUserObject(cshape);
        shapeHierarchy = new javax.swing.tree.DefaultTreeModel(shapeRoot); 

        javax.swing.tree.DefaultMutableTreeNode cshape1Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape2Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape3Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape4Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape5Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape6Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape7Node = new javax.swing.tree.DefaultMutableTreeNode();
        
        cshape1Node.setUserObject(cshape1);
        cshape2Node.setUserObject(cshape2);
        cshape3Node.setUserObject(cshape3);
        cshape4Node.setUserObject(cshape4);
        cshape5Node.setUserObject(cshape5);
        cshape6Node.setUserObject(cshape6);
        cshape7Node.setUserObject(cshape7);

/*       	Shape
                1
                    2
                        4
                        5
                    3
                        6
                        7
*/
        shapeHierarchy.insertNodeInto(cshape1Node,shapeRoot,0);
        shapeHierarchy.insertNodeInto(cshape7Node,cshape3Node,0);
        shapeHierarchy.insertNodeInto(cshape6Node,cshape3Node,0);
        shapeHierarchy.insertNodeInto(cshape3Node,cshape1Node,0);
        shapeHierarchy.insertNodeInto(cshape5Node,cshape2Node,0);
        shapeHierarchy.insertNodeInto(cshape4Node,cshape2Node,0);
        shapeHierarchy.insertNodeInto(cshape2Node,cshape1Node,0);                
    }
    
    private void initColorHierarchy()
    {
        javax.swing.tree.DefaultMutableTreeNode colorRoot = new javax.swing.tree.DefaultMutableTreeNode();
        CShape cshape = new CShape();
        cshape.setIdString("-1");
        colorRoot.setUserObject(cshape);
        colorHierarchy = new javax.swing.tree.DefaultTreeModel(colorRoot); 

        javax.swing.tree.DefaultMutableTreeNode cshape1Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape2Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape3Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape4Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape5Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape6Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape7Node = new javax.swing.tree.DefaultMutableTreeNode();
        
        cshape1Node.setUserObject(cshape1);
        cshape2Node.setUserObject(cshape2);
        cshape3Node.setUserObject(cshape3);
        cshape4Node.setUserObject(cshape4);
        cshape5Node.setUserObject(cshape5);
        cshape6Node.setUserObject(cshape6);
        cshape7Node.setUserObject(cshape7);

/*       	Color
                1
                    4
                2
                    5
                        7
                3
                    6
*/
        colorHierarchy.insertNodeInto(cshape3Node,colorRoot,0);
        colorHierarchy.insertNodeInto(cshape6Node,cshape3Node,0);
        colorHierarchy.insertNodeInto(cshape2Node,colorRoot,0);
        colorHierarchy.insertNodeInto(cshape5Node,cshape2Node,0);
        colorHierarchy.insertNodeInto(cshape7Node,cshape5Node,0);
        colorHierarchy.insertNodeInto(cshape1Node,colorRoot,0);
        colorHierarchy.insertNodeInto(cshape4Node,cshape1Node,0);
    }
    
    private void initEdgeHierarchy()
    {
        javax.swing.tree.DefaultMutableTreeNode edgeRoot = new javax.swing.tree.DefaultMutableTreeNode();
        CShape cshape = new CShape();
        cshape.setIdString("-1");
        edgeRoot.setUserObject(cshape);
        edgeHierarchy = new javax.swing.tree.DefaultTreeModel(edgeRoot); 
        
        javax.swing.tree.DefaultMutableTreeNode cshape1Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape2Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape3Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape4Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape5Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape6Node = new javax.swing.tree.DefaultMutableTreeNode();
        javax.swing.tree.DefaultMutableTreeNode cshape7Node = new javax.swing.tree.DefaultMutableTreeNode();
        
        cshape1Node.setUserObject(cshape1);
        cshape2Node.setUserObject(cshape2);
        cshape3Node.setUserObject(cshape3);
        cshape4Node.setUserObject(cshape4);
        cshape5Node.setUserObject(cshape5);
        cshape6Node.setUserObject(cshape6);
        cshape7Node.setUserObject(cshape7);

/*       	Edge
                1
                    2
                        3
                        4
                5
                    6
                        7
*/
        edgeHierarchy.insertNodeInto(cshape7Node,cshape6Node,0);
        edgeHierarchy.insertNodeInto(cshape6Node,cshape5Node,0);
        edgeHierarchy.insertNodeInto(cshape5Node,edgeRoot,0);
        edgeHierarchy.insertNodeInto(cshape4Node,cshape2Node,0);
        edgeHierarchy.insertNodeInto(cshape1Node,edgeRoot,0);
        edgeHierarchy.insertNodeInto(cshape3Node,cshape2Node,0);
        edgeHierarchy.insertNodeInto(cshape2Node,cshape1Node,0);
    }
    
    public CShape getNode(int index)
    {
        return cshapes[index];
    }
    
    public CShape[] getNodes()
    {
        return cshapes;
    }
    
    public javax.swing.tree.DefaultTreeModel getShapeHierarchy()
    {
        return shapeHierarchy;
    }

    public javax.swing.tree.DefaultTreeModel getColorHierarchy()
    {
        return colorHierarchy;
    }

    public javax.swing.tree.DefaultTreeModel getEdgeHierarchy()
    {
        return edgeHierarchy;
    }
}
    