package edu.mit.is.okapi.servlets;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

/**
 * Okapi MIT Logout Servlet.
 *
 * Processes login
 *
 * @author OKI Dev team
 * @version $Revision: 1.2 $ / $Date: 2002/05/04 03:46:19 $
 */

public class LogoutServlet extends HttpServlet {

    /**Initialize global variables*/
    public void init(ServletConfig config) throws ServletException
    {
	super.init(config);
    }


    /**Process the HTTP Get request*/
    public void doGet(HttpServletRequest request,
		      HttpServletResponse response)
	throws ServletException, IOException
    {

	javax.servlet.http.HttpSession session =  request.getSession();
	session.invalidate();

	/*
	  Simply issue cookies which are invalid.
	*/


	Cookie ssl_c =  new Cookie("ok_authen_ssl", "*****");
	ssl_c.setPath("/");
	ssl_c.setSecure(true);
	Cookie c = new Cookie("ok_authen", "*****");
	c.setPath("/");
	response.addCookie(c);
	response.addCookie(ssl_c);
	response.sendRedirect("http://"+
			      request.getServerName()+"/");
    }

    /**Process the HTTP Post request with username/password */
    public void doPost(HttpServletRequest request,
		       HttpServletResponse response)
	throws ServletException, IOException
    {
	doGet(request, response);
    }

    /**Clean up resources*/
    public void destroy() {
    }
}
