package edu.mit.is.service.authentication.impl.authenkrb4;
/*
   Copyright (c) 2002 Massachusetts Institute of Technology

   This work, including software, documents, or other related items (the
   "Software"), is being provided by the copyright holder(s) subject to
   the terms of the MIT OKI(TM)  API Implementation License. By
   obtaining, using and/or copying this Software, you agree that you have
   read, understand, and will comply with the following terms and
   conditions of the MIT OKI(TM) API Implementation License:

   Permission to use, copy, modify, and distribute this Software and its
   documentation, with or without modification, for any purpose and
   without fee or royalty is hereby granted, provided that you include
   the following on ALL copies of the Software or portions thereof,
   including modifications or derivatives, that you make:

    *  The full text of the MIT OKI(TM) API Implementation License in a
       location viewable to users of the redistributed or derivative
       work.

    *  Any pre-existing intellectual property disclaimers, notices, or
       terms and conditions. If none exist, a short notice similar to the
       following should be used within the body of any redistributed or
       derivative Software:
       "Copyright (c) 2002 Massachusetts Institute of Technology
       All Rights Reserved."

    *  Notice of any changes or modifications to the MIT OKI(TM)
       Software, including the date the changes were made. Any modified
       software must be distributed in such as manner as to avoid any
       confusion with the original MIT OKI(TM) Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

   The name and trademarks of copyright holder(s) and/or MIT may NOT be
   used in advertising or publicity pertaining to the Software without
   specific, written prior permission. Title to copyright in the Software
   and any associated documentation will at all times remain with the
   copyright holders.

   The export of software employing encryption technology may require a
   specific license from the United States Government. It is the
   responsibility of any person or organization contemplating export to
   obtain such a license before exporting this Software.
*/

/*
 * $Source: /cvs/oki/tech/contrib/mit/impl/src/edu/mit/is/service/authentication/impl/authenkrb4/Callback.java,v $
 */

/**
 * Kerberos 4 authentication for OKI User Interface
 *
 * Licensed under the {@link org.okip.service.ApiImplementationLicenseMIT MIT OKI(TM) API Implementation License}.
 *
 * @version $Name:  $ / $Revision: 1.3 $ / $Date: 2002/07/03 19:04:38 $
*/

public class Callback
implements java.io.Serializable {
  public Object[] getNameAndPassword()
  throws org.okip.service.authentication.api.AuthenticationException {
    try {
      javax.swing.JTextField name = new javax.swing.JTextField();
      javax.swing.JLabel nameLabel = new javax.swing.JLabel("Name");
      javax.swing.JPasswordField password = new javax.swing.JPasswordField();
      javax.swing.JLabel passwordLabel = new javax.swing.JLabel("Password");
      javax.swing.JLabel quitLabel = new javax.swing.JLabel("To finish close dialog");
      javax.swing.JFrame  parent = new javax.swing.JFrame("Kerberos Authentication");
      javax.swing.JDialog dialog = new javax.swing.JDialog(parent);

      name.setColumns(10);
      password.setColumns(10);

      nameLabel.setLabelFor(name);
      passwordLabel.setLabelFor(password);

      dialog.setModal(true);
      dialog.getContentPane().setLayout(new java.awt.FlowLayout());
      dialog.getContentPane().setSize(100, 100);
      dialog.getContentPane().add(nameLabel);
      dialog.getContentPane().add(name);
      dialog.getContentPane().add(passwordLabel);
      dialog.getContentPane().add(password);
      dialog.getContentPane().add(quitLabel);
      dialog.pack();
      dialog.show();

      Object[] nap = new Object[2];
      nap[0] = name.getText();
      nap[1] = password.getPassword();
      return nap;
    }
    catch (Throwable ex) {
      throw new org.okip.service.authentication.api.AuthenticationException(
        ex.getMessage());
    }
  }
}
