package edu.mit.is.service.authorization;

public class Authorization
implements org.okip.service.authorization.api.Authorization {

  private final static String NO        = "N";
  private final static String YES       = "Y";

  // Authorization stored procedures

  private final static String CREATE             =
    "ROLESAPI_CREATE_AUTHORIZATION";
  private final static String DELETE             =
    "ROLESAPI_DELETE_AUTHORIZATION";
  private final static String UPDATE             =
    "ROLESAPI_UPDATE_AUTHORIZATION";
  private final static String IS_USER_AUTHORIZED =
    "ROLESAPI_IS_USER_AUTHORIZED";

  // Authorization field names

  private final static String AUTHORIZATION_ID  = "AUTHORIZATION_ID";
  private final static String FUNCTION_ID       = "FUNCTION_ID";
  private final static String QUALIFIER_ID      = "QUALIFIER_ID";
  private final static String KERBEROS_NAME     = "KERBEROS_NAME";
  private final static String QUALIFIER_CODE    = "QUALIFIER_CODE";
  private final static String FUNCTION_NAME     = "FUNCTION_NAME";
  private final static String FUNCTION_CATEGORY = "FUNCTION_CATEGORY";
  private final static String QUALIFIER_NAME    = "QUALIFIER_DESCRIPTION";
  private final static String MODIFIED_BY       = "MODIFIED_BY";
  private final static String MODIFIED_DATE     = "MODIFIED_DATE";
  private final static String DESCEND           = "DESCEND";
  private final static String EFFECTIVE_DATE    = "EFFECTIVE_DATE";
  private final static String EXPIRATION_DATE   = "EXPIRATION_DATE";

  private final static String PERSON            = "PERSON";
  private final static String FUNCTION          = "FUNCTION";
  private final static String QUALIFIER         = "QUALIFIER";
  private final static String ACTIVENOW         = "IS_ACTIVE_NOW";

  public boolean isImplied() {
    // make this look in the database
    return false;
  }

  private Factory factory =
    null;

  /**
   * Method getFactory
   *
   *
   * @return
   *
   */
  public Factory getFactory() {
    return this.factory;
  }

  protected void setFactory(
          Factory factory) {
    this.factory = factory;
  }

  private java.util.Properties properties = null;

  /**
   * Method getProperties
   *
   *
   * @return
   *
   */
  public java.util.Properties getProperties() {
    return this.properties;
  }

  protected void setProperties(java.util.Properties properties) {
    this.properties = properties;
  }

  protected Object getProperty(String propertyName) {
    if ((null != propertyName) && (null != this.properties)) {
      Object obj = this.properties.get(propertyName);

      try {
        if (-1 != propertyName.toUpperCase().indexOf(PERSON)) {

          // make this call to get all the person properties

          ((Person) obj).isFoundInAuthorization();
        }
      }
      catch (Exception ex) {}

      return obj;
    }

    return null;
  }

  protected void setProperty(String propertyName, Object property) {
    if (null == this.properties) {
      this.properties = new java.util.Properties();
    }

    if ((null != this.properties) && (null != propertyName)
            && (null != property)) {
      this.properties.put(propertyName, property);
    }
  }

  /**
   * Method getId
   *
   *
   * @return
   *
   */
  public Object getId() {
    return getProperty(AUTHORIZATION_ID);
  }

  protected void setId(Object id) {
    setProperty(AUTHORIZATION_ID, id);
  }

  /**
   * Method getAgent
   *
   *
   * @return
   *
   */
  public org.okip.service.authorization.api.Agent getAgent() {
    return (org.okip.service.authorization.api.Agent) getProperty(PERSON);
  }

  protected void setPerson(org.okip.service.authorization.api.Agent person) {
    setProperty(PERSON, person);
  }

  /**
   * Method getFunction
   *
   *
   * @return
   *
   */
  public org.okip.service.authorization.api.Function getFunction() {
    return (org.okip.service.authorization.api.Function) getProperty(FUNCTION);
  }

  protected void setFunction(org.okip.service.authorization.api.Function function) {
    setProperty(FUNCTION, function);
  }

  /**
   * Method getQualifier
   *
   *
   * @return
   *
   */
  public org.okip.service.authorization.api.Qualifier getQualifier() {
    return (org.okip.service.authorization.api.Qualifier) getProperty(QUALIFIER);
  }

  protected void setQualifier(org.okip.service.authorization.api.Qualifier qualifier) {
    setProperty(QUALIFIER, qualifier);
  }

  /**
   * Method getEffectiveDate
   *
   *
   * @return
   *
   */
  public java.sql.Timestamp getEffectiveDate() {
    return (java.sql.Timestamp) getProperty(EFFECTIVE_DATE);
  }

  protected void setEffectiveDate(java.sql.Timestamp effectiveDate) {
    setProperty(EFFECTIVE_DATE, effectiveDate);
  }

  /**
   * Method getExpirationDate
   *
   *
   * @return
   *
   */
  public java.sql.Timestamp getExpirationDate() {
    return (java.sql.Timestamp) getProperty(EXPIRATION_DATE);
  }

  protected void setExpirationDate(java.sql.Timestamp expirationDate) {
    setProperty(EXPIRATION_DATE, expirationDate);
  }

  /**
   * Method isActiveNow
   *
   *
   * @return
   *
   */
  public boolean isActiveNow() {
    return ((Boolean) getProperty(ACTIVENOW)).booleanValue();
  }

  protected void setActiveNow(boolean activeNow) {
    setProperty(ACTIVENOW, new Boolean(activeNow));
  }

  /**
   * Method getModifiedBy
   *
   *
   * @return
   *
   */
  public String getModifiedBy() {
    return (String) getProperty(MODIFIED_BY);
  }

  protected void setModifiedBy(String modifiedBy) {
    setProperty(MODIFIED_BY, modifiedBy);
  }

  /**
   * Method getModifiedDate
   *
   *
   * @return
   *
   */
  public java.sql.Timestamp getModifiedDate() {
    return (java.sql.Timestamp) getProperty(MODIFIED_DATE);
  }

  protected void setModifiedDate(java.sql.Timestamp modifiedDate) {
    setProperty(MODIFIED_DATE, modifiedDate);
  }

  protected Authorization(
          Factory factory,
          java.util.Properties properties) {
    setFactory(factory);
    setProperties(properties);
  }

  protected Authorization(
          Factory factory,
          Object id, org.okip.service.authorization.api.Agent person,
          org.okip.service.authorization.api.Function function,
          org.okip.service.authorization.api.Qualifier qualifier,
          java.sql.Timestamp effectiveDate,
          java.sql.Timestamp expirationDate, boolean activeNow,
          String modifiedBy, java.sql.Timestamp modifiedDate
  ) {
    setFactory(factory);
    setId(id);
    setPerson(person);
    setFunction(function);
    setQualifier(qualifier);
    setEffectiveDate(effectiveDate);
    setExpirationDate(expirationDate);
    setActiveNow(activeNow);
    setModifiedBy(modifiedBy);
    setModifiedDate(modifiedDate);
  }

  /**
   * Method delete
   *
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public void delete()
  throws org.okip.service.authorization.api.AuthorizationException {
    try {
      if ((null != getFactory())
              && (null != getFactory().getConnection())
              && (null != getId())) {
        Connection connection =
          getFactory().getConnection();
        Object[]                                 args       = new Object[4];

        args[0] = (null == getId())
                  ? null
                  : getId();
        args[1] = (null == getFunction())
                  ? null
                  : ((null == getFunction().getKey())
                     ? null
                     : getFunction().getKey());
        args[2] = (null == getQualifier())
                  ? null
                  : ((null == getQualifier().getKey())
                     ? null
                     : getQualifier().getKey());
        args[3] = (null == getFactory())
                  ? null
                  : ((null == getFactory().getOwner())
                     ? null
                     : (((Person) (getFactory().getOwner().getProxy(Person.class))).getKerberosName()));

        int[] columnTypes = new int[4];

        columnTypes[0] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[1] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[2] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[3] = java.sql.DatabaseMetaData.procedureColumnIn;

        int[] dataTypes = new int[4];

        dataTypes[0] = java.sql.Types.NUMERIC;
        dataTypes[1] = java.sql.Types.VARCHAR;
        dataTypes[2] = java.sql.Types.VARCHAR;
        dataTypes[3] = java.sql.Types.VARCHAR;

        connection.callProcedure(DELETE, args, columnTypes, dataTypes);
        setId(null);
        setPerson(null);
        setFunction(null);
        setQualifier(null);
        setEffectiveDate(null);
        setExpirationDate(null);
        setActiveNow(true);
        setModifiedBy(null);
        setModifiedDate(null);

        return;
      }
    }
    catch (Exception ex) {
      throw new org.okip.service.authorization.api.AuthorizationException(
        ex.getMessage());
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.DELETEAUTHORIZATIONFAILED);
  }

  /**
   * Method update
   *
   *
   * @param person
   * @param function
   * @param qualifier
   * @param effectiveDate
   * @param expirationDate
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public void update(org.okip.service.authorization.api.Agent person,
                     org.okip.service.authorization.api.Function function,
                     org.okip.service.authorization.api.Qualifier qualifier,
                     java.sql.Timestamp effectiveDate,
                     java.sql.Timestamp expirationDate)
  throws org.okip.service.authorization.api.AuthorizationException {
    try {
      if ((null != getFactory())
              && (null != getFactory().getConnection())
              && (null != getId())) {
        Connection connection =
          getFactory().getConnection();
        Object[]                                 args       = new Object[9];

        args[0] = getId();
        args[1] = (null != function)
                  ? ((Function) function).getKey()
                  : ((Function) getFunction()).getKey();
        args[2] = (null != qualifier)
                  ? ((Qualifier) qualifier).getKey()
                  : ((Qualifier) getQualifier()).getKey();
        args[3] = (null != person)
                  ? ((Person) person).getKerberosName()
                  : ((Person) getAgent()).getKerberosName();
        args[4] = YES;
        args[5] = YES;
        args[6] = factory.createRolesDate(effectiveDate);
        args[7] = factory.createRolesDate(expirationDate);
        args[8] = ((null != getFactory().getOwner())
                   ? ((Person) getFactory().getOwner().getProxy(Person.class)).getKerberosName()
                   : null);

        int[] columnTypes = new int[11];

        columnTypes[0]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[1]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[2]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[3]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[4]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[5]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[6]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[7]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[8]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[9]  = java.sql.DatabaseMetaData.procedureColumnOut;
        columnTypes[10] = java.sql.DatabaseMetaData.procedureColumnOut;

        int[] dataTypes = new int[11];

        dataTypes[0]  = java.sql.Types.NUMERIC;
        dataTypes[1]  = java.sql.Types.VARCHAR;
        dataTypes[2]  = java.sql.Types.VARCHAR;
        dataTypes[3]  = java.sql.Types.VARCHAR;
        dataTypes[4]  = java.sql.Types.CHAR;
        dataTypes[5]  = java.sql.Types.VARCHAR;
        dataTypes[6]  = java.sql.Types.VARCHAR;
        dataTypes[7]  = java.sql.Types.VARCHAR;
        dataTypes[8]  = java.sql.Types.VARCHAR;
        dataTypes[9]  = java.sql.Types.VARCHAR;
        dataTypes[10] = java.sql.Types.VARCHAR;

        Table table =
          connection.callProcedure(UPDATE, args, columnTypes, dataTypes);

        if (null != table) {
          if (null != person) {
            setPerson(person);
          }

          if (null != function) {
            setFunction(function);
          }

          if (null != qualifier) {
            setQualifier(qualifier);
          }

          if (null != effectiveDate) {
            setEffectiveDate(effectiveDate);
          }

          if (null != expirationDate) {
            setExpirationDate(expirationDate);
          }

          Rows rows = table.getRows();

          if (rows.hasMoreRows()) {
            Object[] row = rows.nextRow();

            setModifiedBy((String) row[0]);
            setModifiedDate(
              getFactory().createSqlTimestamp((String) row[1]));
          }

          return;
        }
      }
    }
    catch (Exception ex) {
      throw new org.okip.service.authorization.api.AuthorizationException(
        ex.getMessage());
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.UPDATEAUTHORIZATIONFAILED);
  }

  /**
   * Method create
   *
   *
   * @param factory
   * @param person
   * @param function
   * @param qualifier
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public static org.okip.service.authorization.api.Authorization create(
          Factory factory,
          org.okip.service.authorization.api.Agent person,
          org.okip.service.authorization.api.Function function,
          org.okip.service.authorization.api.Qualifier qualifier)
  throws org.okip.service.authorization.api.AuthorizationException {
    return create(factory, person, function, qualifier,
                  new java.sql.Timestamp(new java.util.Date().getTime()),
                  null);
  }

  /**
   * Method create
   *
   *
   * @param factory
   * @param person
   * @param function
   * @param qualifier
   * @param effectiveDate
   * @param expirationDate
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public static org.okip.service.authorization.api.Authorization create(
          Factory factory,
          org.okip.service.authorization.api.Agent person,
          org.okip.service.authorization.api.Function function,
          org.okip.service.authorization.api.Qualifier qualifier,
          java.sql.Timestamp effectiveDate,
          java.sql.Timestamp expirationDate)
  throws org.okip.service.authorization.api.AuthorizationException {
    try {
      if ((null != factory) && (null != factory.getConnection())
              && (null != person)
              && (person instanceof Person)
              && (null != function)
              && (function instanceof Function)
              && (null != qualifier)
              && (qualifier instanceof Qualifier)
              && (null != effectiveDate)) {
        Connection connection =
          factory.getConnection();
        Object[]                                 args       = new Object[8];

        args[0] =
          ((Function) function).getKey();
        args[1] =
          ((Qualifier) qualifier).getKey();
        args[2] =
          ((Person) person).getKerberosName();
        args[3] = YES;
        args[4] = YES;
        args[5] = factory.createRolesDate(effectiveDate);
        args[6] = factory.createRolesDate(expirationDate);
        args[7] = ((null != factory.getOwner())
                   ? ((Person) factory.getOwner().getProxy(Person.class)).getKerberosName()
                   : null);

        int[] columnTypes = new int[11];

        columnTypes[0]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[1]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[2]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[3]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[4]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[5]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[6]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[7]  = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[8]  = java.sql.DatabaseMetaData.procedureColumnOut;
        columnTypes[9]  = java.sql.DatabaseMetaData.procedureColumnOut;
        columnTypes[10] = java.sql.DatabaseMetaData.procedureColumnOut;

        int[] dataTypes = new int[11];

        dataTypes[0]  = java.sql.Types.VARCHAR;
        dataTypes[1]  = java.sql.Types.VARCHAR;
        dataTypes[2]  = java.sql.Types.VARCHAR;
        dataTypes[3]  = java.sql.Types.CHAR;
        dataTypes[4]  = java.sql.Types.VARCHAR;
        dataTypes[5]  = java.sql.Types.VARCHAR;
        dataTypes[6]  = java.sql.Types.VARCHAR;
        dataTypes[7]  = java.sql.Types.VARCHAR;
        dataTypes[8]  = java.sql.Types.VARCHAR;
        dataTypes[9]  = java.sql.Types.VARCHAR;
        dataTypes[10] = java.sql.Types.NUMERIC;

        Table tab =
          connection.callProcedure(CREATE, args, columnTypes, dataTypes);

        if (null != tab) {
          Rows rows = tab.getRows();

          if (null != rows) {
            if (rows.hasMoreRows()) {
              Object[]                            row     = rows.nextRow();
              String                              modBy   = (String) row[0];
              java.sql.Timestamp                  modDate =
                factory.createSqlTimestamp((String) row[1]);
              Number                              id      = (Number) row[2];
              String                              sqlx    =
                getAuthorizationDetailSQL(id);
              Table table   =
                connection.executeQuery(sqlx);

              if (null != table) {
                java.util.Properties properties =
                  getPropertiesFromTable(factory, table);

                if (null != properties) {
                  Authorization authorization =
                    new Authorization(
                      factory, properties);

                  return (authorization);
                }
              }
            }
          }
        }
      }
    }
    catch (Exception ex) {
      throw new org.okip.service.authorization.api.AuthorizationException(
        ex.getMessage());
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.CREATEAUTHORIZATIONFAILED);
  }

  /**
   * Method isAuthorized
   *
   *
   * @param factory
   * @param person
   * @param function
   * @param qualifier
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public static boolean isAuthorized(
          Factory factory,
          org.okip.service.authorization.api.Agent person,
          org.okip.service.authorization.api.Function function,
          org.okip.service.authorization.api.Qualifier qualifier)
  throws org.okip.service.authorization.api.AuthorizationException {
    try {
      if (null != factory.getConnection()) {
        Connection connection =
          factory.getConnection();
        Object[]                                 args       = new Object[4];

        args[0] =
          ((Person) person).getKerberosName();
        args[1] =
          ((FunctionType) function.getFunctionType()).getKeyword();
        args[2] = function.getKey();
        args[3] = qualifier.getKey();

        int[] columnTypes = new int[4];

        columnTypes[0] = java.sql.DatabaseMetaData.procedureColumnReturn;
        columnTypes[1] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[2] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[3] = java.sql.DatabaseMetaData.procedureColumnIn;

        int[] dataTypes = new int[4];

        dataTypes[0] = java.sql.Types.VARCHAR;
        dataTypes[1] = java.sql.Types.VARCHAR;
        dataTypes[2] = java.sql.Types.VARCHAR;
        dataTypes[3] = java.sql.Types.VARCHAR;

        Table table =
          connection.callProcedure(IS_USER_AUTHORIZED, args, columnTypes,
                                   dataTypes);

        if (null != table) {
          Rows rows = table.getRows();

          if (null != rows) {
            if (rows.hasMoreRows()) {
              Object[] row = rows.nextRow();

              return ((String) row[0]).equals("Y");
            }
          }
        }
      }
    }
    catch (Exception ex) {
      throw new org.okip.service.authorization.api.AuthorizationException(
        ex.getMessage());
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.QUERYAUTHORIZATIONFAILED);
  }

  /**
   * Method isAuthorized
   *
   *
   * @param factory
   * @param person
   * @param function
   * @param qualifier
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public static boolean isAuthorized(
          Factory factory,
          org.okip.service.authorization.api.Agent person,
          org.okip.service.authorization.api.FunctionType functionType,
          org.okip.service.authorization.api.Qualifier qualifier)
  throws org.okip.service.authorization.api.AuthorizationException {
    try {
      if (null != factory.getConnection()) {
        Connection connection =
          factory.getConnection();
        Object[]                                 args       = new Object[4];

        args[0] =
          ((Person) person).getKerberosName();
        args[1] = functionType;
        args[2] = "";
        args[3] = qualifier.getKey();

        int[] columnTypes = new int[4];

        columnTypes[0] = java.sql.DatabaseMetaData.procedureColumnReturn;
        columnTypes[1] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[2] = java.sql.DatabaseMetaData.procedureColumnIn;
        columnTypes[3] = java.sql.DatabaseMetaData.procedureColumnIn;

        int[] dataTypes = new int[4];

        dataTypes[0] = java.sql.Types.VARCHAR;
        dataTypes[1] = java.sql.Types.VARCHAR;
        dataTypes[2] = java.sql.Types.VARCHAR;
        dataTypes[3] = java.sql.Types.VARCHAR;

        Table table =
          connection.callProcedure(IS_USER_AUTHORIZED, args, columnTypes,
                                   dataTypes);

        if (null != table) {
          Rows rows = table.getRows();

          if (null != rows) {
            if (rows.hasMoreRows()) {
              Object[] row = rows.nextRow();

              return ((String) row[0]).equals("Y");
            }
          }
        }
      }
    }
    catch (Exception ex) {
      throw new org.okip.service.authorization.api.AuthorizationException(
        ex.getMessage());
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.QUERYAUTHORIZATIONFAILED);
  }

  private static String getAuthorizationDetailSQL(Number id)
  throws org.okip.service.authorization.api.AuthorizationException {
    if (null != id) {
      String sql = "select";

      sql += " authorization_id, function_id, qualifier_id,";
      sql += " kerberos_name, function_name, qualifier_name,";
      sql += " function_category, qualifier_code,";
      sql += " modified_by, modified_date,";
      sql += " do_function, grant_and_view,";
      sql += " effective_date, expiration_date";
      sql += " from authorization";
      sql += " where authorization_id = '" + id + "'";

      return sql;
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.NULLARGUMENT);
  }

  private static Object getFieldFromTable(String fieldName,
                                          String[] columnNames, Object[] row)
  throws org.okip.service.authorization.api.AuthorizationException {
    if ((null != columnNames) && (null != row)) {
      int col = -1;

      for (int i = 0; columnNames.length != i; i++) {
        if (fieldName.equals(columnNames[i])) {
          col = i;

          break;
        }
      }

      if (-1 != col) {
        return row[col];
      }
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.AUTHORIZATIONFIELDDOESNOTEXIST);
  }

  private static java.util.Properties getPropertiesFromTable(
          Factory factory,
          Table table)
  throws org.okip.service.authorization.api.AuthorizationException {
    if (null != table) {
      Object                             functionId          = null;
      String                             functionTypeStr = null;
      String                             kerberosName        = null;
      String                             functionName        = null;
      Object                             qualifierId         = null;
      String                             qualifierCode       = null;
      String                             qualifierName       = null;
      Rows rows                =
        table.getRows();

      if (rows.hasMoreRows()) {
        Object[]             row         = rows.nextRow();
        String[]             columnNames = rows.getColumnNames();
        java.util.Properties properties  = new java.util.Properties();

        for (int i = 0; columnNames.length != i; i++) {
          if ((null != columnNames[i]) && (null != row[i])
                  &&!(columnNames[i].equals(""))
                  &&!(columnNames[i].equalsIgnoreCase("NULL"))) {
            if (columnNames[i].equals("KERBEROS_NAME")) {
              kerberosName = (String) row[i];

              properties.put(columnNames[i], row[i]);
            }
            else if (columnNames[i].equals("FUNCTION_CATEGORY")) {
              functionTypeStr = (String) row[i];

              properties.put(columnNames[i], row[i]);
            }
            else if (columnNames[i].equals("FUNCTION_NAME")) {
              functionName = (String) row[i];

              properties.put(columnNames[i], row[i]);
            }
            else if (columnNames[i].equals("QUALIFIER_CODE")) {
              qualifierCode = (String) row[i];

              properties.put(columnNames[i], row[i]);
            }
            else if (columnNames[i].equals("QUALIFIER_NAME")) {
              qualifierName = (String) row[i];

              properties.put(columnNames[i], row[i]);
            }
            else if (columnNames[i].equals("IS_ACTIVE_NOW")) {
              properties.put(columnNames[i], new Boolean("Y".equals((String) row[i])));
            }
            else if (columnNames[i].equals("AUTHORIZATION_ID")) {
              properties.put(columnNames[i], row[i]);
              properties.put(columnNames[i], row[i]);
            }
            else if (columnNames[i].equals("FUNCTION_ID")) {
              functionId = row[i];

              properties.put(columnNames[i], row[i]);
            }
            else if (columnNames[i].equals("QUALIFIER_ID")) {
              qualifierId = row[i];

              properties.put(columnNames[i], row[i]);
            }
            else {
              properties.put(columnNames[i], row[i]);
            }
          }
        }

        FunctionType functionType =
          new FunctionType(factory,
            functionTypeStr, null);

        Function         function =
          new Function(factory, functionName, null, functionType, null);

        properties.put("FUNCTION", function);

        Qualifier qualifier =
          new Qualifier(factory,
            (java.io.Serializable)qualifierId, qualifierCode, qualifierName, null);

        properties.put("QUALIFIER", qualifier);

        Person person =
          new Person( factory, kerberosName, null, null, null, null, null);

        properties.put("PERSON", person);

        return properties;
      }
    }

    return null;
  }
}
