package edu.mit.is.service.authorization;

public class AuthorizationsIterator
implements org.okip.service.authorization.api.AuthorizationsIterator {

  private static final String   ALGORITHM_SIMPLE =
    "SIMPLE";
  private static final String   ALGORITHM_F_WITH_Q =
    "F_WITH_Q";
  private static final String   ALGORITHM_WHO_CAN_DO =
    "WHO_CAN_DO";
  private static final String   GETAUTHORIZATIONSQUERYSQL =
    "ROLESAPI_GET_SQL_AUTH1";
  private static final String   DONT_EXPAND_FUNCTIONS =
    "N";
  private static final String   DONT_EXPAND_QUALIFIERS =
    "N";

  protected Rows    rows   =
    null;
  protected Factory factory =
    null;

  /**
   * Method hasNext
   *
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public boolean hasNext()
  throws org.okip.service.authorization.api.AuthorizationException {
    if (null != this.rows) {
      return this.rows.hasMoreRows();
    }

    return false;
  }

  /**
   * Method next
   *
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public org.okip.service.authorization.api.Authorization next()
  throws org.okip.service.authorization.api.AuthorizationException {
    if (null != this.rows) {
      if (this.rows.hasMoreRows()) {
        return getAuthorization(this.rows.getColumnNames(),
        this.rows.nextRow());
      }
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.AUTHORIZATIONENUMERATIONFAILED);
  }

  private boolean hideImpliedAuthorizations = false ;

  /**
   * Method hideImpliedAuthorizations
   *
   */
  public void hideImpliedAuthorizations() {
    this.hideImpliedAuthorizations = true;
  }

  /**
   * Method showImpliedAuthorizations
   *
   */
  public void showImpliedAuthorizations() {
    this.hideImpliedAuthorizations = false;
  }

  /**
   * Method getAuthorizations
   *
   *
   * @param Factory
   * @param Person
   * @param FunctionType
   * @param boolean - isActiveNow
   * @param int - start
   * @param int - number
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public static org.okip.service.authorization.api.AuthorizationsIterator getAuthorizations(
    Factory factory,
    org.okip.service.authorization.api.Agent person,
    org.okip.service.authorization.api.FunctionType functionType,
    boolean isActiveNow)
  throws org.okip.service.authorization.api.AuthorizationException {
    return getAuthorizationsInternal
    (factory, ALGORITHM_SIMPLE,
      ((Person)person).getKerberosName(),
      (String) null, (String) null,
      (java.io.Serializable) null, (String) null, (String) null,
      (isActiveNow ? "Y" : "N"), "Y" );
  }

  /**
   * Given a Function and a Qualifier
   * returns an enumeration of all AuthorizationsIterator that would allow people
   * to do the Function with Qualifier. This method differs from the simple
   * form of getAuthorizations in that this method looks for any Authorization
   * that permits doing the Function with the Qualifier even if the Authorization's
   * Qualifier happens to be a parent of this Qualifier argument.
   */
  public static org.okip.service.authorization.api.AuthorizationsIterator getAuthorizationsForDoingFWithQ(
    Factory factory,
    org.okip.service.authorization.api.Function function,
    org.okip.service.authorization.api.Qualifier qualifier,
    boolean isActiveNow)
  throws org.okip.service.authorization.api.AuthorizationException {
    return getAuthorizationsInternal(factory, ALGORITHM_F_WITH_Q,
      null, function, qualifier, isActiveNow,
      true);
  }

  /**
   * Given a FunctionType and a Qualifier
   * returns an enumeration of all AuthorizationsIterator that would allow people
   * to do Functions in the FunctionType with Qualifier. This method differs
   * from getAuthorizations in that this method looks for any Authorization
   * that permits doing the Function with the Qualifier even if the
   * Authorization's Qualifier happens to be a parent of the Qualifier argument.
   */
  public static org.okip.service.authorization.api.AuthorizationsIterator getAuthorizationsForDoingFWithQ(
    Factory factory,
    org.okip.service.authorization.api.FunctionType functionType,
    org.okip.service.authorization.api.Qualifier qualifier,
    boolean isActiveNow)
  throws org.okip.service.authorization.api.AuthorizationException {
    return getAuthorizationsInternal(factory, ALGORITHM_F_WITH_Q,
      (String) null,
      (String) null,
      (String) ((null == functionType)
        ? null
        : ((FunctionType)functionType).getKeyword()),
      (java.io.Serializable) ((null == qualifier)
        ? null
        : ((Qualifier) qualifier).getId()),
      (String) ((null == qualifier)
        ? null
        : (String) qualifier.getKey()),
      (String) ((null == qualifier)
        ? null
        : ((null == qualifier.getQualifierType())
          ? null
          : ((QualifierType)qualifier.getQualifierType()).getKeyword())),
      (String) (isActiveNow
        ? "Y"
        : "N"),
      (String) DONT_EXPAND_QUALIFIERS);
  }

  /**
   * Given at a Person, a Function, and a Qualifier
   * returns an enumeration of matching authorizations.
   */
  public static org.okip.service.authorization.api.AuthorizationsIterator getAuthorizations(
    Factory factory,
    org.okip.service.authorization.api.Agent person,
    org.okip.service.authorization.api.Function function,
    org.okip.service.authorization.api.Qualifier qualifier,
    boolean isActiveNow,
    boolean expandQualifiers)
  throws org.okip.service.authorization.api.AuthorizationException {
    return getAuthorizationsInternal(factory, ALGORITHM_SIMPLE,
        person, function, qualifier,
        isActiveNow,
        expandQualifiers);
  }

  /**
   * Given at a Person, a FunctionType, and a Qualifier
   * returns an enumeration of matching authorizations.
   */
  public static org.okip.service.authorization.api.AuthorizationsIterator getAuthorizations(
    Factory factory,
    org.okip.service.authorization.api.Agent person,
    org.okip.service.authorization.api.FunctionType functionType,
    org.okip.service.authorization.api.Qualifier qualifier,
    boolean isActiveNow,
    boolean expandQualifiers)
  throws org.okip.service.authorization.api.AuthorizationException {
    return getAuthorizationsInternal(
	  factory,
	  ALGORITHM_SIMPLE,
      (String) ((null == person)
        ? null
        : ((Person) person).getKerberosName()),
      (String) null,
      (String) ((null == functionType)
        ? null
        : ((FunctionType)functionType).getKeyword()),
      (java.io.Serializable) ((null == qualifier)
        ? null
        : ((Qualifier) qualifier).getId()),
      (String) ((null == qualifier)
        ? null
        : (String) qualifier.getKey()),
      (String) ((null == qualifier)
        ? null
        : ((null == qualifier.getQualifierType())
          ? null
          : ((QualifierType)qualifier.getQualifierType()).getKeyword())),
      (String) (isActiveNow
        ? "Y"
        : "N"),
      (expandQualifiers
        ? "Y"
        : "N"));
  }

  /**
   *
   * @param factory
   * @param isActiveNow
   * @param expandQualifiers
   * @return an enumeration of matching authorizations
   * (should return 1 authorization, unless user has requested
   * expansion by Functions or Qualifiers).
   */
  public static org.okip.service.authorization.api.AuthorizationsIterator getAuthorizations(
    Factory factory,
    boolean isActiveNow,
    boolean expandQualifiers)
  throws org.okip.service.authorization.api.AuthorizationException {
    return getAuthorizationsInternal(factory, ALGORITHM_SIMPLE,
        null, null, null,
        isActiveNow,
        expandQualifiers);
  }

  private static org.okip.service.authorization.api.AuthorizationsIterator getAuthorizationsInternal(
    Factory factory,
    String algorithm,
    org.okip.service.authorization.api.Agent person,
    org.okip.service.authorization.api.Function function,
    org.okip.service.authorization.api.Qualifier qualifier,
    boolean isActiveNow,
    boolean expandQualifiers)
  throws org.okip.service.authorization.api.AuthorizationException {
    String kerberosName =
      (null == person)
      ? null
      : ((Person) person).getKerberosName();
    String functionType =
      (null == function)
      ? null
      : ((null == function.getFunctionType())
         ? null
         : ((FunctionType)function.getFunctionType()).getKeyword());
    String functionName =
      (null == function)
      ? null
      : (String) function.getKey();
    String qualifierType =
      (null == qualifier)
      ? null
      : ((null == qualifier.getQualifierType())
        ? null
        : ((QualifierType)qualifier.getQualifierType()).getKeyword());
    String qualifierCode =
      (null == qualifier)
      ? null
      : (String) qualifier.getKey();
    java.io.Serializable qualifierId =
      (null == qualifier)
      ? null
      : ((Qualifier) qualifier).getId();
    String expandQualifiersStr =
      (expandQualifiers)
      ? "N"
      : (expandQualifiers
        ? "Y"
        : "N");
    String isActiveNowStr =
      (isActiveNow)
      ? "Y"
        : (isActiveNow
        ? "Y"
        : "N");

    return getAuthorizationsInternal(factory, algorithm,
        kerberosName,
        functionName,
        functionType, qualifierId,
        qualifierCode, qualifierType,
        isActiveNowStr,
        expandQualifiersStr);
  }

  private static org.okip.service.authorization.api.AuthorizationsIterator getAuthorizationsInternal(
    Factory factory,
    String algorithm, String kerberosName,
    String functionName, String functionType,
    java.io.Serializable qualifierId, String qualifierCode, String qualifierType,
    String isActiveNowStr,
    String expandQualifiersStr)
  throws org.okip.service.authorization.api.AuthorizationException {
    try {
      if ((null != isActiveNowStr)
        && (null != expandQualifiersStr)) {
          String     sqlQuery       =
            getAuthSQL(factory, algorithm, expandQualifiersStr,
              isActiveNowStr, functionType,
              functionName, qualifierType, qualifierCode,
              qualifierId, kerberosName);
          org.okip.service.authorization.api.AuthorizationsIterator authorizations =
            getAuthorizations(factory, sqlQuery);

          if (!authorizations.hasNext()) {
            org.okip.service.authorization.api.Agent person = null;

            if (null != kerberosName) {
              person =
                new Person(factory, kerberosName, null, null, null, null, null);
              if (null != person) {
                if (!person.isFoundInAuthorization()) {
                  throw new org.okip.service.authorization.api.AuthorizationException(
                    org.okip.service.authorization.api.AuthorizationException.AGENTNOTFOUNDINAUTHORIZATION);
                }
              }
            }

            org.okip.service.authorization.api.Function function = null;

            if ((null != functionName)
              && ((null != functionType)
              || (null != qualifierType))) {
                org.okip.service.authorization.api.FunctionType fc = null;

                if (null != functionType) {
                  fc = new FunctionType(
                    factory, functionType, null);
                }

                org.okip.service.authorization.api.QualifierType qt = null;

                if (null != qualifierType) {
                  qt =
                    new QualifierType(
                      factory, qualifierType, null);
                }

                function =
                  new Function(factory,
                    functionName, (String) null, fc, qt);

                if (!factory.isFunctionFoundInAuthorization(
                  function)) {
                    throw new org.okip.service.authorization.api.AuthorizationException(
                      org.okip.service.authorization.api.AuthorizationException.FUNCTIONNOTFOUNDINAUTHORIZATION);
                }
              }

              org.okip.service.authorization.api.Qualifier qualifier = null;

              if (null != qualifierCode) {
                org.okip.service.authorization.api.QualifierType qt = null;

                if (null != qualifierType) {
                  qt =
                    new QualifierType(
                      factory, qualifierType, null);
                }

                qualifier =
                  new Qualifier(factory,
                    qualifierCode, (String) null, qt);

                if (!factory.isQualifierFoundInAuthorization(
                  qualifier)) {
                    throw new org.okip.service.authorization.api.AuthorizationException(
                      org.okip.service.authorization.api.AuthorizationException.QUALIFIERNOTFOUNDINAUTHORIZATION);
                }
              }
        }

        return authorizations;
      }

      throw new org.okip.service.authorization.api.AuthorizationException(
        org.okip.service.authorization.api.AuthorizationException.QUERYAUTHORIZATIONFAILED);
    }
    catch (Exception ex) {
      throw new org.okip.service.authorization.api.AuthorizationException(
        new String(
          org.okip.service.authorization.api.AuthorizationException.QUERYAUTHORIZATIONFAILED
            + ex.getMessage()));
    }
  }

  protected static org.okip.service.authorization.api.AuthorizationsIterator getAuthorizations(
    Factory factory,
    String sqlQuery)
  throws org.okip.service.authorization.api.AuthorizationException {
    try {
      if ((null != factory) && (null != sqlQuery)) {
        Connection      connection     =
          factory.getConnection();
        Table     table    =
          connection.executeQuery(sqlQuery);
        AuthorizationsIterator authorizations =
          new AuthorizationsIterator();

        authorizations.factory = factory;
        authorizations.rows   = table.getRows();

        return authorizations;
      }
    }
    catch (Exception ex) {
      throw new org.okip.service.authorization.api.AuthorizationException(
        ex.getMessage());
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.QUERYAUTHORIZATIONFAILED);
  }

  /**
   * @param algorithm is "SIMPLE" or "F_WITH_Q" or "WHO_CAN_DO"
   * @param expandQualifiers is either "Y" or "N", default is "N"
   * @param isActiveNow is either "Y" or "N", default is "N"
   */
  private static String getAuthSQL(
    Factory factory,
    String algorithm, String expandQualifiers, String isActiveNow,
    String functionType,
    String functionName, String qualifierType,
    String qualifierCode, java.io.Serializable qualifierId, String kerberosName)
  throws org.okip.service.authorization.api.AuthorizationException {
    if (null != factory) {
      Connection connection =
        factory.getConnection();
      Object[]   args       = new Object[11];

      args[0]  = algorithm;
      args[1]  = expandQualifiers;
      args[2]  = isActiveNow;
      args[3]  = functionType;
      args[4]  = functionName;
      args[5]  = qualifierType;
      args[6]  = qualifierCode;
      args[7]  = (null == qualifierId)
                 ? ""
                 : qualifierId.toString();
      args[8] = kerberosName;

      int[] columnTypes = new int[12];

      columnTypes[0]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[1]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[2]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[3]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[4]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[5]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[6]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[7]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[8]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[9]  = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[10] = java.sql.DatabaseMetaData.procedureColumnIn;
      columnTypes[11] = java.sql.DatabaseMetaData.procedureColumnOut;

      int[] dataTypes = new int[12];

      dataTypes[0]  = java.sql.Types.VARCHAR;
      dataTypes[1]  = java.sql.Types.VARCHAR;
      dataTypes[2]  = java.sql.Types.VARCHAR;
      dataTypes[3]  = java.sql.Types.VARCHAR;
      dataTypes[4]  = java.sql.Types.VARCHAR;
      dataTypes[5]  = java.sql.Types.VARCHAR;
      dataTypes[6]  = java.sql.Types.VARCHAR;
      dataTypes[7]  = java.sql.Types.VARCHAR;
      dataTypes[8]  = java.sql.Types.VARCHAR;
      dataTypes[9]  = java.sql.Types.VARCHAR;
      dataTypes[10] = java.sql.Types.VARCHAR;
      dataTypes[11] = java.sql.Types.VARCHAR;

      Table tab =
        connection.callProcedure(GETAUTHORIZATIONSQUERYSQL, args,
          columnTypes, dataTypes);

      if (null != tab) {
        if (null != tab.getRows()) {
          Rows rows = tab.getRows();

          if (rows.hasMoreRows()) {
            Object[] row = rows.nextRow();

            if (null != row) {
              String sql = (String) row[0];

              return sql;
            }
          }
        }
      }
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.AUTHORIZATIONENUMERATIONFAILED);
  }

  private org.okip.service.authorization.api.Authorization getAuthorization(
    String[] columnNames, Object[] row)
  throws org.okip.service.authorization.api.AuthorizationException {
    if ((null != columnNames) && (null != row)) {
      java.util.Properties properties    = new java.util.Properties();
      String   functionTypeStr = null;
      String   functionName  = null;
      java.io.Serializable   qualifierId   = null;
      String   qualifierCode       = null;
      String   qualifierName       = null;
      boolean  grantAuthorization  = true;
      boolean  isActiveNow   = true;
      java.io.Serializable authorizationId     = null;
      String   kerberosName  = null;

      for (int i = 0; columnNames.length != i; i++) {
        if (columnNames[i].equals("KERBEROS_NAME")) {
          kerberosName = (String) row[i];
        }
        else if (columnNames[i].equals("FUNCTION_CATEGORY")) {
          functionTypeStr = (String) row[i];
        }
        else if (columnNames[i].equals("FUNCTION_NAME")) {
          functionName = (String) row[i];
        }
        else if (columnNames[i].equals("QUALIFIER_CODE")) {
          qualifierCode = (String) row[i];
        }
        else if (columnNames[i].equals("QUALIFIER_NAME")) {
          qualifierName = (String) row[i];
        }
        else if (columnNames[i].equals("IS_ACTIVE_NOW")) {
          isActiveNow = ("Y".equals((String) row[i]));
        }
        else if (columnNames[i].equals("GRANT_AUTHORIZATION")) {
          grantAuthorization = ("Y".equals((String) row[i]));
        }
        else if (columnNames[i].equals("QUALIFIER_ID")) {
          qualifierId = (java.io.Serializable) row[i];
        }

      }

      FunctionType functionType =
        new FunctionType(
          this.factory, functionTypeStr, null);

      Function   function   =
        new Function(this.factory,
          functionName, null, functionType, null);

      Qualifier  qualifier  =
        new Qualifier(this.factory,
          qualifierId, qualifierCode, qualifierName,
          (org.okip.service.authorization.api.QualifierType) null);

      Person    person     =
        new Person(this.factory, kerberosName, null, null, null, null, null);

      properties.put("AUTHORIZATION_ID", authorizationId);
      properties.put("AGENT", person);
      properties.put("GRANT_AUTHROIZATION", new Boolean(grantAuthorization));
      properties.put("IS_ACTIVE_NOW", new Boolean(isActiveNow));
      properties.put("FUNCTION", function);
      properties.put("QUALIFIER", qualifier);

      return new Authorization(
        this.factory, properties);
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.AUTHORIZATIONENUMERATIONFAILED);
  }

}
