package edu.mit.is.service.authorization;

public class Connect
	extends	java.lang.Thread
	implements	java.lang.Cloneable
{
	private static final int MAXRETRIES = 3 ;

	protected String databaseURL = null ;
	protected String username = null ;
	protected String password = null ;
	protected java.sql.Connection conn = null ;

	public Connect
	( String driverName
	, String databaseURL
	, String username
	, String password
	)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		try {
			Class.forName( driverName ) ;
			this.databaseURL = databaseURL ;
			this.username = username ;
			this.password = password ;
		}
		catch(Exception ex) {
			throw new ConnectionException(ex.getMessage());
		}
	}

	public java.sql.Connection getConnection()
	{
		try
		{
			if( null == conn )
			{
				for( int i = 0 ; MAXRETRIES != i ; i ++ )
				{
					Connect clone = ( Connect ) this.clone() ;
					clone.start() ;

					clone.join( 30000 ) ; // wait 30 seconds for a timeout
					conn = clone.conn ;
					if( null != conn )
					{
						return conn ;
					}
				}
			}
			return conn ;
		}
		catch( Exception ex )
		{
			ex.printStackTrace() ;
			return null ;
		}
	}


	public void run()
	{
		try
		{
			conn = java.sql.DriverManager.getConnection
				( databaseURL , username , password ) ;
		}
		catch( Exception ex )
		{
			ex.printStackTrace() ;
		}
	}
}