package edu.mit.is.service.authorization;

public class Connection
implements java.io.Serializable {

	private static final String EXECUTEUPDATE = "executeUpdate" ;
	private static final String CALLPROCEDURE = "callProcedure" ;
	private static final String COLUMN_NAME = "COLUMN_NAME" ;
	private static final String COLUMN_TYPE = "COLUMN_TYPE" ;
	private static final String DATA_TYPE = "DATA_TYPE" ;
	private static final String SEQUENCE = "SEQUENCE" ;

	public Table getProcedures
		( String catalog
		, String schemaPattern
		, String procedureNamePattern
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		return Table.getProcedures
			( this
			, catalog
			, schemaPattern
			, procedureNamePattern
			) ;
	}

	public Table getProcedureColumns
		( String catalog
		, String schemaPattern
		, String procedureName
		, String columnNamePattern
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		return Table.getProcedureColumns
			( this
			, catalog
			, schemaPattern
			, procedureName
			, columnNamePattern
			) ;
	}

	public Table getTables()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		return Table.getTables
			( this
			) ;
	}

	public Table getTables
		( String catalog
		, String schemaPattern
		, String tableNamePattern
		, String[] tableTypes
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		return Table.getTables
			( this
			, catalog
			, schemaPattern
			, tableNamePattern
			, tableTypes
			) ;
	}

	public Table executeQuery( String sql )
		throws org.okip.service.authorization.api.AuthorizationException
	{
		return Table.executeQuery
			( this
			, sql
			) ;
	}

	public Table executeQuery
		( String sql
		, Object[] objs
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		return Table.executeQuery
			( this
			, sql
			, objs
			) ;
	}

	public Table executeQuery
		( String sql
		, Object[] objs
		, int[] targetSqlTypes
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		return Table.executeQuery
			( this
			, sql
			, objs
			, targetSqlTypes
			) ;
	}

	public Table executeQuery
		( String sql
		, Object[] objs
		, int[] targetSqlTypes
		, int[] scales
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		return Table.executeQuery
			( this
			, sql
			, objs
			, targetSqlTypes
			, scales
			) ;
	}

	public int executeUpdate( String sql )
		throws org.okip.service.authorization.api.AuthorizationException
	{
//		if( hasClient() )
//		{
//			return executeUpdateRemotely( sql ) ;
//		}
		return executeUpdateLocally( sql ) ;
	}
/*
	private int executeUpdateRemotely( String sql )
		throws org.okip.service.authorization.api.AuthorizationException
	{
		Class[] argsTypes = new Class[ 1 ] ;
		Object[] args = new Object[ 1 ] ;
		argsTypes[ 0 ] = sql.getClass() ;
		args[ 0 ] = sql ;
		Number num = ( Number ) getClient().invoke( this , EXECUTEUPDATE , argsTypes , args ) ;
		return num.intValue() ;
	}
*/
	public int executeUpdateLocally( String sql )
		throws org.okip.service.authorization.api.AuthorizationException
	{
		java.sql.Statement statement = null ;
		try
		{
			java.sql.Connection conn = getConnection() ;
			statement = conn.createStatement() ;
			int rowCount = statement.executeUpdate( sql ) ;
			statement.close() ; statement = null ;
			return rowCount ;
		}
		catch( Exception ex )
		{
			resetConnection();
			throw new ConnectionException(ex.getMessage());
		}
	}

	public int executeUpdate( String sql , Object[] objs )
		throws org.okip.service.authorization.api.AuthorizationException
	{
//		if( hasClient() )
//		{
//			return executeUpdateRemotely( sql , objs ) ;
//		}
		return executeUpdateLocally( sql , objs ) ;
	}
/*
	private int executeUpdateRemotely( String sql , Object[] objs )
		throws org.okip.service.authorization.api.AuthorizationException
	{
		Class[] argsTypes = new Class[ 2 ] ;
		Object[] args = new Object[ 2 ] ;
		argsTypes[ 0 ] = sql.getClass() ;
		argsTypes[ 1 ] = objs.getClass() ;
		args[ 0 ] = sql ;
		args[ 1 ] = objs ;
		Number num = ( Number ) getClient().invoke( this , EXECUTEUPDATE , argsTypes , args ) ;
		return num.intValue() ;
	}
*/
	public int executeUpdateLocally( String sql , Object[] objs )
		throws org.okip.service.authorization.api.AuthorizationException
	{
		java.sql.PreparedStatement statement = null ;
		try
		{
			java.sql.Connection conn = getConnection() ;
			statement = conn.prepareStatement( sql ) ;
			for( int i = 0 ; objs.length != i ; i ++ )
			{
				statement.setObject( i + 1 , objs[ i ] ) ;
			}
			int rowCount = statement.executeUpdate() ;
			statement.close() ; statement = null ;
			return rowCount ;
		}
		catch( Exception ex )
		{
			resetConnection();
			throw new ConnectionException(ex.getMessage());
		}
	}

	public int executeUpdate( String sql , Object[] objs , int[] targetSqlTypes )
		throws org.okip.service.authorization.api.AuthorizationException
	{
//		if( hasClient() )
//		{
//			return executeUpdateRemotely( sql , objs , targetSqlTypes ) ;
//		}
		return executeUpdateLocally( sql , objs  , targetSqlTypes ) ;
	}
/*
	private int executeUpdateRemotely
		( String sql
		, Object[] objs
		, int[] targetSqlTypes
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		Class[] argsTypes = new Class[ 3 ] ;
		Object[] args = new Object[ 3 ] ;
		argsTypes[ 0 ] = sql.getClass() ;
		argsTypes[ 1 ] = objs.getClass() ;
		argsTypes[ 2 ] = targetSqlTypes.getClass() ;
		args[ 0 ] = sql ;
		args[ 1 ] = objs ;
		args[ 2 ] = targetSqlTypes ;
		Number num = ( Number ) getClient().invoke( this , EXECUTEUPDATE , argsTypes , args ) ;
		return num.intValue() ;
	}
*/
	public int executeUpdateLocally( String sql , Object[] objs , int[] targetSqlTypes )
		throws org.okip.service.authorization.api.AuthorizationException
	{
		java.sql.PreparedStatement statement = null ;
		try
		{
			java.sql.Connection conn = getConnection() ;
			statement = conn.prepareStatement( sql ) ;
			for( int i = 0 ; objs.length != i ; i ++ )
			{
				statement.setObject( i + 1 , objs[ i ] , targetSqlTypes[ i ] ) ;
			}
			int rowCount = statement.executeUpdate() ;
			statement.close() ; statement = null ;
			return rowCount ;
		}
		catch( Exception ex )
		{
			resetConnection();
			throw new ConnectionException(ex.getMessage());
		}
	}

	public int executeUpdate( String sql , Object[] objs , int[] targetSqlTypes , int[] scales )
		throws org.okip.service.authorization.api.AuthorizationException
	{
//		if( hasClient() )
//		{
//			return executeUpdateRemotely( sql , objs , targetSqlTypes , scales ) ;
//		}
		return executeUpdateLocally( sql , objs  , targetSqlTypes , scales ) ;
	}
/*
	private int executeUpdateRemotely
		( String sql
		, Object[] objs
		, int[] targetSqlTypes
		, int[] scales
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		Class[] argsTypes = new Class[ 4 ] ;
		Object[] args = new Object[ 4 ] ;
		argsTypes[ 0 ] = sql.getClass() ;
		argsTypes[ 1 ] = objs.getClass() ;
		argsTypes[ 2 ] = targetSqlTypes.getClass() ;
		argsTypes[ 3 ] = scales.getClass() ;
		args[ 0 ] = sql ;
		args[ 1 ] = objs ;
		args[ 2 ] = targetSqlTypes ;
		args[ 3 ] = scales ;
		Number num = ( Number ) getClient().invoke( this , EXECUTEUPDATE , argsTypes , args ) ;
		return num.intValue() ;
	}
*/
	public int executeUpdateLocally( String sql , Object[] objs , int[] targetSqlTypes , int [] scales )
		throws org.okip.service.authorization.api.AuthorizationException
	{
		java.sql.PreparedStatement statement = null ;
		try
		{
			java.sql.Connection conn = getConnection() ;
			statement = conn.prepareStatement( sql ) ;
			for( int i = 0 ; objs.length != i ; i ++ )
			{
				statement.setObject( i + 1 , objs[ i ] , targetSqlTypes[ i ] , scales[ i ] ) ;
			}
			int rowCount = statement.executeUpdate() ;
			statement.close() ; statement = null ;
			return rowCount ;
		}
		catch( Exception ex )
		{
			resetConnection();
			throw new ConnectionException(ex.getMessage());
		}
	}

	public void commit()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		try
		{
			if( ! getAutoCommit().booleanValue() )
			{
				getConnection().commit() ;
			}
		}
		catch( Exception ex )
		{
			resetConnection() ;
			throw new ConnectionException(ex.getMessage());
		}
	}

	public void rollback()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		try
		{
			if( ! getAutoCommit().booleanValue() )
			{
				getConnection().rollback() ;
			}
		}
		catch( Exception ex )
		{
			resetConnection() ;
			throw new ConnectionException(ex.getMessage());
		}
	}

	public Table callProcedure
		( String procedureName
		, Object[] args
		, int[] columnTypes
		, int[] dataTypes
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		return callProcedure
			( ( String ) null
			, ( String ) null
			, procedureName
			, ( String ) null
			, args
			, columnTypes
			, dataTypes
			) ;
	}

	public Table callProcedure
		( String catalog
		, String schemaPattern
		, String procedureName
		, String columnNamePattern
		, Object[] args
		, int[] columnTypes
		, int[] dataTypes
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
//		if( hasClient() )
//		{
//			return callProcedureRemotely
//				( catalog
//				, schemaPattern
//				, procedureName
//				, columnNamePattern
//				, args
//				, columnTypes
//				, dataTypes
//				) ;
//		}
		return callProcedureLocally
			( catalog
			, schemaPattern
			, procedureName
			, columnNamePattern
			, args
			, columnTypes
			, dataTypes
			) ;
	}
/*
	private Table callProcedureRemotely
		( String catalog
		, String schemaPattern
		, String procedureName
		, String columnNamePattern
		, Object[] arguments
		, int[] columnTypes
		, int[] dataTypes
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		Class[] argsTypes = new Class[ 7 ] ;
		Object[] args = new Object[ 7 ] ;
		argsTypes[ 0 ]
			= ( null != catalog ) ? catalog.getClass() : null ;
		argsTypes[ 1 ]
			= ( null != schemaPattern ) ? schemaPattern.getClass() : null ;
		argsTypes[ 2 ]
			= ( null != procedureName ) ? procedureName.getClass() : null ;
		argsTypes[ 3 ]
			= ( null != columnNamePattern ) ? columnNamePattern.getClass() : null ;
		argsTypes[ 4 ]
			= ( null != arguments ) ? arguments.getClass() : null ;
		argsTypes[ 5 ]
			= ( null != columnTypes ) ? columnTypes.getClass() : null ;
		argsTypes[ 6 ]
			= ( null != dataTypes ) ? dataTypes.getClass() : null ;
		args[ 0 ] = catalog ;
		args[ 1 ] = schemaPattern ;
		args[ 2 ] = procedureName ;
		args[ 3 ] = columnNamePattern ;
		args[ 4 ] = arguments ;
		args[ 5 ] = columnTypes ;
		args[ 6 ] = dataTypes ;
		return ( Table ) getClient().invoke( this , CALLPROCEDURE , argsTypes , args ) ;
	}
*/
	public Table callProcedureLocally
		( String catalog
		, String schemaPattern
		, String procedureName
		, String columnNamePattern
		, Object[] args
		, int[] columnTypes
		, int[] dataTypes
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		java.sql.CallableStatement stmt = null ;
		try
		{
			if
			(  ( null != procedureName )
			&& ( null != args )
			&& ( null != columnTypes )
			&& ( null != dataTypes )
			)
			{
				stmt
					= setStatement
						( catalog
						, schemaPattern
						, procedureName
						, columnNamePattern
						, args
						, columnTypes
						, dataTypes
						) ;
				stmt.execute() ;
				Table table = createTable( stmt , columnTypes , dataTypes ) ;
				stmt.close() ;
				return table ;
			}
			throw new ConnectionException
				( ConnectionException.INVALIDARGUMENTS ) ;
		}
		catch( Exception ex )
		{
			resetConnection() ;
			throw new ConnectionException(ex.getMessage());
		}
	}

	private java.sql.CallableStatement setStatement
		( String catalog
		, String schemaPattern
		, String procedureName
		, String columnNamePattern
		, Object[] args
		, int[] columnTypes
		, int[] dataTypes
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		try {
			String ret = "" ;
			String params = "" ;
			int paramCount = 0 ;
			for( int i = 0 ; columnTypes.length != i ; i ++ )
			{
				int columnType = columnTypes[ i ] ;
				switch( columnType )
				{
				case java.sql.DatabaseMetaData.procedureColumnIn:
				case java.sql.DatabaseMetaData.procedureColumnInOut:
				case java.sql.DatabaseMetaData.procedureColumnOut:
				case java.sql.DatabaseMetaData.procedureColumnResult:
					if( 0 != paramCount ) { params += ", " ; }
					params += "?" ;
					paramCount ++ ;
					break ;
				case java.sql.DatabaseMetaData.procedureColumnReturn:
					ret = "?=" ;
					break ;
				}
			}
			String sql = "{" + ret + "call " + procedureName + "(" + params + ")}" ;
			java.sql.CallableStatement stmt = getConnection().prepareCall( sql ) ;
			int index = 0 ;
			int sequence = 1 ;
			for( int i = 0 ; columnTypes.length != i ; i ++ )
			{
				int columnType = columnTypes[ i ] ;
				int datatype = dataTypes[ i ] ;
				Object arg = null ;
				if( ( null != args ) && ( args.length != index ) )
				{
					arg = args[ index ++ ] ;
				}
				if( null == arg )
				{
					arg = "" ;
				}
				switch( columnType )
				{
				case java.sql.DatabaseMetaData.procedureColumnIn:
					if( args.length != i )
					{
						if( datatype == java.sql.Types.OTHER )
						{
							stmt.setObject( sequence , arg , java.sql.Types.FLOAT , 0 ) ;
						}
						else
						{
							stmt.setObject( sequence , arg , datatype ) ;
						}
						sequence ++ ;
					}
					break ;
				case java.sql.DatabaseMetaData.procedureColumnInOut:
					if( datatype == java.sql.Types.OTHER )
					{
						stmt.setObject( sequence , arg , java.sql.Types.FLOAT , 0 ) ;
						stmt.registerOutParameter( sequence , java.sql.Types.FLOAT , 0 ) ;
					}
					else
					{
						stmt.setObject( sequence , arg , datatype ) ;
						stmt.registerOutParameter( sequence , datatype ) ;
					}
					sequence ++ ;
					break ;
				case java.sql.DatabaseMetaData.procedureColumnResult:
				case java.sql.DatabaseMetaData.procedureColumnReturn:
				case java.sql.DatabaseMetaData.procedureColumnOut:
					if( datatype == java.sql.Types.OTHER )
					{
						stmt.registerOutParameter( sequence , java.sql.Types.FLOAT , 0 ) ;
					}
					else
					{
						stmt.registerOutParameter( sequence , datatype ) ;
					}
					sequence ++ ;
					break ;
				case java.sql.DatabaseMetaData.procedureColumnUnknown:
					break ;
				}
			}
			return stmt ;
		}
		catch(Exception ex) {
			throw new ConnectionException(ex.getMessage());
		}
	}

	private Table createTable
		( java.sql.CallableStatement stmt
		, int[] columnTypes
		, int[] dataTypes
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		try {
			java.util.Vector outColumnsV = new java.util.Vector() ;
			java.util.Vector outColumnsMetaDataV = new java.util.Vector() ;
			for( int i = 0 ; columnTypes.length != i ; i ++ )
			{

				switch( columnTypes[ i ] )
				{
				case java.sql.DatabaseMetaData.procedureColumnInOut:
				case java.sql.DatabaseMetaData.procedureColumnOut:
				case java.sql.DatabaseMetaData.procedureColumnReturn:
				case java.sql.DatabaseMetaData.procedureColumnResult:
					ColumnMetaData colMetaData
						= new ColumnMetaData( i + 1 , null ) ;
					colMetaData.columnType = dataTypes[ i ] ;
					outColumnsV.addElement( stmt.getObject( i + 1 ) ) ;
					outColumnsMetaDataV.addElement( colMetaData ) ;
					break ;
				default:
					break ;
				}
			}
			ColumnMetaData[] columnsMetaData
				= new ColumnMetaData[ outColumnsMetaDataV.size() ] ;
			Object[] columns
				= new Object[ outColumnsV.size() ] ;
			for( int i = 0 ; columns.length != i ; i ++ )
			{
				columnsMetaData[ i ]
					= ( ColumnMetaData ) outColumnsMetaDataV.elementAt( i ) ;
				columns[ i ] = outColumnsV.elementAt( i ) ;
			}
			Object[] onerow = new Object[ 1 ] ;
			onerow[ 0 ] = ( Object ) columns ;
			RowsMetaData rowsMetaData = new RowsMetaData( columnsMetaData ) ;
			Rows rows2 = new Rows( rowsMetaData , onerow ) ;
			Table table = new Table( this , rows2 ) ;
			return table ;
		}
		catch(Exception ex) {
			throw new ConnectionException(ex.getMessage());
		}
	}

	protected static String connstr = ".Connection" ;
	protected static String clientstr = "org.okiproject.serviceimpl.mit.rmissl.Client" ;
	protected static int ROWS_IN_BLOCK = 1000 ;

	private static final String EMPTYSTRING = "" ;
	private static final String DEFAULTCONNECTION = EMPTYSTRING ;

	private String database = EMPTYSTRING ;
	public String getDatabase() { return this.database ; }
	private void setDatabase( String database )
	{
		if( ! this.database.equals( database ) )
		{
			resetCacheId() ;
			this.database = EMPTYSTRING ;
			if( null != database )
			{
				this.database = database ;
			}
		}
	}

	private static final String DEFAULTDATABASEURLPREFIX = "jdbc:oracle:oci8:@" ;
	private String databaseURL = EMPTYSTRING ;
	public String getDatabaseURL() { return this.databaseURL ; }
	private void setDatabaseURL( String databaseURL )
	{
		if( ! this.databaseURL.equals( databaseURL ) )
		{
			resetCacheId() ;
			this.databaseURL = EMPTYSTRING ;
			if( null != databaseURL )
			{
				this.databaseURL = databaseURL ;
			}
		}
	}

	private static final String DEFAULTDRIVERNAME = "oracle.jdbc.driver.OracleDriver" ;
	private String driverName = DEFAULTDRIVERNAME ;
	public String getDriverName() { return this.driverName ; }
	public void setDriverName( String driverName ) { this.driverName = driverName ; }

	private String username = EMPTYSTRING ;
	public String getUsername() { return this.username ; }
	private void setUsername( String username )
	{
		if( ! this.username.equals( username ) )
		{
			resetCacheId() ;
			this.username = EMPTYSTRING ;
			if( null != username )
			{
				this.username = username ;
			}
		}
	}

	private String password = EMPTYSTRING ;
	private String getPassword() { return this.password ; }
	private void setPassword( String password )
	{
		if( ! this.password.equals( password ) )
		{
			resetCacheId() ;
			this.password = EMPTYSTRING ;
			if( null != password )
			{
				this.password = password ;
			}
		}
	}

	private Boolean autoCommit = new Boolean( true ) ;
	public Boolean getAutoCommit() { return this.autoCommit ; }
	public void setAutoCommit( Boolean autoCommit )
	{
		try
		{
			if( ! this.autoCommit.equals( autoCommit ) )
			{
				resetConnection() ;
				this.autoCommit = autoCommit ;
			}
		}
		catch( Exception ex )
		{
			ex.printStackTrace() ;
		}
	}

	private Connection()
	{
		super() ;
	}

	public static Connection create
		( String databaseURL
		, String driverName
		, String username
		, String password
		, String id
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		String exStr = ConnectionException.INVALIDUSERNAME ;
		if( null != username )
		{
			if( null != password )
			{
				if( null != databaseURL )
				{
					if( null != driverName )
					{
						Connection db = ( Connection ) new Connection() ;
						db.setDatabase( null ) ;
						db.setDatabaseURL( databaseURL ) ;
						db.setDriverName( driverName ) ;
						db.setUsername( username ) ;
						db.setPassword( password ) ;
						db.setId( id ) ;
						return db ;
					}
					else
					{
						exStr = ConnectionException.INVALIDDRIVERNAME ;
					}
				}
				else
				{
					exStr = ConnectionException.INVALIDDATABASEURL ;
				}
			}
			else
			{
				exStr = ConnectionException.INVALIDPASSWORD ;
			}
		}
		throw new ConnectionException( exStr ) ;
	}

	public static Connection create
		( String database
		, String username
		, String password
		, String id
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		String exStr = ConnectionException.INVALIDDATABASE ;
		if( null != database )
		{
			if( null != username )
			{
				if( null != password )
				{
					Connection db = ( Connection ) new Connection() ;
					db.setDatabase( database ) ;
					db.setDatabaseURL( null ) ;
					db.setDriverName( DEFAULTDRIVERNAME ) ;
					db.setUsername( username ) ;
					db.setPassword( password ) ;
					db.setId( id ) ;
					return db ;
				}
				else
				{
					exStr = ConnectionException.INVALIDPASSWORD ;
				}
			}
			else
			{
				exStr = ConnectionException.INVALIDUSERNAME ;
			}
		}
		throw new ConnectionException( exStr ) ;
	}

	private String id = DEFAULTCONNECTION ;
	public String getId() { return this.id ; }
	private void setId( String id )
	{
		this.id = DEFAULTCONNECTION ;
		if( null != id )
		{
			this.id = id ;
		}
	}

	public synchronized boolean equals( Connection db )
	{
		return
		(
			( this == db )
			||
			(  ( null != db )
			&& ( db instanceof Connection )
			&& ( getCacheId().equals( ( ( Connection ) db ).getCacheId() ) )
			)
		) ;
	}

	private Object cacheId = null ;
	private synchronized Object getCacheId()
	{
		if( null == this.cacheId )
		{
			Object[] objs = new Object[ 6 ] ;
			objs[ 0 ] = getDatabase() ;
			objs[ 1 ] = getDatabaseURL() ;
			objs[ 2 ] = getUsername() ;
			objs[ 3 ] = getPassword() ;
			objs[ 4 ] = getId() ;
			objs[ 5 ] = connstr ;
			this.cacheId = objs ;
		}
		return this.cacheId ;
	}
	private void resetCacheId() { this.cacheId = null ; }

	public void connect()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		getConnection() ;
	}

	public void disconnect()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		resetConnection() ;
	}

	protected java.sql.Connection getConnection()
	{
		try
		{
			java.sql.Connection conn = getConnectionFromCache() ;
			if( null == conn )
			{
				String dbURL = DEFAULTDATABASEURLPREFIX + getDatabase() ;
				if( ! EMPTYSTRING.equals( getDatabaseURL() ) )
				{
					dbURL = getDatabaseURL() ;
				}
				Connect connect
					= new Connect
						( getDriverName()
						, dbURL
						, getUsername()
						, getPassword()
						) ;
				conn = connect.getConnection() ;
				conn.setAutoCommit( getAutoCommit().booleanValue() ) ;
				RuntimeContext.setProperty( getCacheId() , conn ) ;
			}
			return conn ;
		}
		catch( Exception ex )
		{
		}
		return null ;
	}

	protected java.sql.Connection getConnectionFromCache()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		java.util.Enumeration enum
			= RuntimeContext.getKeys() ;
		if( null != enum )
		{
			while( enum.hasMoreElements() )
			{
				Object[] test = ( Object[] ) enum.nextElement() ;
				if( ( getDatabase().equals( ( String ) test[ 0 ] ) )
				&&	( getDatabaseURL().equals( ( String ) test[ 1 ] ) )
				&&	( getUsername().equals( ( String ) test[ 2 ] ) )
				&&	( getPassword().equals( ( String ) test[ 3 ] ) )
				&&	( getId().equals( ( String ) test[ 4 ] ) )
				&&	( connstr.equals( ( String ) test[ 5 ] ) )
				)
				{
					return ( java.sql.Connection )
						RuntimeContext.getProperty( test ) ;
				}
			}
		}
		return null ;
	}

	protected void resetConnection()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		try {
			java.sql.Connection conn
				= ( java.sql.Connection ) RuntimeContext.getProperty
					( getCacheId() ) ;
			if( null != conn )
			{
				conn.close() ;
				RuntimeContext.setProperty( getCacheId() , null ) ;
			}
		}
		catch(Exception ex) {
			resetConnection();
			throw new ConnectionException(ex.getMessage());
		}
	}

	private String findDataTypeName( int datatype )
	{
		for( int i = 0 ; types.length != i ; i ++ )
		{
			if( types[ i ] == datatype )
			{
				return typeNames[ i ] ;
			}
		}
		return null ;
	}

	private static int[] types =
	{	java.sql.Types.ARRAY
	,	java.sql.Types.BIGINT
	,	java.sql.Types.BINARY
	,	java.sql.Types.BIT
	,	java.sql.Types.BLOB
	,	java.sql.Types.CHAR
	,	java.sql.Types.CLOB
	,	java.sql.Types.DATE
	,	java.sql.Types.DECIMAL
	,	java.sql.Types.DISTINCT
	,	java.sql.Types.DOUBLE
	,	java.sql.Types.FLOAT
	,	java.sql.Types.INTEGER
	,	java.sql.Types.JAVA_OBJECT
	,	java.sql.Types.LONGVARBINARY
	,	java.sql.Types.LONGVARCHAR
	,	java.sql.Types.NULL
	,	java.sql.Types.NUMERIC
	,	java.sql.Types.OTHER
	,	java.sql.Types.REAL
	,	java.sql.Types.REF
	,	java.sql.Types.SMALLINT
	,	java.sql.Types.STRUCT
	,	java.sql.Types.TIME
	,	java.sql.Types.TIMESTAMP
	,	java.sql.Types.TINYINT
	,	java.sql.Types.VARBINARY
	,	java.sql.Types.VARCHAR
	} ;

  	private static String[] typeNames =
  	{	"java.sql.Types.ARRAY"
	,	"java.sql.Types.BIGINT"
	,	"java.sql.Types.BINARY"
	,	"java.sql.Types.BIT"
	,	"java.sql.Types.BLOB"
	,	"java.sql.Types.CHAR"
	,	"java.sql.Types.CLOB"
	,	"java.sql.Types.DATE"
	,	"java.sql.Types.DECIMAL"
	,	"java.sql.Types.DISTINCT"
	,	"java.sql.Types.DOUBLE"
	,	"java.sql.Types.FLOAT"
	,	"java.sql.Types.INTEGER"
	,	"java.sql.Types.JAVA_OBJECT"
	,	"java.sql.Types.LONGVARBINARY"
	,	"java.sql.Types.LONGVARCHAR"
	,	"java.sql.Types.NULL"
	,	"java.sql.Types.NUMERIC"
	,	"java.sql.Types.OTHER"
	,	"java.sql.Types.REAL"
	,	"java.sql.Types.REF"
	,	"java.sql.Types.SMALLINT"
	,	"java.sql.Types.STRUCT"
	,	"java.sql.Types.TIME"
	,	"java.sql.Types.TIMESTAMP"
	,	"java.sql.Types.TINYINT"
	,	"java.sql.Types.VARBINARY"
	,	"java.sql.Types.VARCHAR"
	} ;

}