package edu.mit.is.service.authorization;

public class FunctionsIterator
implements org.okip.service.authorization.api.FunctionsIterator {
  protected Rows rows = null;
  protected Factory factory = null;

  /**
   * Method hasNext
   *
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public boolean hasNext()
  throws org.okip.service.authorization.api.AuthorizationException {
    if (null != this.rows) {
      return this.rows.hasMoreRows();
    }

    return false;
  }

  /**
   * Method next
   *
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public org.okip.service.authorization.api.Function next()
  throws org.okip.service.authorization.api.AuthorizationException {
    if (null != this.rows) {
      return getFunction(this.rows.getColumnNames(), this.rows.nextRow());

    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.FUNCTIONENUMERATIONFAILED);
  }

  /**
   * Method getFunctionsOfType
   *
   *
   * @param factory
   * @param functionType
   *
   * @return
   *
   * @throws org.okip.service.authorization.api.AuthorizationException
   *
   */
  public static org.okip.service.authorization.api.FunctionsIterator getFunctionsOfType(
          Factory factory,
          org.okip.service.authorization.api.FunctionType functionType)
  throws org.okip.service.authorization.api.AuthorizationException {
    try {
      if (null != factory) {
        Connection connection =
          factory.getConnection();
        Table      table      =
          connection.executeQuery(
            getFunctionsInTypeSQL(((FunctionType)functionType).getKeyword()));

        if (null != table) {
          FunctionsIterator functions =
            new FunctionsIterator();

          functions.factory = factory;
          functions.rows         = table.getRows();

          return functions;
        }
        else {
          if (((FunctionType)functionType).isFoundInAuthorization()) {
            return null;
          }
        }
      }
    }
    catch (org.okip.service.authorization.api.AuthorizationException ex) {
      throw new org.okip.service.authorization.api.AuthorizationException(
        ex.getMessage());
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.FUNCTIONTYPENOTFOUNDINAUTHORIZATION);
  }

  protected static org.okip.service.authorization.api.FunctionsIterator getFunctionsIterator(
          Factory factory,
          String sqlQuery)
  throws org.okip.service.authorization.api.AuthorizationException {
    try {
      if (null != sqlQuery) {
        Connection       connection =
          factory.getConnection();
        Table            table      =
          connection.executeQuery(sqlQuery);
        FunctionsIterator functions  =
          new FunctionsIterator();

        functions.factory = factory;
        functions.rows         = table.getRows();

        return functions;
      }
    }
    catch (org.okip.service.authorization.api.AuthorizationException ex) {
      throw new org.okip.service.authorization.api.AuthorizationException(
        ex.getMessage());
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.FUNCTIONENUMERATIONFAILED);
  }

  private static String getFunctionsInTypeSQL(String functionType) {
    String sql = "select";

    sql +=
      " function_id, function_name, function_description, function_category,";
    sql += " modified_by, modified_date, qualifier_type";
    sql += " from function";
    sql += " where function_category = '" + functionType + "'";

    return sql;
  }

  private org.okip.service.authorization.api.Function getFunction(
          String[] columnNames, Object[] row)
  throws org.okip.service.authorization.api.AuthorizationException {
    if ((null != columnNames) && (null != row)) {
      java.util.Properties properties = new java.util.Properties();

      for (int i = 0; columnNames.length != i; i++) {
        properties.put(columnNames[i], row[i]);
      }

      return (new Function(
        this.factory, properties));
    }

    throw new org.okip.service.authorization.api.AuthorizationException(
      org.okip.service.authorization.api.AuthorizationException.FUNCTIONENUMERATIONFAILED);
  }

}
