package edu.mit.is.service.authorization;

public class Rows
implements java.io.Serializable {

	protected static int MAXNUMBEROFROWS = 1000 ;
	private static final Object[] NOARGS = new Object[ 0 ] ;
	private static final Class[] NOARGSTYPES = new Class[ 0 ] ;
	private static final String GETROWS = "getRows" ;

	private static final org.okip.service.authorization.api.AuthorizationException GETROWSFAILED
		= new edu.mit.is.service.authorization.TableException
			( edu.mit.is.service.authorization.TableException.GETROWSFAILED
			) ;

	private static final org.okip.service.authorization.api.AuthorizationException GETCOLUMNFAILED
		= new edu.mit.is.service.authorization.TableException
			( edu.mit.is.service.authorization.TableException.GETCOLUMNFAILED
			) ;

	private String catalog = null ;
	private String schemaPattern = null ;
	private String procedureNamePattern = null ;
	private String columnNamePattern = null ;
	private String procedureName = null ;
	private String tableNamePattern = null ;
	private String[] tableTypes = null ;

	protected Table table = null ;
	private String sql = null ;
	private Object[] objs = null ;
	private int[] targetSqlTypes = null ;
	private int[] scales = null ;

	private Object[] rows = null ;
	private int index = 0 ;
	private int offset = 0 ;

	private RowsMetaData rowsMetaData = null ;
	public RowsMetaData getRowsMetaData()
	{
		return this.rowsMetaData ;
	}

	public String[] getColumnNames()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		String[] columnNames
			= new String[ this.rowsMetaData.getColumnCount() ] ;
		for( int i = 0 ; columnNames.length != i ; i ++ )
		{
			ColumnMetaData colMetaData
				= this.rowsMetaData.getColumnsMetaData()[ i ] ;
			columnNames[ i ]
				= colMetaData.getColumnName() ;
		}
		return columnNames ;

	}

	public int getColumn( String columnName )
		throws org.okip.service.authorization.api.AuthorizationException
	{
		String[] columnNames = getColumnNames() ;
		for( int i = 0 ; columnNames.length != i ; i ++ )
		{
			if( columnName.equals( columnNames[ i ] ) )
			{
				return i ;
			}
		}
		throw GETCOLUMNFAILED ;
	}

	public boolean hasMoreRows()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		if( null != rows )
		{
			if( index < rows.length )
			{
				return true ;
			}
			else
			{
				this.offset += index ;
				index = 0 ;
				rows = null ;
				if( null != table )
				{
					getRows() ;
					return( null != this.rows ) ;
				}
			}
		}
		return false ;
	}

	public Object[] nextRow()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		if( null != rows )
		{
			return ( Object[] ) rows[ index ++ ] ;
		}
		throw GETROWSFAILED ;
	}

	public Object clone()
	{
		try
		{
			return new Rows( this.rowsMetaData , rows ) ;
		}
		catch( Exception ex )
		{
			ex.printStackTrace() ;
		}
		return null ;
	}

	protected Rows
		( RowsMetaData rowsMetaData
		, Object[] rows
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		this.rowsMetaData = rowsMetaData ;
		this.rows = rows ;
	}

	protected Rows
		( Table table
		, String catalog
		, String schemaPattern
		, String tableNamePattern
		, String[] tableTypes
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		this.table = table ;
		this.catalog = catalog ;
		this.schemaPattern = schemaPattern ;
		this.tableNamePattern = tableNamePattern ;
		this.tableTypes = tableTypes ;

		getRows() ;
	}

	protected Rows
		( Table table
		, String catalog
		, String schemaPattern
		, String procedureNamePattern
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		this.table = table ;
		this.catalog = catalog ;
		this.schemaPattern = schemaPattern ;
		this.procedureNamePattern = procedureNamePattern ;

		getRows() ;
	}

	protected Rows
		( Table table
		, String catalog
		, String schemaPattern
		, String procedureName
		, String columnNamePattern
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		this.table = table ;
		this.catalog = catalog ;
		this.schemaPattern = schemaPattern ;
		this.procedureName = procedureName ;
		this.columnNamePattern = columnNamePattern ;

		getRows() ;
	}

	protected Rows
		( Table table
		, String sql
		, Object[] objs
		, int[] targetSqlTypes
		, int[] scales
		)
		throws org.okip.service.authorization.api.AuthorizationException
	{
		this.table = table ;
		this.sql = sql ;
		this.objs = objs ;
		this.scales = scales ;

		getRows() ;
	}

	public void getRows()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		Connection connection
			= ( Connection )
				( ( Table ) table ).getConnection() ;
//		if( connection.hasClient() )
//		{
//			getRowsRemotely() ;
//		}
//		else
		{
			getRowsLocally() ;
		}
	}

	private void getRowsRemotely()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		Connection connection
			= ( Connection )
				( ( Table ) table ).getConnection() ;
//		org.okiproject.serviceimpl.mit.rmissl.Client client = connection.getClient() ;
//		client.invoke( this , GETROWS , NOARGSTYPES , NOARGS ) ;
	}

	public void getRowsLocally()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		try {
			java.sql.ResultSet rs = getResultSet() ;
			java.sql.ResultSetMetaData rsMeta = rs.getMetaData() ;
			this.rowsMetaData = new RowsMetaData( rsMeta ) ;
			this.rows = createRows( rs ) ;
			java.sql.Statement statement = rs.getStatement() ;
			rs.close() ;
			statement.close() ;
		}
		catch(Exception ex) {
			throw new ConnectionException(ex.getMessage());
		}
	}

	protected java.sql.ResultSet getResultSet()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		if
			(  ( null != tableNamePattern )
			|| ( null != tableTypes )
			)
		{
			return getTables() ;
		}
		else if( null != this.sql )
		{
			return getQuery() ;
		}
		else if
			(  ( null != this.procedureName )
			|| ( null != this.columnNamePattern )
			)
		{
			return getProcedureColumns() ;
		}
		else
		{
			return getProcedures() ;
		}
	}

	private java.sql.Connection getConnection()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		Connection conn =
			( ( Table ) this.table
			).getConnection() ;

		java.sql.Connection connection =
			( ( Connection ) conn
			).getConnection() ;
		return connection ;
	}

	private java.sql.ResultSet getTables()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		try {
			java.sql.DatabaseMetaData meta
				= getConnection().getMetaData() ;

			return meta.getTables
					( this.catalog
					, this.schemaPattern
					, this.tableNamePattern
					, this.tableTypes
					) ;
		}
		catch(Exception ex) {
			throw new ConnectionException(ex.getMessage());
		}
	}

	private java.sql.ResultSet getQuery()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		try {
			java.sql.Connection connection
				= getConnection() ;
			java.sql.ResultSet rs = null ;
			if( null == objs )
			{
				java.sql.Statement statement
					= connection.createStatement() ;
				rs = statement.executeQuery( sql ) ;
			}
			else
			{
				java.sql.PreparedStatement statement
					= connection.prepareStatement( sql ) ;
				for( int i = 0 ; objs.length != i ; i ++ )
				{
					if( null != this.scales )
					{
						statement.setObject
							( i + 1
							, objs[ i ]
							, targetSqlTypes[ i ]
							, scales[ i ]
							) ;
					}
					else if ( null != targetSqlTypes )
					{
						statement.setObject
							( i + 1
							, objs[ i ]
							, targetSqlTypes[ i ]
							) ;
					}
					else
					{
						statement.setObject
							( i + 1
							, objs[ i ]
							) ;
					}
				}
				rs = statement.executeQuery() ;
			}
			return rs ;
		}
		catch(Exception ex) {
			throw new ConnectionException(ex.getMessage());
		}
	}

	private java.sql.ResultSet getProcedureColumns()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		try {
			java.sql.DatabaseMetaData meta
				= getConnection().getMetaData() ;

			return meta.getProcedureColumns
					( this.catalog
					, this.schemaPattern
					, this.procedureName
					, this.columnNamePattern
					) ;
		}
		catch(Exception ex) {
			throw new ConnectionException(ex.getMessage());
		}
	}

	private java.sql.ResultSet getProcedures()
		throws org.okip.service.authorization.api.AuthorizationException
	{
		try {
			java.sql.DatabaseMetaData meta
				= getConnection().getMetaData() ;

			return meta.getProcedures
					( this.catalog
					, this.schemaPattern
					, this.procedureNamePattern
					) ;
		}
		catch(Exception ex) {
			throw new ConnectionException(ex.getMessage());
		}
	}

	private Object[] createRows( java.sql.ResultSet rs )
		throws org.okip.service.authorization.api.AuthorizationException
	{
		try
		{
			int rsType = rs.getType() ;
			if( rs.TYPE_FORWARD_ONLY == rsType )
			{
				if( rs.next() )
				{
					return createCells( rs ) ;
				}
			}
			else if( rs.TYPE_SCROLL_INSENSITIVE == rsType )
			{
				rs.setFetchDirection( rs.FETCH_FORWARD ) ;
				if( rs.first() )
				{
					return createCells( rs ) ;
				}
			}
			else if( rs.TYPE_SCROLL_SENSITIVE == rsType )
			{
				rs.setFetchDirection( rs.FETCH_FORWARD ) ;
				boolean isRowAvailable = rs.first() ;
				if( rs.first() )
				{
					return createCells( rs ) ;
				}
			}
		}
		catch( Exception ex )
		{
			String message = GETROWSFAILED.getMessage() ;
			message += ex.getMessage() ;
			throw new org.okip.service.authorization.api.AuthorizationException( message ) ;
		}
		return null ;
	}

	private Object[] createCells( java.sql.ResultSet rs )
		throws org.okip.service.authorization.api.AuthorizationException
	{
		try {
			Object[] rows = new Object[ MAXNUMBEROFROWS ] ;
			int cursor = 0 ;
			int rowsAdded = 0 ;
			boolean isRowAvailable = true ;
			while( isRowAvailable )
			{
				if( cursor >= this.offset )
				{
					Object[] columns
						= new Object
							[ this.rowsMetaData.getColumnCount()
							] ;
					for( int i = 0 ; columns.length != i ; i ++ )
					{
						columns[ i ] = createCell( rs.getObject( i + 1 ) , rowsAdded , i ) ;
					}
					rows[ rowsAdded ] = columns ;
					rowsAdded ++ ;

				}
				if( MAXNUMBEROFROWS == rowsAdded )
				{
					break ;
				}
				cursor ++ ;
				isRowAvailable = rs.next() ;
			}
			if( 0 == rowsAdded )
			{
				return null ;
			}
			if( MAXNUMBEROFROWS > rowsAdded )
			{
				Object[] newRows = new Object[ rowsAdded ] ;
				for( int j = 0 ; rowsAdded != j ; j ++ )
				{
					newRows[ j ] = rows[ j ] ;
				}
				rows = newRows ;
			}
			return rows ;
		}
		catch(Exception ex) {
			throw new ConnectionException(ex.getMessage());
		}
	}

	private Object createCell
		( Object obj
		, int row
		, int col
		)
		throws Exception
	{
		return obj ;
	}

}