package edu.mit.is.service.dbc;



/**
 * Class Connect
 *
 *
 * @author
 * @version %I%, %G%
 */
public class Connect
extends java.lang.Thread
implements java.lang.Cloneable {
  private static final int      MAXRETRIES  = 3;

  protected String              databaseURL = null;
  protected String              username    = null;
  protected String              password    = null;
  protected java.sql.Connection conn        = null;

  /**
   * Constructor Connect
   *
   *
   * @param driverName
   * @param databaseURL
   * @param username
   * @param password
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public Connect(String driverName, String databaseURL, String username,
                 String password)
  throws org.okip.service.dbc.api.DbcException {
    try {
      Class.forName(driverName);

      this.databaseURL = databaseURL;
      this.username    = username;
      this.password    = password;
    }
    catch (Exception ex) {
      throw new org.okip.service.dbc.api.DbcException(ex.getMessage());
    }
  }

  /**
   * Method getConnection
   *
   *
   * @return java.sql.Connection
   *
   */
  public java.sql.Connection getConnection() {
    try {
      if (null == conn) {
        for (int i = 0; MAXRETRIES != i; i++) {
          Connect clone = (Connect) this.clone();

          clone.start();

          clone.join(30000);    // wait 30 seconds for a timeout

          conn = clone.conn;

          if (null != conn) {
            return conn;
          }
        }
      }

      return conn;
    }
    catch (Exception ex) {
      ex.printStackTrace();

      return null;
    }
  }

  /**
   * Method run
   *
   *
   */
  public void run() {
    try {
      conn = java.sql.DriverManager.getConnection(databaseURL, username,
                                                  password);
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }
}
