package edu.mit.is.service.dbc;



import org.okip.service.dbc.api.DbcException;


/**
 * Class Connection
 *
 *
 * @author
 * @version %I%, %G%
 */
public class Connection
implements org.okip.service.dbc.api.Connection, java.io.Serializable {

  private static final String            EXECUTEUPDATE  = "executeUpdate";
  private static final String            CALLPROCEDURE  = "callProcedure";
  private static final String            COLUMN_NAME    = "COLUMN_NAME";
  private static final String            COLUMN_TYPE    = "COLUMN_TYPE";
  private static final String            DATA_TYPE      = "DATA_TYPE";
  private static final String            SEQUENCE       = "SEQUENCE";

  private static final Integer           DEFAULTMAXROWS = new Integer(1000);

  private static final String            CLASSNAME      =
    Connection.class.getPackage().getName();

  protected static String                connstr        = ".Connection";
  protected static int                   ROWS_IN_BLOCK  = 1000;

  private edu.mit.is.service.dbc.Factory factory        = null;

  /**
   * Constructor Connection
   *
   *
   */
  public Connection() {
    super();
  }

  /**
   * Constructor Connection
   *
   *
   * @param factory
   *
   */
  public Connection(edu.mit.is.service.dbc.Factory factory) {
    this.factory = factory;
  }

  /**
   * Method getFactory
   *
   *
   * @return edu.mit.is.service.dbc.Factory
   *
   */
  public edu.mit.is.service.dbc.Factory getFactory() {
    return this.factory;
  }

  private static final String EMPTYSTRING       = "";
  private static final String DEFAULTCONNECTION = EMPTYSTRING;

  private String              database          = EMPTYSTRING;

  /**
   * Method getDatabase
   *
   *
   * @return String
   *
   */
  public String getDatabase() {
    return this.database;
  }

  private void setDatabase(String database) {
    if (!this.database.equals(database)) {
      resetCacheId();

      this.database = EMPTYSTRING;

      if (null != database) {
        this.database = database;
      }
    }
  }

  private static final String DEFAULTDATABASEURLPREFIX = "jdbc:oracle:oci8:@";
  private String              databaseURL              = EMPTYSTRING;

  /**
   * Method getDatabaseURL
   *
   *
   * @return String
   *
   */
  public String getDatabaseURL() {
    return this.databaseURL;
  }

  private void setDatabaseURL(String databaseURL) {
    if (!this.databaseURL.equals(databaseURL)) {
      resetCacheId();

      this.databaseURL = EMPTYSTRING;

      if (null != databaseURL) {
        this.databaseURL = databaseURL;
      }
    }
  }

  private static final String DEFAULTDRIVERNAME =
    "oracle.jdbc.driver.OracleDriver";
  private String              driverName        = DEFAULTDRIVERNAME;

  /**
   * Method getDriverName
   *
   *
   * @return String
   *
   */
  public String getDriverName() {
    return this.driverName;
  }

  /**
   * Method setDriverName
   *
   *
   * @param driverName
   *
   */
  public void setDriverName(String driverName) {
    this.driverName = driverName;
  }

  private String username = EMPTYSTRING;

  /**
   * Method getUsername
   *
   *
   * @return String
   *
   */
  public String getUsername() {
    return this.username;
  }

  private void setUsername(String username) {
    if (!this.username.equals(username)) {
      resetCacheId();

      this.username = EMPTYSTRING;

      if (null != username) {
        this.username = username;
      }
    }
  }

  private String password = EMPTYSTRING;

  private String getPassword() {
    return this.password;
  }

  private void setPassword(String password) {
    if (!this.password.equals(password)) {
      resetCacheId();

      this.password = EMPTYSTRING;

      if (null != password) {
        this.password = password;
      }
    }
  }

  private Integer maxRows = DEFAULTMAXROWS;

  /**
   * Method getMaxRows
   *
   *
   * @return Integer
   *
   */
  public Integer getMaxRows() {
    return this.maxRows;
  }

  private void setMaxRows(Integer maxRows) {
    if (!this.maxRows.equals(maxRows)) {
      resetCacheId();

      this.maxRows = new Integer(0);

      if (null != maxRows) {
        this.maxRows = maxRows;
      }
    }
  }

  private boolean autoCommit = true;

  /**
   * Method getAutoCommit
   *
   *
   * @return boolean
   *
   */
  public boolean getAutoCommit() {
    return this.autoCommit;
  }

  /**
   * Method setAutoCommit
   *
   *
   * @param autoCommit
   *
   */
  public void setAutoCommit(boolean autoCommit) {
    try {
      if (!this.autoCommit == autoCommit) {
        resetConnection();

        this.autoCommit = autoCommit;
      }
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  /**
   * Method create
   *
   *
   * @param databaseURL
   * @param driverName
   * @param username
   * @param password
   * @param maxRows
   * @param factory
   *
   * @return org.okip.service.dbc.api.Connection
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public static org.okip.service.dbc.api.Connection create(String databaseURL,
          String driverName, String username, String password,
          Integer maxRows, edu.mit.is.service.dbc.Factory factory)
  throws org.okip.service.dbc.api.DbcException {
    String exStr = org.okip.service.dbc.api.DbcException.INVALIDUSERNAME;

    if (null != username) {
      if (null != password) {
        if (null != databaseURL) {
          if (null != driverName) {
            if (null != maxRows) {
              edu.mit.is.service.dbc.Connection dbCon =
                new edu.mit.is.service.dbc.Connection(factory);

              dbCon.setDatabase(null);
              dbCon.setDatabaseURL(databaseURL);
              dbCon.setDriverName(driverName);
              dbCon.setUsername(username);
              dbCon.setPassword(password);
              dbCon.setMaxRows(maxRows);
              dbCon.setId(dbCon.getDatabase() + dbCon.getDatabaseURL()
                          + dbCon.getDriverName() + dbCon.getUsername()
                          + dbCon.getPassword());

              return dbCon;
            }
            else {
              exStr = org.okip.service.dbc.api.DbcException.INVALIDMAXROWS;
            }
          }
          else {
            exStr = org.okip.service.dbc.api.DbcException.INVALIDDRIVERNAME;
          }
        }
        else {
          exStr = org.okip.service.dbc.api.DbcException.INVALIDDATABASEURL;
        }
      }
      else {
        exStr = org.okip.service.dbc.api.DbcException.INVALIDPASSWORD;
      }
    }

    throw new org.okip.service.dbc.api.DbcException(exStr);
  }

  /**
   * Method create
   *
   *
   * @param databaseURL
   * @param driverName
   * @param username
   * @param password
   * @param factory
   *
   * @return org.okip.service.dbc.api.Connection
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public static org.okip.service.dbc.api.Connection create(String databaseURL,
          String driverName, String username, String password,
          edu.mit.is.service.dbc.Factory factory)
  throws org.okip.service.dbc.api.DbcException {
    String exStr = org.okip.service.dbc.api.DbcException.INVALIDUSERNAME;

    if (null != username) {
      if (null != password) {
        if (null != databaseURL) {
          if (null != driverName) {
            edu.mit.is.service.dbc.Connection dbCon =
              new edu.mit.is.service.dbc.Connection(factory);

            dbCon.setDatabase(null);
            dbCon.setDatabaseURL(databaseURL);
            dbCon.setDriverName(driverName);
            dbCon.setUsername(username);
            dbCon.setPassword(password);
            dbCon.setMaxRows(DEFAULTMAXROWS);
            dbCon.setId(dbCon.getDatabase() + dbCon.getDatabaseURL()
                        + dbCon.getDriverName() + dbCon.getUsername()
                        + dbCon.getPassword());

            return dbCon;
          }
          else {
            exStr = org.okip.service.dbc.api.DbcException.INVALIDDRIVERNAME;
          }
        }
        else {
          exStr = org.okip.service.dbc.api.DbcException.INVALIDDATABASEURL;
        }
      }
      else {
        exStr = org.okip.service.dbc.api.DbcException.INVALIDPASSWORD;
      }
    }

    throw new org.okip.service.dbc.api.DbcException(exStr);
  }

  /**
   * Method create
   *
   *
   * @param database
   * @param username
   * @param password
   *
   * @return org.okip.service.dbc.api.Connection
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public static org.okip.service.dbc.api.Connection create(String database,
          String username, String password)
  throws org.okip.service.dbc.api.DbcException {
    String exStr = org.okip.service.dbc.api.DbcException.INVALIDDATABASE;

    if (null != database) {
      if (null != username) {
        if (null != password) {
          edu.mit.is.service.dbc.Connection dbCon =
            new edu.mit.is.service.dbc.Connection();

          dbCon.setDatabase(database);
          dbCon.setDatabaseURL(null);
          dbCon.setDriverName(DEFAULTDRIVERNAME);
          dbCon.setUsername(username);
          dbCon.setPassword(password);
          dbCon.setMaxRows(DEFAULTMAXROWS);
          dbCon.setId(dbCon.getDatabase() + dbCon.getDatabaseURL()
                      + dbCon.getDriverName() + dbCon.getUsername()
                      + dbCon.getPassword());

          return dbCon;
        }
        else {
          exStr = org.okip.service.dbc.api.DbcException.INVALIDPASSWORD;
        }
      }
      else {
        exStr = org.okip.service.dbc.api.DbcException.INVALIDUSERNAME;
      }
    }

    throw new org.okip.service.dbc.api.DbcException(exStr);
  }

  /**
   * Method create
   *
   *
   * @param username
   * @param password
   *
   * @return org.okip.service.dbc.api.Connection
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public static org.okip.service.dbc.api.Connection create(String username,
          String password)
  throws org.okip.service.dbc.api.DbcException {
    String exStr = org.okip.service.dbc.api.DbcException.INVALIDUSERNAME;

    if (null != username) {
      if (null != password) {
        edu.mit.is.service.dbc.Connection dbCon =
          new edu.mit.is.service.dbc.Connection();

        dbCon.setDatabase(null);
        dbCon.setDatabaseURL(null);
        dbCon.setDriverName(DEFAULTDRIVERNAME);
        dbCon.setUsername(username);
        dbCon.setPassword(password);
        dbCon.setMaxRows(DEFAULTMAXROWS);
        dbCon.setId(dbCon.getDatabase() + dbCon.getDatabaseURL()
                    + dbCon.getDriverName() + dbCon.getUsername()
                    + dbCon.getPassword());

        return dbCon;
      }
      else {
        exStr = org.okip.service.dbc.api.DbcException.INVALIDPASSWORD;
      }
    }

    throw new org.okip.service.dbc.api.DbcException(exStr);
  }

  private String id = DEFAULTCONNECTION;

  /**
   * Method getId
   *
   *
   * @return String
   *
   */
  public String getId() {
    return this.id;
  }

  private void setId(String id) {
    this.id = DEFAULTCONNECTION;

    if (null != id) {
      this.id = id;
    }
  }

  /**
   * Method equals
   *
   *
   * @param db
   *
   * @return boolean
   *
   */
  public synchronized boolean equals(Connection db) {
    return ((this == db)
            || ((null != db) && (db instanceof Connection)
                && (getCacheId().equals(((Connection) db).getCacheId()))));
  }

  private Object cacheId = null;

  private synchronized Object getCacheId() {
    if (null == this.cacheId) {
      Object[] objs = new Object[6];

      objs[0]      = getDatabase();
      objs[1]      = getDatabaseURL();
      objs[2]      = getUsername();
      objs[3]      = getPassword();
      objs[4]      = getId();
      objs[5]      = connstr;
      this.cacheId = objs;
    }

    return this.cacheId;
  }

  private void resetCacheId() {
    this.cacheId = null;
  }

  /**
   * Method connect
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public void connect()
  throws org.okip.service.dbc.api.DbcException {
    getConnection();
  }

  /**
   * Method disconnect
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public void disconnect()
  throws org.okip.service.dbc.api.DbcException {
    resetConnection();
  }

  protected java.sql.Connection getConnection() {
    try {
      java.sql.Connection conn = getConnectionFromCache();

      if (null == conn) {
        String dbURL = DEFAULTDATABASEURLPREFIX + getDatabase();

        if (!EMPTYSTRING.equals(getDatabaseURL())) {
          dbURL = getDatabaseURL();
        }

        Connect connect = new Connect(getDriverName(), dbURL, getUsername(),
                                      getPassword());

        conn = connect.getConnection();

        conn.setAutoCommit(getAutoCommit());
        RuntimePool.setProperty(getCacheId(), conn);
      }

      return conn;
    }
    catch (Exception ex) {}

    return null;
  }

  protected java.sql.Connection getConnectionFromCache()
  throws org.okip.service.dbc.api.DbcException {
    java.util.Enumeration enum = RuntimePool.getKeys();

    if (null != enum) {
      while (enum.hasMoreElements()) {
        Object[] test = (Object[]) enum.nextElement();

        if ((getDatabase().equals((String) test[0]))
                && (getDatabaseURL().equals((String) test[1]))
                && (getUsername().equals((String) test[2]))
                && (getPassword().equals((String) test[3]))
                && (getId().equals((String) test[4]))
                && (connstr.equals((String) test[5]))) {
          return (java.sql.Connection) RuntimePool.getProperty(test);
        }
      }
    }

    return null;
  }

  protected void resetConnection()
  throws org.okip.service.dbc.api.DbcException {
    try {
      java.sql.Connection conn =
        (java.sql.Connection) RuntimePool.getProperty(getCacheId());

      if (null != conn) {
        conn.close();
        RuntimePool.setProperty(getCacheId(), null);
      }
    }
    catch (Exception ex) {
      resetConnection();

      throw new org.okip.service.dbc.api.DbcException(ex.getMessage());
    }
  }

  private String findDataTypeName(int datatype) {
    for (int i = 0; types.length != i; i++) {
      if (types[i] == datatype) {
        return typeNames[i];
      }
    }

    return null;
  }

  private static int[]    types     = {
    java.sql.Types.ARRAY, java.sql.Types.BIGINT, java.sql.Types.BINARY,
    java.sql.Types.BIT, java.sql.Types.BLOB, java.sql.Types.CHAR,
    java.sql.Types.CLOB, java.sql.Types.DATE, java.sql.Types.DECIMAL,
    java.sql.Types.DISTINCT, java.sql.Types.DOUBLE, java.sql.Types.FLOAT,
    java.sql.Types.INTEGER, java.sql.Types.JAVA_OBJECT,
    java.sql.Types.LONGVARBINARY, java.sql.Types.LONGVARCHAR,
    java.sql.Types.NULL, java.sql.Types.NUMERIC, java.sql.Types.OTHER,
    java.sql.Types.REAL, java.sql.Types.REF, java.sql.Types.SMALLINT,
    java.sql.Types.STRUCT, java.sql.Types.TIME, java.sql.Types.TIMESTAMP,
    java.sql.Types.TINYINT, java.sql.Types.VARBINARY, java.sql.Types.VARCHAR
  };

  private static String[] typeNames = {
    "java.sql.Types.ARRAY", "java.sql.Types.BIGINT", "java.sql.Types.BINARY",
    "java.sql.Types.BIT", "java.sql.Types.BLOB", "java.sql.Types.CHAR",
    "java.sql.Types.CLOB", "java.sql.Types.DATE", "java.sql.Types.DECIMAL",
    "java.sql.Types.DISTINCT", "java.sql.Types.DOUBLE",
    "java.sql.Types.FLOAT", "java.sql.Types.INTEGER",
    "java.sql.Types.JAVA_OBJECT", "java.sql.Types.LONGVARBINARY",
    "java.sql.Types.LONGVARCHAR", "java.sql.Types.NULL",
    "java.sql.Types.NUMERIC", "java.sql.Types.OTHER", "java.sql.Types.REAL",
    "java.sql.Types.REF", "java.sql.Types.SMALLINT", "java.sql.Types.STRUCT",
    "java.sql.Types.TIME", "java.sql.Types.TIMESTAMP",
    "java.sql.Types.TINYINT", "java.sql.Types.VARBINARY",
    "java.sql.Types.VARCHAR"
  };

  /**
   * Clears all warnings reported for this
   * Connection object.
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public void clearWarnings()
  throws org.okip.service.dbc.api.DbcException {
    return;
  }

  /**
   * Releases this Connection object's database
   * and JDBC resources immediately instead of
   * waiting for them to be automatically released.
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public void close()
  throws org.okip.service.dbc.api.DbcException {
    return;
  }

  /**
   * Makes all changes made since the previous
   * commit/rollback permanent and releases any
   * database locks currently held by this
   * Connection object.
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public void commit()
  throws org.okip.service.dbc.api.DbcException {
    return;
  }

  /**
   * Creates a Statement object for sending
   * SQL statements to the database.
   *
   * @return Statement
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.Statement createStatement()
  throws org.okip.service.dbc.api.DbcException {
    org.okip.service.dbc.api.Statement statement =
      new edu.mit.is.service.dbc.Statement(this);

    return statement;
  }

  /**
   * Creates a Statement object that will
   * generate ResultSet objects with the
   * given type and concurrency.
   *
   * @param resultSetType
   * @param resultSetConcurrency
   *
   * @return Statement
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.Statement createStatement(int resultSetType,
          int resultSetConcurrency)
  throws org.okip.service.dbc.api.DbcException {
    return null;
  }

  /**
   * Creates a Statement object that will
   * generate ResultSet objects with the
   * given type, concurrency, and holdability.
   *
   * @param resultSetType
   * @param resultSetConcurrency
   * @param resultSetHoldability
   *
   * @return Statement
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.Statement createStatement(int resultSetType,
          int resultSetConcurrency, int resultSetHoldability)
  throws org.okip.service.dbc.api.DbcException {
    return null;
  }

  /**
   * Retrieves the current auto-commit mode
   * for this Connection object.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */

  /*  boolean getAutoCommit()
   throws org.okip.service.dbc.api.DbcException
   {
   try {
     java.sql.Connection conn = getConnection() ;
     return conn.getAutoCommit();
     } catch( java.sql.SQLException e ) {
    throw new DbcException(e.getMessage());

     }
   }*/

  /**
   * Retrieves this Connection object's
   * current catalog name.
   *
   * @return catalog
   *
   * @throws DbcException
   *
   */
  public String getCatalog()
  throws org.okip.service.dbc.api.DbcException {
    return null;
  }

  /**
   * Retrieves the current holdability of
   * ResultSet objects created using this
   * Connection object.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getHoldability()
  throws org.okip.service.dbc.api.DbcException {
    return 0;
  }

  /**
   * Retrieves a DatabaseMetaData object that
   * contains metadata about the database to
   * which this Connection object represents
   * a connection.
   *
   * @return DatabaseMetaData
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.DatabaseMetaData getMetaData()
  throws org.okip.service.dbc.api.DbcException {
    return null;    //should change to return dbc databasemetadata

  }

  /**
   * Retrieves this Connection object's current
   * transaction isolation level.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getTransactionIsolation()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the Map object associated
   * with this Connection object.
   *
   * @return map
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public java.util.Map getTypeMap()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Retrieves the first warning reported
   * by calls on this Connection object.
   *
   *
   * @return java.sql.SQLWarning
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public java.sql.SQLWarning getWarnings()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this Connection object
   * has been closed.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean isClosed()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Retrieves whether this Connection object
   * is in read-only mode.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean isReadOnly()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Converts the given SQL statement into
   * the system's native SQL grammar.
   *
   * @param sql
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String nativeSQL(String sql)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Creates a CallableStatement object
   * for calling database stored procedures.
   *
   * @param sql
   *
   * @return CallableStatement
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.CallableStatement prepareCall(String sql)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Creates a CallableStatement object that
   * will generate ResultSet objects with the
   * given type and concurrency.
   *
   * @param sql
   * @param resultSetType
   * @param resultSetConcurrency
   *
   * @return CallableStatement
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.CallableStatement prepareCall(String sql,
          int resultSetType, int resultSetConcurrency)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Creates a CallableStatement object that
   * will generate ResultSet objects with the
   * given type, concurrency and holdability.
   *
   * @param sql
   * @param resultSetType
   * @param resultSetConcurrency
   * @param resultSetHoldability
   *
   * @return CallableStatement
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.CallableStatement prepareCall(String sql,
          int resultSetType, int resultSetConcurrency,
          int resultSetHoldability)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Creates a PreparedStatement object for sending
   * parameterized SQL statements to the database.
   *
   * @param sql
   *
   * @return PreparedStatement
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.PreparedStatement prepareStatement(
          String sql)
  throws org.okip.service.dbc.api.DbcException {
    return new edu.mit.is.service.dbc.PreparedStatement(this, sql);
  }

  /**
   * Creates a default PreparedStatement object
   * that has the capability to retrieve
   * auto-generated keys.
   *
   * @param sql
   * @param autoGeneratedKeys
   *
   * @return PreparedStatement
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.PreparedStatement prepareStatement(
          String sql, int autoGeneratedKeys)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Creates a default PreparedStatement object
   * capable of returning the auto-generated keys
   * designated by the given array.
   *
   * @param sql
   * @param columnIndexes
   *
   * @return PreparedStatement
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.PreparedStatement prepareStatement(
          String sql, int[] columnIndexes)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Creates a PreparedStatement object that will
   * generate ResultSet objects with the given
   * type and concurrency.
   *
   * @param sql
   * @param resultSetType
   * @param resultSetConcurrency
   *
   * @return PreparedStatement
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.PreparedStatement prepareStatement(
          String sql, int resultSetType, int resultSetConcurrency)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Creates a PreparedStatement object that will
   * generate ResultSet objects with the given type,
   * concurrency, and holdability.
   *
   * @param sql
   * @param resultSetType
   * @param resultSetConcurrency
   * @param resultSetHoldability
   *
   * @return PreparedStatement
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.PreparedStatement prepareStatement(
          String sql, int resultSetType, int resultSetConcurrency,
          int resultSetHoldability)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Creates a default PreparedStatement object
   * capable of returning the auto-generated keys
   * designated by the given array.
   *
   * @param sql
   * @param columnNames
   *
   * @return PreparedStatement
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.PreparedStatement prepareStatement(
          String sql, String[] columnNames)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Removes the given Savepoint object from
   * the current transaction.
   *
   * @param savepoint
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public void releaseSavepoint(java.sql.Savepoint savepoint)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Undoes all changes made in the current
   * transaction and releases anydatabase locks
   * currently held by this Connection object.
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public void rollback()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Undoes all changes made after the given
   * Savepoint object was set.
   *
   * @param savepoint
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public void rollback(java.sql.Savepoint savepoint)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Sets this connection's auto-commit mode
   * to the given state.
   *
   *
   * @param catalog
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */

  /*     public void setAutoCommit(boolean autoCommit) throws DbcException
   {
   try {
       java.sql.Connection conn = getConnection() ;
       conn.setAutoCommit(autoCommit);
     } catch( java.sql.SQLException e ) {
       throw new DbcException(e.getMessage());

     }
   }*/

  /**
   * Sets the given catalog name in order to
   * select a subspace of this Connection
   * object's database in which to work.
   *
   * @param catalog
   *
   * @throws DbcException
   *
   */
  public void setCatalog(String catalog)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Changes the holdability of ResultSet
   * objects created using this Connection
   * object to the given holdability.
   *
   * @param holdability
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public void setHoldability(int holdability)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Puts this connection in read-only mode
   * as a hint to the driver to enable
   * database optimizations.
   *
   * @param readOnly
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public void setReadOnly(boolean readOnly)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Creates an unnamed savepoint in the current
   * transaction and returns the new Savepoint
   * object that represents it.
   *
   * @return Savepoint
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.Savepoint setSavepoint()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");

  }

  /**
   * Creates a savepoint with the given name in
   * the current transaction and returns the new
   * Savepoint object that represents it.
   *
   * @param name
   *
   * @return Savepoint
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.Savepoint setSavepoint(String name)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Attempts to change the transaction isolation
   * level for this Connection object to the one given.
   *
   * @param level
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public void setTransactionIsolation(int level)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Installs the given TypeMap object as
   * the type map for this Connection object.
   *
   * @param map
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */

  public void setTypeMap(java.util.Map map)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }
}
