package edu.mit.is.service.dbc;



/*
   Copyright (c) 2002 Massachusetts Institute of Technology

   This work, including any software, documents, or other related items
   (the "Work"), is being provided by the copyright holder(s) subject to
   the terms of the MIT OKI(TM) API Definition License. By obtaining,
   using and/or copying this Work, you agree that you have read,
   understand, and will comply with the following terms and conditions of
   the MIT OKI(TM) API Definition License:

   You may use, copy, and distribute unmodified versions of this Work for
   any purpose, without fee or royalty, provided that you include the
   following on ALL copies of the Work that you make or distribute:

    *  The full text of the MIT OKI(TM) API Definition License in a
       location viewable to users of the redistributed Work.

    *  Any pre-existing intellectual property disclaimers, notices, or
       terms and conditions. If none exist, a short notice similar to the
       following should be used within the body of any redistributed
       Work: "Copyright (c) 2002 Massachusetts Institute of Technology. All
       Rights Reserved."

   You may modify or create Derivatives of this Work only for your
   internal purposes. You shall not distribute or transfer any such
   Derivative of this Work to any location or any other third party. For
   purposes of this license, "Derivative" shall mean any derivative of
   the Work as defined in the United States Copyright Act of 1976, such
   as a translation or modification.

   THIS WORK PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE WORK
   OR THE USE OR OTHER DEALINGS IN THE WORK.

   The name and trademarks of copyright holder(s) and/or MIT may NOT be
   used in advertising or publicity pertaining to the Work without
   specific, written prior permission. Title to copyright in the Work and
   any associated documentation will at all times remain with the
   copyright holders.

*/

/*
 * $Source: /cvs/oki/tech/contrib/mit/impl/src/edu/mit/is/service/dbc/DatabaseMetaData.java,v $
 */

/**
 * Comprehensive information about the database as a whole.
 *
 * @see{java.sql.DatabaseMetaData}
 *
 * <p>
 * Licensed under the {@link org.okip.service.ApiLicense MIT OKI&#153; API Definition License}.
 *
 * @version $Name:  $ / $Revision: 1.5 $ / $Date: 2002/07/29 18:45:56 $
 */
public class DatabaseMetaData
implements org.okip.service.dbc.api.DatabaseMetaData, java.io.Serializable {

  /**
   * Retrieves whether the current user can
   * call all the procedures returned by
   * the method getProcedures.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean allProceduresAreCallable()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether the current user can
   * use all the tables returned by the method
   * getTables in a SELECT statement.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean allTablesAreSelectable()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether a data definition statement
   * within a transaction forces the transaction
   * to commit.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean dataDefinitionCausesTransactionCommit()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database ignores
   * a data definition statement within a
   * transaction.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean dataDefinitionIgnoredInTransactions()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether or not a visible row
   * delete can be detected by calling the
   * method ResultSet.rowDeleted.
   *
   * @param type
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean deletesAreDetected(int type)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether the return value for
   * the method getMaxRowSize includes the
   * SQL data types LONGVARCHAR and LONGVARBINARY.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean doesMaxRowSizeIncludeBlobs()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of the given
   * attribute of the given type for a
   * user-defined type (UDT) that is available
   * in the given schema and catalog.
   *
   * @param catalog
   * @param schemaPattern
   * @param typeNamePattern
   * @param attributeNamePattern
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getAttributes(String catalog,
          String schemaPattern, String typeNamePattern,
          String attributeNamePattern)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of a table's
   * optimal set of columns that uniquely
   * identifies a row.
   *
   * @param catalog
   * @param schema
   * @param table
   * @param scope
   * @param nullable
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getBestRowIdentifier(
          String catalog, String schema, String table, int scope,
          boolean nullable)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the catalog names available
   * in this database.
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getCatalogs()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the String that this database
   * uses as the separator between a catalog
   * and table name.
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getCatalogSeparator()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the database vendor's preferred
   * term for "catalog".
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getCatalogTerm()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of the access
   * rights for a table's columns.
   *
   * @param catalog
   * @param schema
   * @param table
   * @param columnNamePattern
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getColumnPrivileges(
          String catalog, String schema, String table,
          String columnNamePattern)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of table columns
   * available in the specified catalog.
   *
   * @param catalog
   * @param schemaPattern
   * @param tableNamePattern
   * @param columnNamePattern
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getColumns(String catalog,
          String schemaPattern, String tableNamePattern,
          String columnNamePattern)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the connection that produced
   * this metadata object.
   *
   * @return Connection
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.Connection getConnection()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of the foreign
   * key columns in the given foreign key
   * table that reference the primary key
   * columns of the given primary key table
   * (describe how one table imports
   * another's key).
   *
   * @param primaryCatalog
   * @param primarySchema
   * @param primaryTable
   * @param foreignCatalog
   * @param foreignSchema
   * @param foreignTable
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getCrossReference(
          String primaryCatalog, String primarySchema, String primaryTable,
          String foreignCatalog, String foreignSchema, String foreignTable)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the major version number
   * of the underlying database.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getDatabaseMajorVersion()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the minor version number
   * of the underlying database.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getDatabaseMinorVersion()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the name of this database
   * product.
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getDatabaseProductName()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the version number of
   * this database product.
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getDatabaseProductVersion()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves this database's default
   * transaction isolation level.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getDefaultTransactionIsolation()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves this JDBC driver's major
   * version number.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getDriverMajorVersion()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves this JDBC driver's minor
   * version number.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getDriverMinorVersion()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the name of this JDBC driver.
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getDriverName()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the version number of this
   * JDBC driver as a String.
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getDriverVersion()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of the
   * foreign key columns that reference
   * the given table's primary key columns
   * (the foreign keys exported by a table).
   *
   * @param catalog
   * @param schema
   * @param table
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getExportedKeys(String catalog,
          String schema, String table)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves all the "extra" characters
   * that can be used in unquoted identifier
   * names (those beyond a-z, A-Z, 0-9 and _).
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getExtraNameCharacters()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the string used to quote
   * SQL identifiers.
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getIdentifierQuoteString()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of the primary
   * key columns that are referenced by a
   * table's foreign key columns (the primary
   * keys imported by a table).
   *
   * @param catalog
   * @param schema
   * @param table
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getImportedKeys(String catalog,
          String schema, String table)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of the given
   * table's indices and statistics.
   *
   * @param catalog
   * @param schema
   * @param table
   * @param unique
   * @param approximate
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getIndexInfo(String catalog,
          String schema, String table, boolean unique, boolean approximate)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the major JDBC version
   * number for this driver.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getJDBCMajorVersion()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the minor JDBC version
   * number for this driver.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getJDBCMinorVersion()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * hex characters this database allows
   * in an inline binary literal.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxBinaryLiteralLength()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * characters that this database allows
   * in a catalog name.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxCatalogNameLength()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * characters this database allows
   * for a character literal.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxCharLiteralLength()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * characters this database allows
   * for a column name.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxColumnNameLength()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * columns this database allows in
   * a GROUP BY clause.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxColumnsInGroupBy()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * columns this database allows in
   * an index.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxColumnsInIndex()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * columns this database allows in
   * an ORDER BY clause.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxColumnsInOrderBy()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * columns this database allows in
   * a SELECT list.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxColumnsInSelect()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * columns this database allows in
   * a table.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxColumnsInTable()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * concurrent connections to this
   * database that are possible.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxConnections()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * characters that this database
   * allows in a cursor name.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxCursorNameLength()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * bytes this database allows for an
   * index, including all of the parts
   * of the index.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxIndexLength()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * characters that this database allows
   * in a procedure name.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxProcedureNameLength()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * bytes this database allows in a
   * single row.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxRowSize()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * characters that this database
   * allows in a schema name.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxSchemaNameLength()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * characters this database allows
   * in an SQL statement.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxStatementLength()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * active statements to this database
   * that can be open at the same time.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxStatements()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * characters this database allows
   * in a table name.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxTableNameLength()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * tables this database allows in a
   * SELECT statement.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxTablesInSelect()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of
   * characters this database allows
   * in a user name.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getMaxUserNameLength()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a comma-separated list
   * of math functions available with
   * this database.
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getNumericFunctions()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of the
   * given table's primary key columns.
   *
   * @param catalog
   * @param schema
   * @param table
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getPrimaryKeys(String catalog,
          String schema, String table)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of the
   * given catalog's stored procedure
   * parameter and result columns.
   *
   * @param catalog
   * @param schemaPattern
   * @param procedureNamePattern
   * @param columnNamePattern
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getProcedureColumns(
          String catalog, String schemaPattern, String procedureNamePattern,
          String columnNamePattern)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of the
   * stored procedures available
   * in the given catalog.
   *
   * @param catalog
   * @param schemaPattern
   * @param procedureNamePattern
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getProcedures(String catalog,
          String schemaPattern, String procedureNamePattern)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the database vendor's
   * preferred term for "procedure".
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getProcedureTerm()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the default holdability
   * of this ResultSet object.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getResultSetHoldability()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the schema names
   * available in this database.
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getSchemas()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the database vendor's
   * preferred term for "schema".
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getSchemaTerm()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the string that can be
   * used to escape wildcard characters.
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getSearchStringEscape()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a comma-separated list of
   * all of this database's SQL keywords
   * that are NOT also SQL92 keywords.
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getSQLKeywords()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Indicates whether the SQLSTATEs
   * returned by SQLException.getSQLState
   * is X/Open (now known as Open Group)
   * SQL CLI or SQL99.
   *
   * @return int
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public int getSQLStateType()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a comma-separated list
   * of string functions available with
   * this database.
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getStringFunctions()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of the table
   * hierarchies defined in a particular
   * schema in this database.
   *
   * @param catalog
   * @param schemaPattern
   * @param tableNamePattern
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getSuperTables(String catalog,
          String schemaPattern, String tableNamePattern)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of the
   * user-defined type (UDT) hierarchies
   * defined in a particular schema in
   * this database.
   *
   * @param catalog
   * @param schemaPattern
   * @param typeNamePattern
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getSuperTypes(String catalog,
          String schemaPattern, String typeNamePattern)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a comma-separated list
   * of system functions available with
   * this database.
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getSystemFunctions()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of the
   * access rights for each table
   * available in a catalog.
   *
   * @param catalog
   * @param schemaPattern
   * @param tableNamePattern
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getTablePrivileges(String catalog,
          String schemaPattern, String tableNamePattern)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of the
   * tables available in the given catalog.
   *
   * @param catalog
   * @param schemaPattern
   * @param tableNamePattern
   * @param types
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getTables(String catalog,
          String schemaPattern, String tableNamePattern, String[] types)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the table types
   * available in this database.
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getTableTypes()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a comma-separated list
   * of the time and date functions
   * available with this database.
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getTimeDateFunctions()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of all
   * the standard SQL types supported
   * by this database.
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getTypeInfo()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of the
   * user-defined types (UDTs) defined
   * in a particular schema.
   *
   * @param catalog
   * @param schemaPattern
   * @param typeNamePattern
   * @param types
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getUDTs(String catalog,
          String schemaPattern, String typeNamePattern, int[] types)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the URL for this DBMS.
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getURL()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the user name as
   * known to this database.
   *
   * @return String
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public String getUserName()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves a description of a table's
   * columns that are automatically updated
   * when any value in a row is updated.
   *
   * @param catalog
   * @param schema
   * @param table
   *
   * @return ResultSet
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public org.okip.service.dbc.api.ResultSet getVersionColumns(String catalog,
          String schema, String table)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether or not a visible
   * row insert can be detected by calling
   * the method ResultSet.rowInserted.
   *
   * @param type
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean insertsAreDetected(int type)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether a catalog appears
   * at the start of a fully qualified
   * table name.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean isCatalogAtStart()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database
   * is in read-only mode.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean isReadOnly()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Indicates whether updates made
   * to a LOB are made on a copy or
   * directly to the LOB.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean locatorsUpdateCopy()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database
   * supports concatenations between
   * NULL and non-NULL values being NULL.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean nullPlusNonNullIsNull()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether NULL values are
   * sorted at the end regardless of
   * sort order.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean nullsAreSortedAtEnd()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether NULL values are
   * sorted at the start regardless of
   * sort order.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean nullsAreSortedAtStart()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether NULL values are
   * sorted high.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean nullsAreSortedHigh()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether NULL values are
   * sorted low.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean nullsAreSortedLow()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether deletes made by
   * others are visible.
   *
   * @param type
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean othersDeletesAreVisible(int type)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether inserts made by
   * others are visible.
   *
   * @param type
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean othersInsertsAreVisible(int type)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether updates made by
   * others are visible.
   *
   * @param type
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean othersUpdatesAreVisible(int type)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether a result set's
   * own deletes are visible.
   *
   * @param type
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean ownDeletesAreVisible(int type)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether a result set's
   * own inserts are visible.
   *
   * @param type
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean ownInsertsAreVisible(int type)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether for the given
   * type of ResultSet object, the result
   * set's own updates are visible.
   *
   * @param type
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean ownUpdatesAreVisible(int type)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database treats
   * mixed case unquoted SQL identifiers as
   * case insensitive and stores them in
   * lower case.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean storesLowerCaseIdentifiers()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database treats
   * mixed case quoted SQL identifiers as
   * case insensitive and stores them in
   * lower case.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean storesLowerCaseQuotedIdentifiers()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database treats
   * mixed case unquoted SQL identifiers as
   * case insensitive and stores them in
   * mixed case.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean storesMixedCaseIdentifiers()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database treats
   * mixed case quoted SQL identifiers as
   * case insensitive and stores them in
   * mixed case.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean storesMixedCaseQuotedIdentifiers()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database treats
   * mixed case unquoted SQL identifiers as
   * case insensitive and stores them in
   * upper case.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean storesUpperCaseIdentifiers()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database treats
   * mixed case quoted SQL identifiers as
   * case insensitive and stores them in
   * upper case.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean storesUpperCaseQuotedIdentifiers()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database
   * supports ALTER TABLE with add column.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsAlterTableWithAddColumn()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database
   * supports ALTER TABLE with drop column.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsAlterTableWithDropColumn()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database
   * supports the ANSI92 entry level
   * SQL grammar.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsANSI92EntryLevelSQL()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database
   * supports the ANSI92 full SQL
   * grammar supported.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsANSI92FullSQL()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database
   * supports the ANSI92 intermediate
   * SQL grammar supported.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsANSI92IntermediateSQL()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database
   * supports batch updates.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsBatchUpdates()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether a catalog name can
   * be used in a data manipulation statement.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsCatalogsInDataManipulation()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether a catalog name can
   * be used in an index definition statement.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsCatalogsInIndexDefinitions()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether a catalog name can
   * be used in a privilege definition statement.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsCatalogsInPrivilegeDefinitions()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether a catalog name can
   * be used in a procedure call statement.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsCatalogsInProcedureCalls()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether a catalog name can
   * be used in a table definition statement.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsCatalogsInTableDefinitions()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database
   * supports column aliasing.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsColumnAliasing()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * the CONVERT function between SQL types.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsConvert()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * the CONVERT for two given SQL types.
   *
   * @param fromType
   * @param toType
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsConvert(int fromType, int toType)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * the ODBC Core SQL grammar.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsCoreSQLGrammar()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * correlated subqueries.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsCorrelatedSubqueries()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * both data definition and data manipulation
   * statements within a transaction.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsDataDefinitionAndDataManipulationTransactions()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * only data manipulation statements within
   * a transaction.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsDataManipulationTransactionsOnly()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether, when table correlation
   * names are supported, they are restricted
   * to being different from the names of the
   * tables.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsDifferentTableCorrelationNames()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * expressions in ORDER BY lists.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsExpressionsInOrderBy()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * the ODBC Extended SQL grammar.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsExtendedSQLGrammar()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * full nested outer joins.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsFullOuterJoins()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether auto-generated keys
   * can be retrieved after a statement has
   * been executed.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsGetGeneratedKeys()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * some form of GROUP BY clause.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsGroupBy()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * using columns not included in the SELECT
   * statement in a GROUP BY clause provided
   * that all of the columns in the SELECT
   * statement are included in the GROUP BY
   * clause.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsGroupByBeyondSelect()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * using a column that is not in the SELECT
   * statement in a GROUP BY clause.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsGroupByUnrelated()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * the SQL Integrity Enhancement Facility.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsIntegrityEnhancementFacility()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * specifying a LIKE escape clause.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsLikeEscapeClause()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database provides
   * limited support for outer joins.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsLimitedOuterJoins()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * the ODBC Minimum SQL grammar.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsMinimumSQLGrammar()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database treats
   * mixed case unquoted SQL identifiers as
   * case sensitive and as a result stores
   * them in mixed case.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsMixedCaseIdentifiers()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database treats
   * mixed case quoted SQL identifiers as case
   * sensitive and as a result stores them
   * in mixed case.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsMixedCaseQuotedIdentifiers()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether it is possible to have
   * multiple ResultSet objects returned from
   * a CallableStatement object simultaneously.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsMultipleOpenResults()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * getting multiple ResultSet objects from a
   * single call to the method execute.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsMultipleResultSets()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database allows
   * having multiple transactions open at
   * once (on different connections).
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsMultipleTransactions()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * named parameters to callable statements.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsNamedParameters()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether columns in this
   * database may be defined as non-nullable.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsNonNullableColumns()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * keeping cursors open across commits.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsOpenCursorsAcrossCommit()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * keeping cursors open across rollbacks.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsOpenCursorsAcrossRollback()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * keeping statements open across commits.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsOpenStatementsAcrossCommit()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * keeping statements open across rollbacks.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsOpenStatementsAcrossRollback()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * using a column that is not in the SELECT
   * statement in an ORDER BY clause.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsOrderByUnrelated()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * some form of outer join.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsOuterJoins()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * positioned DELETE statements.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsPositionedDelete()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * positioned UPDATE statements.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsPositionedUpdate()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * the given concurrency type in combination
   * with the given result set type.
   *
   * @param type
   * @param concurrency
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsResultSetConcurrency(int type, int concurrency)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * the given result set holdability.
   *
   * @param holdability
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsResultSetHoldability(int holdability)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * the given result set type.
   *
   * @param type
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsResultSetType(int type)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * savepoints.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsSavepoints()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether a schema name can be
   * used in a data manipulation statement.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsSchemasInDataManipulation()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether a schema name can be
   * used in an index definition statement.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsSchemasInIndexDefinitions()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether a schema name can be
   * used in a privilege definition statement.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsSchemasInPrivilegeDefinitions()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether a schema name can be
   * used in a procedure call statement.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsSchemasInProcedureCalls()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether a schema name can be
   * used in a table definition statement.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsSchemasInTableDefinitions()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * SELECT FOR UPDATE statements.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsSelectForUpdate()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves weather this database supports
   * statement pooling.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsStatementPooling()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * stored procedure calls that use the stored
   * procedure escape syntax.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsStoredProcedures()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * subqueries in comparison expressions.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsSubqueriesInComparisons()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * subqueries in EXISTS expressions.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsSubqueriesInExists()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * subqueries in IN statements.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsSubqueriesInIns()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * subqueries in quantified expressions.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsSubqueriesInQuantifieds()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * table correlation names.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsTableCorrelationNames()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * the given transaction isolation level.
   *
   * @param level
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsTransactionIsolationLevel(int level)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * transactions.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsTransactions()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * SQL UNION.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsUnion()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database supports
   * SQL UNION ALL.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean supportsUnionAll()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether or not a visible row
   * update can be detected by calling the
   * method ResultSet.rowUpdated.
   *
   * @param type
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean updatesAreDetected(int type)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database uses
   * a file for each table.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean usesLocalFilePerTable()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this database
   * stores tables in a local file.
   *
   * @return boolean
   *
   *
   * @throws org.okip.service.dbc.api.DbcException
   *
   */
  public boolean usesLocalFiles()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

}
