package edu.mit.is.service.dbc;



/*
   Copyright (c) 2002 Massachusetts Institute of Technology

   This work, including any software, documents, or other related items
   (the "Work"), is being provided by the copyright holder(s) subject to
   the terms of the MIT OKI(TM) API Definition License. By obtaining,
   using and/or copying this Work, you agree that you have read,
   understand, and will comply with the following terms and conditions of
   the MIT OKI(TM) API Definition License:

   You may use, copy, and distribute unmodified versions of this Work for
   any purpose, without fee or royalty, provided that you include the
   following on ALL copies of the Work that you make or distribute:

    *  The full text of the MIT OKI(TM) API Definition License in a
       location viewable to users of the redistributed Work.

    *  Any pre-existing intellectual property disclaimers, notices, or
       terms and conditions. If none exist, a short notice similar to the
       following should be used within the body of any redistributed
       Work: "Copyright (c) 2002 Massachusetts Institute of Technology. All
       Rights Reserved."

   You may modify or create Derivatives of this Work only for your
   internal purposes. You shall not distribute or transfer any such
   Derivative of this Work to any location or any other third party. For
   purposes of this license, "Derivative" shall mean any derivative of
   the Work as defined in the United States Copyright Act of 1976, such
   as a translation or modification.

   THIS WORK PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE WORK
   OR THE USE OR OTHER DEALINGS IN THE WORK.

   The name and trademarks of copyright holder(s) and/or MIT may NOT be
   used in advertising or publicity pertaining to the Work without
   specific, written prior permission. Title to copyright in the Work and
   any associated documentation will at all times remain with the
   copyright holders.

*/

/*
 * $Source: /cvs/oki/tech/contrib/mit/impl/src/edu/mit/is/service/dbc/RowSet.java,v $
 */

/**
 * The interface that adds support to the OKI DBC API for the
 * JavaBeansTM component model. A rowset, which can be used as a
 * JavaBeans component in a visual Bean development environment, can
 * be created and configured at design time and executed at run time.
 *
 * <p>
 * Licensed under the {@link org.okip.service.ApiLicense MIT OKI&#153; API Definition License}.
 *
 * @version $Name:  $ / $Revision: 1.7 $ / $Date: 2002/07/29 18:45:56 $
 */
public class RowSet
extends ResultSet
implements org.okip.service.dbc.api.RowSet, java.io.Serializable {

  /* methods which are in RowSet in 1.4 but not in this interface:
     addRowSetListener
     removeRowSetListener
     setAsciiStream
     setBinaryStream
     setCharacterStream
   */

  /**
   * Clears the parameters set for this RowSet object's command.
   *
   */
  public void clearParameters()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Fills this RowSet object with data.
   *
   */
  public void execute()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves this RowSet object's command property.
   *
   * @return String that is a valid SQL query.
   */
  public String getCommand()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the logical name that identifies the
   * data source for this RowSet object.
   *
   * @return String
   */
  public String getDataSourceName()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether escape processing is enabled
   * for this RowSet object.
   *
   * @return boolean
   */
  public boolean getEscapeProcessing()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of bytes that may
   * be returned for certain column values.
   *
   * @return int
   */
  public int getMaxFieldSize()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of rows that this
   * RowSet object can contain.
   *
   * @return int
   */
  public int getMaxRows()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the password used to create a database
   * connection.
   *
   * @return String
   */
  public String getPassword()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the maximum number of seconds the driver
   * will wait for a statement to execute.
   *
   * @return int
   */
  public int getQueryTimeout()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the transaction isolation level set for
   * this RowSet object.
   *
   * @return int
   */
  public int getTransactionIsolation()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the Map object associated with this RowSet
   * object, which specifies the custom mapping of SQL
   * user-defined types, if any.
   *
   * @return java.util.Map
   */
  public java.util.Map getTypeMap()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the url property this RowSet object will use
   * to create a connection if it uses the DriverManager
   * instead of a DataSource object to establish the
   * connection.
   *
   * @return String
   */
  public String getUrl()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves the username used to create a database
   * connection for this RowSet object.
   *
   * @return String
   */
  public String getUsername()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Retrieves whether this RowSet object is read-only.
   *
   * @return boolean
   */
  public boolean isReadOnly()
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command with the given Array value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setArray(int parameterIndex, org.okip.service.dbc.api.Array x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command to the given java.math.BigDecimal
   * value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setBigDecimal(int parameterIndex, java.math.BigDecimal x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command with the given Blob value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setBlob(int parameterIndex, org.okip.service.dbc.api.Blob x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command to the given Java boolean value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setBoolean(int parameterIndex, boolean x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command to the given Java byte value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setByte(int parameterIndex, byte x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command to the given Java array of
   * byte values.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setBytes(int parameterIndex, byte[] x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command with the given Clob value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setClob(int parameterIndex, org.okip.service.dbc.api.Clob x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets this RowSet object's command property
   * to the given SQL query.
   *
   * @param cmd
   *
   */
  public void setCommand(String cmd)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the concurrency of this RowSet object
   * to the given concurrency level.
   *
   * @param concurrency
   *
   */
  public void setConcurrency(int concurrency)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the data source name property for this
   * RowSet object to the given String.
   *
   * @param name
   *
   */
  public void setDataSourceName(String name)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this
   * RowSet object's command to the given
   * java.sql.Date value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setDate(int parameterIndex, java.sql.Date x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this
   * RowSet object's command with the given
   * java.sql.Date and java.util.Calendar values.
   *
   * @param parameterIndex
   * @param x
   * @param cal
   *
   */
  public void setDate(int parameterIndex, java.sql.Date x,
                      java.util.Calendar cal)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this
   * RowSet object's command to the given Java
   * double value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setDouble(int parameterIndex, double x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets escape processing for this RowSet
   * object on or off.
   *
   * @param enable
   */
  public void setEscapeProcessing(boolean enable)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command to the given Java float value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setFloat(int parameterIndex, float x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command to the given Java int value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setInt(int parameterIndex, int x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command to the given Java long value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setLong(int parameterIndex, long x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the maximum number of bytes that can be
   * returned for a column value to the given
   * number of bytes.
   *
   * @param max
   *
   */
  public void setMaxFieldSize(int max)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the maximum number of rows that this RowSet
   * object can contain to the specified number.
   *
   * @param max
   *
   */
  public void setMaxRows(int max)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's SQL command to SQL NULL.
   *
   * @param parameterIndex
   * @param sqlType
   *
   */
  public void setNull(int parameterIndex, int sqlType)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's SQL command to SQL NULL.
   *
   *
   * @param paramIndex
   * @param sqlType
   * @param typeName
   *
   */
  public void setNull(int paramIndex, int sqlType, String typeName)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command with a Java Object.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setObject(int parameterIndex, Object x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command with a Java Object.
   *
   * @param parameterIndex
   * @param x
   * @param targetSqlType
   *
   */
  public void setObject(int parameterIndex, Object x, int targetSqlType)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command with the given Java Object.
   *
   * @param parameterIndex
   * @param x
   * @param targetSqlType
   * @param scale
   *
   */
  public void setObject(int parameterIndex, Object x, int targetSqlType,
                        int scale)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the database password for this RowSet
   * object to the given String.
   *
   * @param password
   */
  public void setPassword(String password)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the maximum time the driver will wait
   * for a statement to execute to the given
   * number of seconds.
   *
   * @param seconds
   *
   */
  public void setQueryTimeout(int seconds)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets whether this RowSet object is read-only
   * to the given boolean.
   *
   *
   * @param value
   *
   */
  public void setReadOnly(boolean value)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command with the given Ref value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setRef(int parameterIndex, java.sql.Ref x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command to the given Java Short value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setShort(int parameterIndex, short x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command to the given Java String value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setString(int parameterIndex, String x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command to the given java.sql.Time value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setTime(int parameterIndex, java.sql.Time x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command with the given java.sql.Time
   * and java.util.Calendar values.
   *
   * @param parameterIndex
   * @param x
   * @param cal
   *
   */
  public void setTime(int parameterIndex, java.sql.Time x,
                      java.util.Calendar cal)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command to the given java.sql.Timestamp
   * value.
   *
   * @param parameterIndex
   * @param x
   *
   */
  public void setTimestamp(int parameterIndex, java.sql.Timestamp x)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the designated parameter in this RowSet
   * object's command with the given java.sql.Timestamp
   * and java.util.Calendar values.
   *
   * @param parameterIndex
   * @param x
   * @param cal
   *
   */
  public void setTimestamp(int parameterIndex, java.sql.Timestamp x,
                           java.util.Calendar cal)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the transaction isolation level for this
   * RowSet object.
   *
   * @param level
   *
   */
  public void setTransactionIsolation(int level)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the type of this RowSet object to the
   * given type.
   *
   * @param type
   *
   */
  public void setType(int type)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Installs the given java.util.Map object
   * as the default type map for this RowSet
   * object.
   *
   * @param typeMap
   *
   */
  public void setTypeMap(java.util.Map typeMap)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the URL this RowSet object will use
   * when it uses the DriverManager to
   * create a connection.
   *
   * @param url
   *
   */
  public void setUrl(String url)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }

  /**
   * Sets the username property for this RowSet
   * object to the given String.
   *
   * @param name
   *
   */
  public void setUsername(String name)
  throws org.okip.service.dbc.api.DbcException {
    throw new org.okip.service.dbc.api.DbcException("NOT IMPLEMENTED");
  }
}
