package edu.mit.is.service.dbc;



/**
 * Class RuntimePool
 *
 *
 * @author
 * @version %I%, %G%
 */
public class RuntimePool {
  private static java.util.Hashtable contexts = new java.util.Hashtable();

  /**
   * Method contains
   *
   *
   * @param key
   *
   * @return boolean
   *
   */
  public static boolean contains(Object key) {
    try {
      if (null != key) {
        Runtime runtime = Runtime.getRuntime();

        if (contexts.containsKey(runtime)) {
          java.util.Hashtable context =
            (java.util.Hashtable) contexts.get(runtime);

          return (context.containsKey(key));
        }
      }
    }
    catch (Exception ex) {}

    return false;
  }

  /**
   * Method setProperty
   *
   *
   * @param key
   * @param value
   *
   */
  public static void setProperty(Object key, Object value) {
    try {
      if (null != key) {
        Runtime runtime = Runtime.getRuntime();

        if (!contexts.containsKey(runtime)) {
          contexts.put(runtime, new java.util.Hashtable());
        }

        java.util.Hashtable context =
          (java.util.Hashtable) contexts.get(runtime);

        if (null != value) {
          context.put(key, value);

        }
        else {
          context.remove(key);
        }
      }
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  /**
   * Method getProperty
   *
   *
   * @param key
   *
   * @return Object
   *
   */
  public static Object getProperty(Object key) {
    try {
      if (null != key) {
        Runtime runtime = Runtime.getRuntime();

        if (contexts.containsKey(runtime)) {
          java.util.Hashtable context =
            (java.util.Hashtable) contexts.get(runtime);

          return (context.get(key));
        }
      }
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }

    return null;
  }

  /**
   * Method getKeys
   *
   *
   * @return java.util.Enumeration
   *
   */
  public static java.util.Enumeration getKeys() {
    try {
      Runtime runtime = Runtime.getRuntime();

      if (contexts.containsKey(runtime)) {
        java.util.Hashtable context =
          (java.util.Hashtable) contexts.get(runtime);

        return (context.keys());
      }
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }

    return null;
  }

  /**
   * Method removeProperty
   *
   *
   * @param key
   *
   * @return Object
   *
   */
  public static Object removeProperty(String key) {
    try {
      if (null != key) {
        Runtime runtime = Runtime.getRuntime();

        if (!contexts.containsKey(runtime)) {
          java.util.Hashtable context =
            (java.util.Hashtable) contexts.get(runtime);

          if (context.containsKey(key)) {
            Object value = context.get(key);

            if (value instanceof java.sql.Connection) {
              ((java.sql.Connection) value).close();
            }
            else if (value instanceof java.sql.ResultSet) {
              ((java.sql.ResultSet) value).close();
            }

            Object obj = context.remove(key);

            System.gc();

            return (obj);
          }
        }
      }
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }

    return null;
  }

}
