package edu.mit.is.util.romi.client;

public class Client
implements org.okip.util.romi.client.api.Client //, java.io.Serializable
{
  private transient String host = null;

  /**
   * Method getHost
   *
   *
   * @return String
   *
   */
  public String getHost() {
    return this.host;
  }

  protected void setHost(String host) {
    this.host = host;
  }

  private transient int port=0;

  /**
   * Method getPort
   *
   *
   * @return int
   *
   */
  public int getPort() {
    return this.port;
  }

  protected void setPort(int port) {
    this.port = port;
  }

  private transient String server = null;

  /**
   * Method getServer
   *
   *
   * @return String
   *
   */
  public String getServer() {
    return this.server;
  }

  protected void setServer(String server) {
    this.server = server;
  }

  private transient org.okip.util.romi.client.api.Factory factory = null;

  /**
   * Method getFactory
   *
   *
   * @return org.okip.util.romi.client.api.Factory
   *
   */
  public org.okip.util.romi.client.api.Factory getFactory() {
    return this.factory;
  }

  protected void setFactory(
          org.okip.util.romi.client.api.Factory factory) {
    this.factory = factory;
  }

  private transient Object response = null;

  /**
   * Method getResponse
   *
   *
   * @return Object
   *
   */
  public Object getResponse() {
    return this.response;
  }

  protected void setResponse(Object response) {
    this.response = response;
  }

  private transient edu.mit.is.util.romi.Remote remote = null;

  protected edu.mit.is.util.romi.Remote getRemote() {
    return this.remote;
  }

  protected void setRemote(edu.mit.is.util.romi.Remote remote) {
    this.remote = remote;
  }

  private Client() {}

  /**
   * Method create
   *
   * @param factory
   * @param host
   * @param port
   * @param server
   * //@param owner
   *
   * @return org.okip.util.romi.client.api.Client
   *
   * @throws org.okip.util.romi.client.api.ClientException
   *
   */
  public static org.okip.util.romi.client.api.Client create(org.okip.util.romi.client.api.Factory factory,
                                                            String host,
                                                            int port,
                                                            String server)
  throws org.okip.util.romi.client.api.ClientException {
    Client client = new Client();
    client.setFactory(factory);
    client.setHost(host);
    client.setPort(port);
    client.setServer(server);
    client.setup();
    return client;
  }


  public static boolean isValid(Client client) throws org.okip.util.romi.client.api.ClientException
  {
    if (  null != client
       && null != client.getFactory()
       && null != client.getHost()
     /* [GS] CHANGE (TIGHTEN CONSTRAINTS?):  && 0 != client.getPort() */
       && null != client.getServer())
    {
      return true;
    }

    else {
      return false;
    }
  }

  /**
   * Method authenticate
   *
   *
   * @param ticket
   *
   * @return Boolean
   *
   * @throws org.okip.util.romi.client.api.ClientException
   *
   */
  public boolean authenticate(byte[] ticket) throws org.okip.util.romi.client.api.ClientException {

    try {
      if (isValid(this) && null != getRemote()) {
        return getRemote().authenticate(ticket);
      }
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }

    return false;
  }

  /**
   * Method invoke
   *
   *
   * @param object
   * @param methodName
   * @param argTypes
   * @param args
   *
   * @return Object
   *
   * @throws org.okip.util.romi.client.api.ClientException
   *
   */

   public Object invoke(java.io.Serializable object, String methodName,
                          Class[] argTypes, Object[] args)
       throws org.okip.util.romi.client.api.ClientException
    {
       try {
         if (isValid(this) && null != getRemote()) {
           Object resp = getRemote().invoke(object, methodName, argTypes, args);
           setResponse(resp);
         }
         else {
            throw new org.okip.util.romi.client.api.ClientException(org.okip.util.romi.client.api.ClientException.INVALIDCLIENT);
         }
       }
       catch (Exception ex) {
         ex.printStackTrace();
         setResponse(ex);
       }

       try {
         if (getResponse() instanceof Exception) {
         throw (org.okip.util.romi.client.api.ClientException) getResponse();
       }
       return getResponse();
      }

      catch (Exception e) {
        e.printStackTrace();
      }

      return null;
  }


  /**
   * Method test
   *
   *
   * @return String
   *
   * @throws org.okip.util.romi.client.api.ClientException
   *
   */
   public String test() throws org.okip.util.romi.client.api.ClientException
   {
    try {
     if (isValid(this) && null != getRemote()) {
       return getRemote().test();
     }
    }
    catch ( Exception ex)
    {
     ex.printStackTrace();
    }
     return "Test failed.";
  }

  protected void setup() throws org.okip.util.romi.client.api.ClientException
  {
    setResponse(null);
    try {
      if (null == System.getSecurityManager()) {
        System.setSecurityManager(new java.rmi.RMISecurityManager());
      }

      if (null == getRemote()) {

      // [GS] CHANGE: edu.mit.is.util.romi.Remote remote = (edu.mit.is.util.romi.Remote) java.rmi.Naming.lookup(
      // [GS] CHANGE:                                         "rmi://" + getHost().trim() + "/" + getServer().trim());
      edu.mit.is.util.romi.Remote remote = (edu.mit.is.util.romi.Remote) java.rmi.Naming.lookup(
                                                "rmi://" + getHost().trim() + (getPort() != 0 ? ":" + getPort() : "") + "/" + getServer().trim());

      setRemote(remote);

        /*
        if (null != getFactory()) {
          System.out.println("get a not null factory "+ getFactory().getClass().getName());
          org.okip.service.authentication.api.Factory afactory =
            (org.okip.service.authentication.api.Factory)
              org.okip.service.shared.api.FactoryManager.getFactory(
                "org.okip.service.authentication.api",
                "edu.mit.is.service.authentication.impl.authenkrb4",
                getFactory().getOwner());


         System.out.println("getting an athen factory");


          //[chs: 4/24/2002 begin]
          edu.mit.is.service.authentication.impl.authenkrb4.AuthenticatedAgent aa =
            (edu.mit.is.service.authentication.impl.authenkrb4.AuthenticatedAgent)
              afactory.getAgent(getFactory().getOwner(),
                new edu.mit.is.service.authentication.impl.authenkrb4.Krb4Type() );
          krb4.lib.Krb4Creds creds = (krb4.lib.Krb4Creds) aa.getCredentials();
          String kerberosName = aa.getKerberosName();
          if (null != creds) {
            byte[] ticket =
              edu.mit.is.service.authentication.impl.authenkrb4.Authenticate.getServiceTicket(
                creds, getService(), getHost(), kerberosName, "");
          //[chs: 4/24/2002 end]

            authenticate(ticket);

          }
        }*/
      }
    }
    catch(Throwable ex) {
      ex.printStackTrace();
      throw new org.okip.util.romi.client.api.ClientException("");
    }
  }
}
