package edu.mit.is.util.romi.server;

public class ClientSocketFactory
implements java.rmi.server.RMIClientSocketFactory, java.io.Serializable {
  private static final int                        SOCKET_TIMEOUT = 10000;
  private static javax.net.SocketFactory          sslFactory     = null;
  private static java.rmi.server.RMISocketFactory rmiFactory     = null;

  /**
   * Method createSocket
   *
   *
   * @param host
   * @param port
   *
   * @return java.net.Socket
   *
   * @throws java.io.IOException
   *
   */
  public java.net.Socket createSocket(String host, int port)
  throws java.io.IOException {
    if (null == sslFactory) {
      sslFactory = javax.net.ssl.SSLSocketFactory.getDefault();
    }

    javax.net.ssl.SSLSocket s =
      (javax.net.ssl.SSLSocket) sslFactory.createSocket(host, port);

    s.setEnabledCipherSuites(s.getSupportedCipherSuites());
    s.setSoTimeout(SOCKET_TIMEOUT);

    return s;
  }

  /**
   * Method equals
   *
   *
   * @param that
   *
   * @return boolean
   *
   */
  public boolean equals(Object that) {
    return (that != null) && (that.getClass() == this.getClass());
  }

}
