package edu.mit.is.util.romi.server;

public class Server extends java.rmi.activation.Activatable
                    implements edu.mit.is.util.romi.Remote
{
  protected String            service         = null;
  protected transient byte[]  srvtab          = null;
  protected transient boolean isAuthenticated = true;
  protected String            tag             = null;

  /**
   * Constructor Server
   *
   *
   * @param id
   * @param data
   *
   * @throws Exception
   *
   */
  public Server(java.rmi.activation.ActivationID id,
                java.rmi.MarshalledObject data)
  throws Exception {
    super(
      id, 0,
      (java.rmi.server.RMIClientSocketFactory) new edu.mit.is.util.romi.server.ClientSocketFactory(),
      (java.rmi.server.RMIServerSocketFactory) new edu.mit.is.util.romi.server.ServerSocketFactory());

    srvtab = (byte[]) data.get();

    if (null != srvtab) {
      isAuthenticated = false;
    }
  }

  /**
   * Method authenticate
   *
   *
   * @param ticket
   *
   * @return boolean
   *
   */
  public boolean authenticate(byte[] ticket) {
    try {
      edu.mit.is.service.authentication.impl.authenkrb4.Authenticate authenticate  =
        new edu.mit.is.service.authentication.impl.authenkrb4.Authenticate();
      byte[]                                           clientAddress =
        java.net.InetAddress.getByName(getClientHost()).getAddress();
      String                                           host          =
        java.net.InetAddress.getLocalHost().getHostName();

      this.tag = authenticate.isValidClient(ticket, clientAddress, srvtab);

      ThreadContext.setProperty("Tag", this.tag);

      isAuthenticated = true;

      return true;
    }
    catch (Throwable ex) {}

    return false;
  }

  /**
   * Method invoke
   *
   *
   * @param object
   * @param methodName
   * @param argTypes
   * @param args
   *
   * @return Object
   *
   */
  public Object invoke(java.io.Serializable object, String methodName,
                       Class[] argTypes, Object[] args)
  {
    Object response = null;

    isAuthenticated = true;    // leave out the athenatication stuff   BLAI
    try {
      if (isAuthenticated) {
        java.lang.reflect.Method method = null;
        if (!(object instanceof java.lang.Class)) {
          method = object.getClass().getMethod(methodName, argTypes);
        }
        else {
          method = ((Class) object).getMethod(methodName, argTypes);
        }
        response = method.invoke(object, args);
      }
      else {
        response =
          new org.okip.util.romi.server.api.ServerException("Not Authenticated");
      }
    }
    catch (Throwable ex) {
      response = ex;
    }

    return response;
  }

  /**
   * Method test
   *
   *
   * @return String
   *
   */
  public String test() {
    return "Test successful";
  }

}
