package edu.mit.is.util.romi.server;

public class ServerSocketFactory
implements java.rmi.server.RMIServerSocketFactory, java.io.Serializable {
  private static final int                     ANONYMOUS_PORT = 0;
  private static final int                     MAX_PORTS      = 100;
  private static javax.net.ServerSocketFactory sslFactory     = null;

  /**
   * Method createServerSocket
   *
   *
   * @param port
   *
   * @return java.net.ServerSocket
   *
   * @throws java.io.IOException
   *
   */
  public java.net.ServerSocket createServerSocket(int port)
  throws java.io.IOException {
    int       ssport    = port;
    Exception exception = null;

    if (ANONYMOUS_PORT == ssport) {
      ssport = 8000;
    }

    if (null == sslFactory) {
      sslFactory = javax.net.ssl.SSLServerSocketFactory.getDefault();
    }

    javax.net.ssl.SSLServerSocket s = null;

    for (int i = 0; MAX_PORTS != i; i++) {
      try {
        s = (javax.net.ssl.SSLServerSocket) sslFactory.createServerSocket(
          ssport + i);

        s.setEnabledCipherSuites(s.getSupportedCipherSuites());

        exception = null;

        break;
      }
      catch (Exception ex) {
        exception = ex;
      }
    }

    if (null != exception) {
      throw new java.io.IOException(exception.toString());
    }

    return s;
  }

  /**
   * Method equals
   *
   *
   * @param that
   *
   * @return boolean
   *
   */
  public boolean equals(Object that) {
    return (that != null) && (that.getClass() == this.getClass());
  }

}
