package org.okip.service.dbc.impl;

import org.okip.service.dbc.api.DbcException; 
import org.okip.service.dbc.api.Blob; 

public class BlobImpl implements 
	org.okip.service.dbc.api.Blob, java.io.Serializable { 

	private transient java.sql.Blob delegate;

	public BlobImpl( java.sql.Blob delegate ) {
		this.delegate = delegate;
	}

	protected final java.sql.Blob getDelegate() {
		return delegate;
	}

  public byte[] getBytes(long pos, int len) 
	throws DbcException {
		try {
			return delegate.getBytes(pos, len);
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }                 
  }

  public long length()
  throws DbcException {
		try {
			return delegate.length();
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }                 
  }

// Changed!
  public long position(Blob pattern, long start)
  throws DbcException {
		try {
			if (! (pattern instanceof BlobImpl) )
				throw  ConnectionImpl.chainException("Blob passed in is not an instance of BlobImpl!",new IllegalArgumentException("public long position(Blob pattern, long start): pattern is not an instance of BlobImpl!") );
			BlobImpl b = (BlobImpl)pattern;
			java.sql.Blob patternDelegate = b.getDelegate();
			return delegate.position(patternDelegate, start);
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }                 
  }

  public long position(byte[] pattern, long start)
  throws DbcException {
		try {
			return delegate.position(pattern, start);
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }                 
  }

  public int setBytes(long pos, byte[] bytes)
  throws DbcException {
		try {
			return delegate.setBytes(pos, bytes);
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }                 
  }

  public int setBytes(long pos, byte[] bytes, int offset, int len)
  throws DbcException {
		try {
			return delegate.setBytes(pos, bytes, offset, len);
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }                 
  }

  public void truncate(long len)
  throws DbcException {
		try {
			delegate.truncate(len);
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }                 
  }

}
