package org.okip.service.dbc.impl;

import org.okip.service.dbc.api.DbcException; 

import org.okip.service.dbc.api.Clob; 

public class ClobImpl implements org.okip.service.dbc.api.Clob, 
java.io.Serializable { 

  private transient java.sql.Clob delegate;

	public ClobImpl( java.sql.Clob delegate ) {
		this.delegate = delegate;
	}

	protected final java.sql.Clob getDelegate() {
		return delegate;
	}

  public String getSubString(long pos, int length)
  throws DbcException {
		try {
			return delegate.getSubString( pos, length );
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }          
  }

  public long length()
  throws DbcException {
		try {
			return delegate.length();
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }          
  }

  public long position(Clob searchstr, long start)
  throws DbcException {
		try {
			return delegate.position( ((ClobImpl)searchstr).getDelegate(),start);
			//return delegate.position( (ClobImpl)searchstr.getDelegate(),start );
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }          
  }

  public long position(String searchstr, long start)
  throws DbcException {
		try {
			return delegate.position(searchstr, start);
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }          
  }

  public int setString(long pos, String str)
  throws DbcException {
		try {
			return delegate.setString(pos,str);
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }          
  }

  public int setString(long pos, String str, int offset, int len)
  throws DbcException {
		try {
			return delegate.setString(pos,str, offset, len);
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }          
  }

  public void truncate(long len)
  throws DbcException {
		try {
			delegate.truncate(len);
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }          
  }
}
