package org.okip.service.dbc.impl;



import org.okip.service.dbc.api.DbcException;


/**
 * Class ParameterMetaDataImpl
 *
 *
 * @author
 * @version $Revision: 1.2 $, $Date: 2002/05/10 22:45:38 $
 */
public class ParameterMetaDataImpl
implements org.okip.service.dbc.api.ParameterMetaData, java.io.Serializable {

  private transient java.sql.ParameterMetaData delegate;
  private transient org.okip.service.dbc.api.PreparedStatement parent;

	public ParameterMetaDataImpl( java.sql.ParameterMetaData delegate, 
													org.okip.service.dbc.api.PreparedStatement parent ) {
				this.delegate = delegate;
				this.parent = parent;
	}

  /**
   * Method getParameterClassName
   *
   *
   * @param param
   *
   * @return String
   *
   * @throws DbcException
   *
   */
  public String getParameterClassName(int param)
  throws DbcException {
		try {
			return delegate.getParameterClassName(param);
		} catch ( java.sql.SQLException sqle ) {
					throw ConnectionImpl.chainException("", sqle);
		}
	}

  /**
   * Method getParameterCount
   *
   *
   * @return int
   *
   * @throws DbcException
   *
   */
  public int getParameterCount()
  throws DbcException {
		try {
		return delegate.getParameterCount();
		} catch ( java.sql.SQLException sqle ) {
					throw ConnectionImpl.chainException("", sqle);
		}
	}
  /**
   * Method getParameterMode
   *
   *
   * @param param
   *
   * @return int
   *
   * @throws DbcException
   *
   */
  public int getParameterMode(int param)
  throws DbcException {
		try {
		return delegate.getParameterMode(param);
		} catch ( java.sql.SQLException sqle ) {
					throw ConnectionImpl.chainException("", sqle);
		}
	}

  /**
   * Method getParameterType
   *
   *
   * @param param
   *
   * @return int
   *
   * @throws DbcException
   *
   */
  public int getParameterType(int param)
  throws DbcException {
		try {
		return delegate.getParameterType(param);
		} catch ( java.sql.SQLException sqle ) {
					throw ConnectionImpl.chainException("", sqle);
		}
	}

  /**
   * Method getParameterTypeName
   *
   *
   * @param param
   *
   * @return String
   *
   * @throws DbcException
   *
   */
  public String getParameterTypeName(int param)
  throws DbcException {
		try {
			return delegate.getParameterTypeName(param);
		} catch ( java.sql.SQLException sqle ) {
					throw ConnectionImpl.chainException("", sqle);
		}
	}

  /**
   * Method getPrecision
   *
   *
   * @param param
   *
   * @return int
   *
   * @throws DbcException
   *
   */
  public int getPrecision(int param)
  throws DbcException {
		try {
			return delegate.getPrecision(param);
		} catch ( java.sql.SQLException sqle ) {
					throw ConnectionImpl.chainException("", sqle);
		}
	}

  /**
   * Method getScale
   *
   *
   * @param param
   *
   * @return int
   *
   * @throws DbcException
   *
   */
  public int getScale(int param)
  throws DbcException {
		try {
			return delegate.getScale(param);
		} catch ( java.sql.SQLException sqle ) {
					throw ConnectionImpl.chainException("", sqle);
		}
	}

  /**
   * Method isNullable
   *
   *
   * @param param
   *
   * @return int
   *
   * @throws DbcException
   *
   */
  public int isNullable(int param)
  throws DbcException {
		try {
			return delegate.isNullable(param);
		} catch ( java.sql.SQLException sqle ) {
					throw ConnectionImpl.chainException("", sqle);
		}
	}

  /**
   * Method isSigned
   *
   *
   * @param param
   *
   * @return boolean
   *
   * @throws DbcException
   *
   */
  public boolean isSigned(int param)
  throws DbcException {
		try {
			return delegate.isSigned(param);
		} catch ( java.sql.SQLException sqle ) {
					throw ConnectionImpl.chainException("", sqle);
		}
	}

};
