package org.okip.service.dbc.impl;

import org.okip.service.dbc.api.DbcException; 

public class ResultSetImpl implements org.okip.service.dbc.api.ResultSet,
  java.io.Serializable { 
  
  private transient java.sql.ResultSet delegate; 
	private org.okip.service.dbc.api.Statement parent;

	public ResultSetImpl( java.sql.ResultSet delegate, 
												org.okip.service.dbc.api.Statement parent ) {
					this.delegate = delegate;
					this.parent = parent;
	}
 
	public boolean absolute(int row) throws DbcException { 
		 try {
				return delegate.absolute(row); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void afterLast() throws DbcException { 
		 try {
			delegate.afterLast(); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void beforeFirst() throws DbcException { 
		 try {
			delegate.beforeFirst(); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public void cancelRowUpdates() throws DbcException { 
		 try {
			delegate.cancelRowUpdates(); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void clearWarnings() throws DbcException { 
		 try {
			delegate.clearWarnings(); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

 
	public void close() throws DbcException { 
		 try {
			delegate.close(); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public void deleteRow() throws DbcException { 
		 try {
			delegate.deleteRow(); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public int findColumn(String columnName) throws DbcException { 
		 try {
			return delegate.findColumn(columnName); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public boolean first() throws DbcException { 
		 try {
			return delegate.first(); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public org.okip.service.dbc.api.Array getArray(int columnIndex) 
		throws DbcException {
		 try {
				return new ArrayImpl( delegate.getArray(columnIndex) );
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public org.okip.service.dbc.api.Array getArray(String columnName) 
		throws DbcException {
		 try {
				return new ArrayImpl( delegate.getArray(columnName) );
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	 public java.math.BigDecimal getBigDecimal(String columnName) 
		throws DbcException {
		 try {
				return delegate.getBigDecimal(columnName);
     } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
     }
		}

	 public java.math.BigDecimal getBigDecimal(int columnIndex) 
		throws DbcException {
		 try {
				return delegate.getBigDecimal(columnIndex);
		 } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
     }
		}

	 public org.okip.service.dbc.api.Blob getBlob(int columnIndex) 
		throws DbcException {
		 try {
			return new BlobImpl( delegate.getBlob(columnIndex) );
     } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
     }
		}

		public org.okip.service.dbc.api.Blob getBlob(String columnName) 
		throws DbcException {
		 try {
			return  new BlobImpl( delegate.getBlob(columnName) );
     } catch( java.sql.SQLException e ) {
				throw ConnectionImpl.chainException("",e);
		 }
		}

		public boolean getBoolean(int columnIndex) throws DbcException { 
		 try {
			return delegate.getBoolean(columnIndex); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
		}
 
		public boolean getBoolean(String columnName) throws DbcException { 
		 try {
				return delegate.getBoolean(columnName); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
		}

		public byte getByte(int columnIndex) throws DbcException { 
		 try {
			return delegate.getByte(columnIndex); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
		}

		public byte getByte(String columnName) throws DbcException { 
		 try {
				return delegate.getByte(columnName); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
		}
 
	 public byte[] getBytes(int columnIndex) 
		throws DbcException {
		 try {
			return delegate.getBytes(columnIndex); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
		}

	 public byte[] getBytes(String columnName) 
		throws DbcException {
		 try {
			return delegate.getBytes(columnName); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
		}

	 public org.okip.service.dbc.api.Clob getClob(int columnIndex) 
  throws DbcException {
		 try {
			return new ClobImpl( delegate.getClob(columnIndex) ); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	 }

	 public org.okip.service.dbc.api.Clob getClob(String columnName) 
	 throws DbcException {
		 try {
			return new ClobImpl( delegate.getClob(columnName) ); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
		}
 
	public int getConcurrency() throws DbcException { 
		 try {
				return delegate.getConcurrency(); 
     } catch( java.sql.SQLException e ) {
				 throw ConnectionImpl.chainException("",e);
     }
	}

	public String getCursorName() throws DbcException { 
		 try {
					return delegate.getCursorName(); 
     } catch( java.sql.SQLException e ) {
				 throw ConnectionImpl.chainException("",e);
     }
	}

	public java.sql.Date getDate(int columnIndex) throws DbcException {
		 try {
			return delegate.getDate(columnIndex); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public java.sql.Date getDate(int columnIndex, java.util.Calendar calendar) 
		throws DbcException {
		 try {
			return delegate.getDate(columnIndex, calendar); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

 public java.sql.Date getDate(String columnName) throws DbcException {
		 try {
			return delegate.getDate(columnName); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

 public java.sql.Date getDate(String columnName, java.util.Calendar calendar) 
  throws DbcException {
		 try {
			return delegate.getDate(columnName, calendar); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
 }
 
	public double getDouble(int columnIndex) throws DbcException { 
		 try {
			return delegate.getDouble(columnIndex); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public double getDouble(String columnName) throws DbcException { 
		 try {
			return delegate.getDouble( columnName); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public int getFetchDirection() throws DbcException { 
		 try {
				return delegate.getFetchDirection(); 
     } catch( java.sql.SQLException e ) {
				throw ConnectionImpl.chainException("",e);
     }
	}
 
	public int getFetchSize() throws DbcException { 
		 try {
			return delegate.getFetchSize(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public float getFloat(int columnIndex) throws DbcException { 
		 try {
			return delegate.getFloat(columnIndex); 
     } catch( java.sql.SQLException e ) {
			 throw ConnectionImpl.chainException("",e);
     }
	}
 
	public float getFloat(String columnName) throws DbcException { 
		 try {
				return delegate.getFloat(columnName); 
     } catch( java.sql.SQLException e ) {
				 throw ConnectionImpl.chainException("",e);
     }
	}
 
	public int getInt(int columnIndex) throws DbcException { 
		 try {
				return delegate.getInt(columnIndex); 
     } catch( java.sql.SQLException e ) {
				throw ConnectionImpl.chainException("",e);
     }
	}
 
	public int getInt(String columnName) throws DbcException { 
		 try {
				return delegate.getInt(columnName); 
     } catch( java.sql.SQLException e ) {
				throw ConnectionImpl.chainException("",e);
     }
	}
 
	public long getLong(int columnIndex) throws DbcException { 
		 try {
				return delegate.getLong(columnIndex); 
     } catch( java.sql.SQLException e ) {
				 throw ConnectionImpl.chainException("",e);
     }
	}
 
	public long getLong(String columnName) throws DbcException { 
		 try {
			return delegate.getLong(columnName); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public java.sql.ResultSetMetaData getMetaData() throws DbcException {
		 try {
			return delegate.getMetaData();
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public Object getObject(int columnIndex) throws DbcException { 
		 try {
			return delegate.getObject(columnIndex); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public Object getObject(int columnIndex, java.util.Map map) throws DbcException { 
		 try {
			return delegate.getObject(columnIndex, map); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public Object getObject(String columnName) throws DbcException { 
		 try {
			return delegate.getObject(columnName); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public Object getObject(String colName, java.util.Map map) 
	throws DbcException { 
		 try {
			return delegate.getObject(colName,map); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

 public java.sql.Ref getRef(int columnIndex) 
  throws DbcException {
		 try {
			return delegate.getRef(columnIndex);
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

 public java.sql.Ref getRef(String colName) 
  throws DbcException {
		 try {
			return delegate.getRef(colName);
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

 
	public int getRow() throws DbcException { 
		 try {
			return delegate.getRow(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public short getShort(int columnIndex) throws DbcException { 
		 try {
			return delegate.getShort(columnIndex); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public short getShort(String columnName) throws DbcException { 
		 try {
			return delegate.getShort(columnName); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public org.okip.service.dbc.api.Statement getStatement() 
  throws DbcException {
			//return delegate.getStatement();
			return parent;
	}
 
	public String getString(int columnIndex) throws DbcException { 
		 try {
			return delegate.getString(columnIndex); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public String getString(String columnName) throws DbcException { 
		 try {
			return delegate.getString(columnName); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public java.sql.Time getTime(int columnIndex) throws DbcException {
		 try {
			return delegate.getTime(columnIndex); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public java.sql.Time getTime(int columnIndex, java.util.Calendar calendar) 
	throws DbcException {
		 try {
			return delegate.getTime(columnIndex, calendar); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

 public java.sql.Time getTime(String columnName) throws DbcException {
		 try {
			return delegate.getTime(columnName); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
 }

	public java.sql.Time getTime(String columnName, java.util.Calendar calendar) 
	throws DbcException {
		 try {
			return delegate.getTime(columnName, calendar); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public java.sql.Timestamp getTimestamp(int columnIndex) 
  throws DbcException {
		 try {
			return delegate.getTimestamp(columnIndex);
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public java.sql.Timestamp getTimestamp(int columnIndex,
				java.util.Calendar calendar) throws DbcException {
		 try {
			return delegate.getTimestamp(columnIndex, calendar);
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public java.sql.Timestamp getTimestamp(String columnName) throws DbcException 
	{
		 try {
			return delegate.getTimestamp(columnName);
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

 public java.sql.Timestamp getTimestamp(String columnName, java.util.Calendar calendar) 
  throws DbcException {
		 try {
			return delegate.getTimestamp(columnName, calendar);
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public int getType() throws DbcException { 
		 try {
			return delegate.getType(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public java.net.URL getURL(int columnIndex) throws DbcException {
		 try {
			return delegate.getURL(columnIndex); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public java.net.URL getURL(String columnName) throws DbcException {
		 try {
			return delegate.getURL(columnName); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public java.sql.SQLWarning getWarnings() throws DbcException {
		 try {
			return delegate.getWarnings(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public void insertRow() throws DbcException { 
		 try {
			delegate.insertRow(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public boolean isAfterLast() throws DbcException { 
		 try {
			return delegate.isAfterLast(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public boolean isBeforeFirst() throws DbcException { 
		 try {
			return delegate.isBeforeFirst(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public boolean isFirst() throws DbcException { 
		 try {
			return delegate.isFirst(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public boolean isLast() throws DbcException { 
		 try {
			return delegate.isLast(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public boolean last() throws DbcException { 
		 try {
			return delegate.last(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public void moveToCurrentRow() throws DbcException { 
		 try {
			delegate.moveToCurrentRow(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public void moveToInsertRow() throws DbcException { 
		 try {
			delegate.moveToInsertRow(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public boolean next() throws DbcException { 
		 try {
			return delegate.next(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public boolean previous() throws DbcException { 
		 try {
			return delegate.previous(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public void refreshRow() throws DbcException { 
		 try {
			delegate.refreshRow(); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public boolean relative(int rows) throws DbcException { 
		 try {
			return delegate.relative(rows); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public boolean rowDeleted() throws DbcException { 
		 try {
			return delegate.rowDeleted(); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public boolean rowInserted() throws DbcException { 
		 try {
			return delegate.rowInserted(); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public boolean rowUpdated() throws DbcException { 
		 try {
			return delegate.rowUpdated(); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void setFetchDirection(int direction) throws DbcException { 
		 try {
			delegate.setFetchDirection(direction); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void setFetchSize(int rows) throws DbcException { 
		 try {
			delegate.setFetchSize(rows); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateArray(int columnIndex, org.okip.service.dbc.api.Array x) 
	throws DbcException { 
		 try {
			delegate.updateArray(columnIndex, ((ArrayImpl)x).getDelegate()); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public void updateArray(String columnName, org.okip.service.dbc.api.Array x) 
	throws DbcException { 
		 try {
			delegate.updateArray(columnName, ((ArrayImpl)x).getDelegate()); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateBigDecimal(int columnIndex, java.math.BigDecimal x) throws DbcException { 
		 try {
			delegate.updateBigDecimal(columnIndex, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateBigDecimal(String columnName, java.math.BigDecimal x) throws DbcException { 
		 try {
			delegate.updateBigDecimal(columnName, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateBlob(int columnIndex, org.okip.service.dbc.api.Blob x) throws DbcException { 
		 try {
			delegate.updateBlob(columnIndex, ((BlobImpl)x).getDelegate()); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public void updateBlob(String columnName, org.okip.service.dbc.api.Blob x) 
	throws DbcException { 
		 try {
			delegate.updateBlob(columnName, ((BlobImpl)x).getDelegate()); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateBoolean(int columnIndex, boolean x) throws DbcException { 
		 try {
			delegate.updateBoolean(columnIndex, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateBoolean(String columnName, boolean x) throws DbcException { 
		 try {
			delegate.updateBoolean(columnName, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateByte(int columnIndex, byte x) throws DbcException { 
		 try {
			delegate.updateByte(columnIndex, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public void updateByte(String columnName, byte x) throws DbcException { 
		 try {
			delegate.updateByte(columnName, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateBytes(int columnIndex, byte[] x) throws DbcException { 
		 try {
			delegate.updateBytes(columnIndex, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public void updateBytes(String columnName, byte[] x) throws DbcException { 
		 try {
			delegate.updateBytes(columnName, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateClob(int columnIndex, org.okip.service.dbc.api.Clob x) 
	throws DbcException { 
		 try {
				delegate.updateClob(columnIndex, ((ClobImpl)x).getDelegate()); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public void updateClob(String columnName, org.okip.service.dbc.api.Clob x) 
	throws DbcException { 
		 try {
			delegate.updateClob(columnName, ((ClobImpl)x).getDelegate()); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateDate(int columnIndex, java.sql.Date x) throws DbcException 
	{ 
		 try {
			delegate.updateDate(columnIndex, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public void updateDate(String columnName, java.sql.Date x) 
	throws DbcException {
		 try {
			 delegate.updateDate(columnName, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public void updateDouble(int columnIndex, double x) throws DbcException { 
		 try {
			delegate.updateDouble(columnIndex, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateDouble(String columnName, double x) throws DbcException { 
		 try {
			delegate.updateDouble(columnName, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateFloat(int columnIndex, float x) throws DbcException { 
		 try {
			delegate.updateFloat(columnIndex, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public void updateFloat(String columnName, float x) throws DbcException { 
		 try {
			delegate.updateFloat(columnName, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateInt(int columnIndex, int x) throws DbcException { 
		 try {
			delegate.updateInt(columnIndex, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public void updateInt(String columnName, int x) throws DbcException { 
		 try {
			delegate.updateInt(columnName, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateLong(int columnIndex, long x) throws DbcException { 
		 try {
			delegate.updateLong(columnIndex, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateLong(String columnName, long x) throws DbcException { 
		 try {
			delegate.updateLong(columnName, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateNull(int columnIndex) throws DbcException { 
		 try {
			delegate.updateNull(columnIndex); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public void updateNull(String columnName) throws DbcException { 
		 try {
			delegate.updateNull(columnName); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateObject(int columnIndex, Object x) throws DbcException { 
		 try {
			delegate.updateObject(columnIndex, x); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}
 
	public void updateObject(int columnIndex, Object x, int scale) throws DbcException { 
		 try {
			delegate.updateObject(columnIndex, x, scale); 
    } catch( java.sql.SQLException e ) {
      throw ConnectionImpl.chainException("",e);
    }
	}

	public void updateObject(String columnName, Object x) throws DbcException { 
		 try {
			delegate.updateObject(columnName, x); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public void updateObject(String columnName, Object x, int scale) 
	throws DbcException { 
		 try {
			delegate.updateObject(columnName, x, scale); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public void updateRef(int columnIndex, java.sql.Ref x) throws DbcException { 
		 try {
			delegate.updateRef(columnIndex, x); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public void updateRef(String columnName, java.sql.Ref x) 
	throws DbcException { 
		 try {
			delegate.updateRef(columnName, x); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public void updateRow() throws DbcException { 
		 try {
			delegate.updateRow(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public void updateShort(int columnIndex, short x) throws DbcException { 
		 try {
			delegate.updateShort(columnIndex, x); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public void updateShort(String columnName, short x) throws DbcException { 
		 try {
			delegate.updateShort(columnName, x); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public void updateString(int columnIndex, String x) throws DbcException { 
		 try {
			delegate.updateString(columnIndex, x); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public void updateString(String columnName, String x) throws DbcException { 
		 try {
			delegate.updateString(columnName, x); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public void updateTime(int columnIndex, java.sql.Time x) 
	throws DbcException { 
		 try {
			delegate.updateTime(columnIndex, x); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public void updateTime(String columnName, java.sql.Time x) 
	throws DbcException { 
		 try {
			delegate.updateTime(columnName, x); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public void updateTimestamp(int columnIndex, java.sql.Timestamp x) 
	throws DbcException { 
		 try {
			delegate.updateTimestamp(columnIndex, x); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

	public void updateTimestamp(String columnName, java.sql.Timestamp x) 
	throws DbcException { 
		 try {
			delegate.updateTimestamp(columnName, x); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}
 
	public boolean wasNull() throws DbcException { 
		 try {
			return delegate.wasNull(); 
     } catch( java.sql.SQLException e ) {
       throw ConnectionImpl.chainException("",e);
     }
	}

}
