package org.okip.service.filing.test;

import org.okip.service.filing.api.*;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;


/**
   Copyright (c) 2002 Massachusetts Institute of Technology

   This work, including software, documents, or other related items (the
   "Software"), is being provided by the copyright holder(s) subject to
   the terms of the MIT OKI&#153; API Implementation License. By
   obtaining, using and/or copying this Software, you agree that you have
   read, understand, and will comply with the following terms and
   conditions of the MIT OKI&#153; API Implementation License:

   Permission to use, copy, modify, and distribute this Software and its
   documentation, with or without modification, for any purpose and
   without fee or royalty is hereby granted, provided that you include
   the following on ALL copies of the Software or portions thereof,
   including modifications or derivatives, that you make:

    *  The full text of the MIT OKI&#153; API Implementation License in a
       location viewable to users of the redistributed or derivative
       work.

    *  Any pre-existing intellectual property disclaimers, notices, or
       terms and conditions. If none exist, a short notice similar to the
       following should be used within the body of any redistributed or
       derivative Software:
       "Copyright (c) 2002 Massachusetts Institute of Technology
       All Rights Reserved."

    *  Notice of any changes or modifications to the MIT OKI&#153;
       Software, including the date the changes were made. Any modified
       software must be distributed in such as manner as to avoid any
       confusion with the original MIT OKI&#153; Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

   The name and trademarks of copyright holder(s) and/or MIT may NOT be
   used in advertising or publicity pertaining to the Software without
   specific, written prior permission. Title to copyright in the Software
   and any associated documentation will at all times remain with the
   copyright holders.

   The export of software employing encryption technology may require a
   specific license from the United States Government. It is the
   responsibility of any person or organization contemplating export to
   obtain such a license before exporting this Software.
*/

/*
 * $Source: /cvs/oki/tech/src/org/okip/service/filing/test/FilingApiFactoryTest.java,v $
 */

/**
 * Test Factory using JUnit.
 *
 * <p>
 * Licensed under the {@link org.okip.service.ApiImplementationLicenseMIT MIT OKI&#153; API Implementation License}.
 *
 * @version $Name:  $ / $Revision: 1.3 $ / $Date: 2002/05/10 23:59:17 $
 */
public class FilingApiFactoryTest
extends TestCase {

  /**
   * Constructor FilingApiFactoryTest
   *
   *
   * @param name
   *
   */
  public FilingApiFactoryTest(String name) {
    super(name);
  }

  /*
  public static Test suite() {
      TestSuite suite= new TestSuite();
      suite.addTest(new FilingApiFactoryTest("testGetFileFactory"));
      suite.addTest(new FilingApiFactoryTest("testGetCabinetFactoriesList"));
      suite.addTest(new FilingApiFactoryTest("testGetAvailableProperties"));
      suite.addTest(new FilingApiFactoryTest("testGetCabinetFactory"));
      suite.addTest(new FilingApiFactoryTest("testListRoots"));
      suite.addTest(new FilingApiFactoryTest("testGetAvailableCabinetFactories"));
      return suite;
  }
  */

  static org.okip.service.filing.api.Factory fileFactory = null;

  /**
   * Method testGetFileFactory
   *
   *
   */
  public void testGetFileFactory() {
    try {
      fileFactory =
        (org.okip.service.filing.api.Factory) org.okip.service.shared.api.FactoryManager.getDefaultFactory(
          "org.okip.service.filing.api", null);
    }
    catch (Exception e) {}
    ;

    assertNotNull(fileFactory);
  }

  /**
   * Method testGetCabinetFactoriesList
   *
   *
   */
  public void testGetCabinetFactoriesList() {
    java.util.List l = null;

    try {
      l = fileFactory.getAvailableCabinetFactories(null);
    }
    catch (Exception e) {}
    ;

    assertNotNull(l);
  }

  /**
   * Method testGetAvailableProperties
   *
   *
   */
  public void testGetAvailableProperties() {
    java.util.List l = null;

    try {
      l = fileFactory.getAvailableProperties();

    }
    catch (Exception e) {}
    ;

    assertNotNull(l);
  }

  static org.okip.service.filing.api.CabinetFactory myCabinetFactory = null;

  /**
   * Method testGetCabinetFactory
   *
   *
   */
  public void testGetCabinetFactory() {
    java.util.List                             l                  = null;
    org.okip.service.filing.api.CabinetFactory cabinetFactories[] = null;

    try {
      l = fileFactory.getAvailableProperties();

      // Get all CabinetFactories with the desired properties
      // want something with readwrite

      java.util.Map desiredProperties = new java.util.Hashtable();

      desiredProperties.put(l.get(0), new Boolean(true));

      cabinetFactories = fileFactory.getCabinetFactory(desiredProperties);

    }
    catch (Exception e) {}
    ;

    assertNotNull(cabinetFactories);
    assertTrue(cabinetFactories.length > 0);

    if (cabinetFactories.length > 0) {
      myCabinetFactory = cabinetFactories[0];
    }

    assertNotNull(myCabinetFactory);
  }

  /**
   * Method testListRoots
   *
   *
   */
  public void testListRoots() {
    org.okip.service.filing.api.Cabinet[] l = null;

    try {
      l = myCabinetFactory.listRoots();
    }
    catch (Exception e) {}
    ;

    assertNotNull(l);
  }

  static org.okip.service.filing.api.CabinetFactory anotherCabinetFactory =
    null;

  /**
   * Method testGetAvailableCabinetFactories
   *
   *
   */
  public void testGetAvailableCabinetFactories() {
    java.util.List                        l           = null;
    org.okip.service.filing.api.Cabinet[] roots       = null;
    org.okip.service.shared.api.Type      cabinetType = null;

    try {
      l = fileFactory.getAvailableCabinetFactories(null);

      if (l != null) {
        cabinetType           = (org.okip.service.shared.api.Type) l.get(0);
        anotherCabinetFactory =
          fileFactory.getCabinetFactoryByType(cabinetType);
        roots                 = anotherCabinetFactory.listRoots();
      }
    }
    catch (Exception e) {}
    ;

    assertNotNull(l);

    assertNotNull(cabinetType);
    assertNotNull(anotherCabinetFactory);
    assertNotNull(roots);
  }

  /**
   * Method testListRoots2
   *
   *
   */
  public void testListRoots2() {
    org.okip.service.filing.api.Cabinet[] l = null;

    try {
      l = anotherCabinetFactory.listRoots();
    }
    catch (Exception e) {}
    ;

    assertNotNull(l);
  }

  /**
   * Method testExistingCabinet
   *
   *
   */
  public void testExistingCabinet() {
    org.okip.service.filing.api.Cabinet        c     = null;
    java.util.Iterator                         iter  = null;
    org.okip.service.filing.api.CabinetEntry   ce    = null;
    org.okip.service.filing.api.OkiInputStream is    = null;

    byte[]                                     b     = new byte[100];

    int                                        nRead = 0;

    try {
      c    = anotherCabinetFactory.getCabinet(
        anotherCabinetFactory.idFromString("/tmp/"));

      iter = c.entries();

      while (iter.hasNext()) {
        ce = (org.okip.service.filing.api.CabinetEntry) iter.next();

        assertNotNull(ce);

        if (ce.isByteStore()) {
          assertNotNull(
            ((org.okip.service.filing.api.ByteStore) ce).getMimeType());

          is    =
            ((org.okip.service.filing.api.ByteStore) ce).getOkiInputStream();

          nRead = is.read(b);

          assertNotNull(is);
          assertTrue(nRead >= 0);
        }
      }
    }
    catch (Exception e) {}
    ;

    assertNotNull(c);
    assertNotNull(iter);
  }
}
