CREATE OR REPLACE PACKAGE BODY localidentifier
AS

FUNCTION EXISTS( p_localid VARCHAR2 ) RETURN INTEGER
IS
    v_flag INTEGER := 0;
    v_numRows INTEGER := 0;
BEGIN
	SELECT 1 INTO v_flag FROM id WHERE LOCALID = p_localid; 
	v_numRows := SQL % ROWCOUNT;
	if  v_numRows > 1  then
			RAISE_APPLICATION_ERROR( -20000,
				'Inconsistency in id table: expected 1 row, found ' || v_numRows || '.');
			v_flag := -1;
                        RETURN v_flag;
	end if;
        RETURN v_flag;
EXCEPTION
	WHEN NO_DATA_FOUND THEN RETURN v_flag;
        WHEN OTHERS THEN RETURN v_flag;
END EXISTS;

FUNCTION ADD( p_localid VARCHAR2 ) RETURN INTEGER
IS
BEGIN
	INSERT INTO ID VALUES ( p_localid, NULL );
	commit;
	RETURN 1;
EXCEPTION
	WHEN OTHERS THEN
	BEGIN
		RAISE_APPLICATION_ERROR( -20001, 
			 'Exception inserting localid. SQL Error # = ' || SQLCODE 
															 || '. Error: ' || SQLERRM );
		rollback;
		RETURN 0;
	END;
 RETURN 0;
END ADD;

FUNCTION ADD( p_localid VARCHAR2, p_associated VARCHAR2) RETURN INTEGER
IS
BEGIN
	INSERT INTO ID ( localid, associated ) VALUES ( p_localid, p_associated );
	commit;
	RETURN 1;
EXCEPTION
	WHEN OTHERS THEN
	BEGIN
		 RAISE_APPLICATION_ERROR( -20001, 
		 'Exception inserting localid. SQL Error # = ' || SQLCODE 
																 || '. Error: ' || SQLERRM );
			rollback;
			RETURN 0;
	END;
        RETURN 0;
END ADD;

FUNCTION GET_ASSOCIATED_DATA( p_localid VARCHAR2 ) RETURN VARCHAR2
IS
v_associated VARCHAR2(255);
BEGIN
	SELECT associated INTO v_associated FROM ID WHERE localid = p_localid;
EXCEPTION
	WHEN OTHERS THEN
	BEGIN
		 RAISE_APPLICATION_ERROR( -20001, 
				 'Exception inserting localid. SQL Error # = ' || SQLCODE 
																 || '. Error: ' || SQLERRM );
	END;
return v_associated;
END GET_ASSOCIATED_DATA;

END localidentifier;
/
SHOW ERRORS
