/*
 * LocalIdTest.java
 *
 * Created on May 21, 2002, 1:20 PM
 * @author giris
 */

package org.okip.service.localid.test;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import junit.framework.Assert;

public class LocalIdTest extends TestCase {
    
    private static org.okip.service.localid.api.Factory localIdFactory;
    
    public LocalIdTest(java.lang.String testName) {
        super(testName);
    }
    
    public static void main(java.lang.String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    
    public static Test suite() {
        TestSuite suite = new TestSuite(LocalIdTest.class);
        return suite;
    }
    
    public void testLocalIdGetFactory() {
                boolean gotException = false;
                
                try {
                    this.localIdFactory = (org.okip.service.localid.api.Factory) 
                        org.okip.service.shared.api.FactoryManager.getDefaultFactory( "org.okip.service.localid.api", null);
                assertNotNull( localIdFactory );
                } catch (Exception ex) {
                    ex.printStackTrace();
                    gotException = true;
                }
                Assert.assertTrue("Exception getting local id factory", gotException == false);
     }

        public void testProperties() {
            java.util.Properties props = System.getProperties();

            java.util.Enumeration e = props.propertyNames();

            for ( ; e.hasMoreElements(); ) {
                String name = (String)e.nextElement();
                if ( name.startsWith("org.okip") ) {
                    String value = System.getProperty(name);
                    System.out.println( name + "==" + value );
                }
            }
            System.out.flush();
        }

        public void testgetLocalId() {
                boolean gotException = false;
                org.okip.service.localid.api.LocalId localId = null;
                for (int i = 0; i < 10000; ++i ) {
                    try {
                            localId = localIdFactory.getLocalId();
                            assertNotNull( localId );
                    } catch (Exception ex) {
                        ex.printStackTrace();
                        gotException = true;
                    }
                    Assert.assertTrue("Exception getting local id", gotException == false);
                    System.out.println("Got localid of " + localId);
                }
     }
    
};
