/** The following are all Design Time aspects */

package org.okip.service.workflow.api;

import org.okip.service.shared.api.*;
import org.okip.service.locallyuniqueidentifier.api.*;

public interface  Step
extends java.io.Serializable
{ 
    /* Design Time */

    /* does it have properties to  determine "can go back" ?? */
    public  LocallyUniqueIdentifier getIdentifier();
    public String getName();
    public String getDescription();

    public void setName(String name);
    public void setDescription(String description);

    public Step[] getParents();
    public Step[] getChildren();

    public OutputState[] getOutputStates();
    public void addOutputState(OutputState outputState);
		public void removeOutputState(OutputState outputState);

		public WorkflowDefinition getWorkflowDefinition();

    public void  addChild(Step step);
    public void removeChild(Step step);

    public Expression getRootExpression();
    public void setRootExpression(Expression expression);

    public Role getRole();
    public void setRole(Role role);

          /** For branching */
    public void linkExternalWorkflow(WorkflowDefinition workflowDefinition);
}
