package org.okip.service.workflow.api;

import org.okip.service.shared.api.*;
import org.okip.service.locallyuniqueidentifier.api.*;

public interface WorkflowService
extends java.io.Serializable
{

/** Notes: The Workflow Service serves as a factory, abstracting the 
creational aspects of the API. Note that created objects may be cached, so
a new instance may be obtained or a stored / predefined object reused.

An Agent parameter is currently shown in all methods, but this only ever 
needs to be set once.
*/


      /* Runtime aspects */

		public Workflow createWorkflow(  Agent agent, 
																		 WorkflowDefinition definition,
																		 Qualifier qualifier );

		public Workflow createWorkflow( Agent agent, 
																		WorkflowDefinition definition, 
																		Qualifier qualifier, Batch batch);

		public Batch createBatch( Agent agent );

		public void endBatch( Batch  batch );
     

    /* Design Time aspects * /

    public WorkflowDefinition createWork flowDefinition(Agent agent, String name );

    public WorkflowDefinition createWorkflowDefinition( 
									ModelWorkflow modelWorkflow, String name);

    public WorkflowDefinition [] listWorkflowDefinitions();

    /** Check in/out Models and WorkflowDefinitions. Enforces 
				mutual exclusion.  
    */ 

    public ModelWorkflow checkoutModel();
		public WorkflowDefinition checkoutWorkflowDefinition();
		public void checkin (ModelWorkflow modelWorkflow);
    public void checkin(WorkflowDefinition definition);

    /* Administrative aspects */
}
