package org.okip.util.romi.client.api;

public interface Client {

  /**
   *  This method gets the Host that this Client uses.
   */
  String getHost();

  /**
   *  This method gets the Port that this Client uses.
   */
  int getPort();

  /**
   *  This method gets the Factory that created the Client.
   */
  Factory getFactory();

  /**
   * Method invoke
   *
   *  Given an object, a methodname, an array of method argument types,
   *  and an array of arguments, this method will invoke the method.
   *
   *
   * @param object
   * @param methodName
   * @param argTypes
   * @param args
   *
   * @return the result of a successful invocation
   */
  Object invoke(java.io.Serializable object, String methodName,
                Class[] argTypes, Object[] args)
  throws org.okip.util.romi.client.api.ClientException;
  //throws java.rmi.RemoteException;

  /**
   *  The test method sends a test object to the Server which returns
   *  a string that indicates that the test was successful or throws
   *  an exception.
   *
   *  @return the result of a successful test
   */
  String test()
  throws org.okip.util.romi.client.api.ClientException;
}
